<?php

/**
 * concargo actions.
 *
 * @package    Concursos Ordinarios
 * @subpackage concargo
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 2288 2006-10-02 15:22:13Z fabien $
 */
class concargoActions extends autoconcargoActions
{
  public function executeList()
  {

    if($this->getRequestParameter('concurso_id'))
      $this->getUser()->setAttribute('concurso_id', $this->getRequestParameter('concurso_id')); 
      
    $concurso = ConcursoPeer::retrieveByPk($this->getUser()->getAttribute('concurso_id'));  
    
    $this->processSort();
    $this->processFilters();


    // pager
    $this->pager = new sfPropelPager('ConcursoCargo', 20);
    
    if(isset($concurso))
      $this->pager->nomconcurso = $concurso->__toString();
    
    $c = new Criteria();
    if(isset($concurso))
      $c->add(ConcursoCargoPeer::CON_CONCURSOS_ID, $this->getUser()->getAttribute('concurso_id') );
    $this->addSortCriteria($c);
    $this->addFiltersCriteria($c);
    $this->pager->setCriteria($c);
    $this->pager->setPage($this->getRequestParameter('page', $this->getUser()->getAttribute('page', 1, 'sf_admin/concurso_cargo')));
    $this->pager->init();
    // save page
    if ($this->getRequestParameter('page')) {
        $this->getUser()->setAttribute('page', $this->getRequestParameter('page'), 'sf_admin/concurso_cargo');
    }
  }
  
  public function executeDelete()
  {
    $this->concurso_cargo = ConcursoCargoPeer::retrieveByPk($this->getRequestParameter('id'));
    $id_concurso_volver = $this->concurso_cargo->getConConcursosId();
    $this->forward404Unless($this->concurso_cargo);

    try
    {
      $this->deleteConcursoCargo($this->concurso_cargo);
    }
    catch (PropelException $e)
    {
      $this->getRequest()->setError('delete', 'Could not delete the selected Concurso cargo. Make sure it does not have any associated items.');
      return $this->forward('concargo', 'list');
    }

    $this->setFlash('notice', 'Your modifications have been saved');
    return $this->redirect('concurso/edit?id='.$id_concurso_volver);
  }
  
  public function executeEdit()
  {
    $this->concurso_cargo = $this->getConcursoCargoOrCreate();

    if ($this->getRequest()->getMethod() == sfRequest::POST)
    {
      $this->updateConcursoCargoFromRequest();

      $this->saveConcursoCargo($this->concurso_cargo);

      $this->setFlash('notice', 'Your modifications have been saved');

      if ($this->getRequestParameter('save_and_add'))
      {
        return $this->redirect('concargo/create?concurso_id='.$this->concurso_cargo->getConConcursosId());
      }
      else if ($this->getRequestParameter('save'))
      {
        return $this->redirect('concurso/edit?id='.$this->concurso_cargo->getConConcursosId());
      }
      else
      {
        return $this->redirect('concargo/edit?id='.$this->concurso_cargo->getId());
      }
    }
    else
    {
      $this->labels = $this->getLabels();
      
      if($this->getRequestParameter('concurso_id')){
        $this->concurso_cargo->setConConcursosId($this->getRequestParameter('concurso_id'));
        $this->getUser()->setAttribute('concurso_id', $this->getRequestParameter('concurso_id')); 
      }else{
        $this->concurso_cargo->setConConcursosId($this->getUser()->getAttribute('concurso_id'));
      }
      
      if($this->getRequestParameter('aspirante_id'))
        $this->concurso_cargo->setConAspirantesId($this->getRequestParameter('aspirante_id'));
    }
  }  
}
