<?php
        //require_once(dirname(__FILE__).'/../lib/BasesfGuardUserActions.class.php');
        // Loading the base action to be overridden 
require_once(sfConfig::get('sf_plugins_dir').'/sfGuardPlugin/modules/sfGuardUser/lib/BasesfGuardUserActions.class.php');

/**
 * User management.
 *
 * @package    symfony
 * @subpackage plugin
 * @author     Fabien Potencier <fabien.potencier@symfony-project.com>
 * @version    SVN: $Id: actions.class.php 3422 2007-02-07 11:57:05Z fabien $
 */

class sfGuardUserActions extends BasesfGuardUserActions
{
  protected function updatesfGuardUserFromRequest()
  {
    // updating user 
    parent::updatesfGuardUserFromRequest();

    // appending user profile data
    $firstname = $this->getRequestParameter('sf_guard_user_firstname');
    $this->sf_guard_user->getProfile()->setFirstname($firstname);

    $lastname = $this->getRequestParameter('sf_guard_user_lastname');
    $this->sf_guard_user->getProfile()->setLastname($lastname);  
     
    if ($this->getRequestParameter('sf_guard_user_fechanac'))
          {
            try
            {
              $dateFormat = new sfDateFormat($this->getUser()->getCulture());
              if (!is_array($this->getRequestParameter('sf_guard_user_fechanac')))
              {
                $value = $dateFormat->format($this->getRequestParameter('sf_guard_user_fechanac'), 'i', $dateFormat->getInputPattern('d'));
              }
              else
              {
                $value_array =$this->getRequestParameter('sf_guard_user_fechanac');
                $value = $value_array['year'].'-'.$value_array['month'].'-'.$value_array['day'].(isset($value_array['hour']) ? ' '.$value_array['hour'].':'.$value_array['minute'].(isset($value_array['second']) ? ':'.$value_array['second'] : '') : '');
              }
              $this->sf_guard_user->getProfile()->setFechanac($value);  
            }
            catch (sfException $e)
            {
              // not a date
            }
          }
          else
          {
            $this->sf_guard_user->getProfile()->setFechanac();  
          }


    //$fechanac = $this->getRequestParameter('sf_guard_user_fechanac');
    //$this->sf_guard_user->getProfile()->setFechanac($fechanac);  
    
    $email = $this->getRequestParameter('sf_guard_user_email');
    $this->sf_guard_user->getProfile()->setEmail($email);  

  }
  
  public function executeActivar()
  {
     
     $usuario = sfGuardUserPeer::retrieveByPk($this->getRequestParameter('usuarioid')); 
     if ($usuario->getIsActive()){
            $usuario->setIsActive(false);
      } else $usuario->setIsActive(true);  
        $usuario->save();
     $this->usuario=$usuario;
  }

  protected function savesfGuardUser($sf_guard_user)
  {

  // saving user data into db
  parent::savesfGuardUser($sf_guard_user); 

  // getting "foreign key" field name  
  $fieldName = sfConfig::get('app_sf_guard_plugin_profile_field_name', 'user_id');

  // getting profile class
  $profileClass = sfConfig::get('app_sf_guard_plugin_profile_class', 'sfGuardUserProfile');
  $profilePeerClass =  $profileClass.'Peer';

  // building "setUserId" method from class and field retrieved above
  $method = 'set'.call_user_func_array(array($profilePeerClass, 'translateFieldName'), array($fieldName, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_PHPNAME));


  // recovering user profile
  $sf_guard_user_profile = $sf_guard_user->getProfile();

  // setting "foreign key". This operation must be done here. This is the only place where we can
  // be sure that the sfGuardUserId is set (since the user is saved/updated in the parent::savesfGuardUser).
  // A hidden field in the form wouldn't be effective when creating a new user, since its id is unknown.
  $sf_guard_user_profile->$method($sf_guard_user->getId());

  // saving user 
  $sf_guard_user_profile->save();

  }

}
