<?php

/**
 * Subclass for performing query and update operations on the 'con_concursos' table.
 *
 * 
 *
 * @package lib.model
 */ 
class ConcursoPeer extends BaseConcursoPeer
{
        static public function getConcMatCargosCount($c){
          $c->addSelectColumn(ConcursoPeer::COUNT);

          $c->addJoin(ConcursoPeer::ID, ConcursoCarreraPeer::CON_CONCURSOS_ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoCarreraPeer::CON_CARRERAS_ID, CarreraPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoCarreraPeer::CON_MATERIAS_ID, MateriaPeer::ID, Criteria::LEFT_JOIN);
          
          $c->addJoin(ConcursoPeer::ID, ConcursoCargoPeer::CON_CONCURSOS_ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoCargoPeer::CON_CARGOS_ID, CargoPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoCargoPeer::CON_DEDICACIONES_ID, DedicacionPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoCargoPeer::CON_ASPIRANTES_ID, AspirantePeer::ID);
          
          $c->addJoin(ConcursoPeer::CON_FACULTADES_ID, FacultadPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoPeer::CON_SEDES_ID, SedePeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoPeer::CON_ESTADO_ID, EstadoPeer::ID, Criteria::LEFT_JOIN);
          
          $rs = ConcursoPeer::doSelectRS($c);
          
          if($rs->next()){
            return $rs->getInt(1);
          }else{
            return 0;
          }
        }
        
        static public function getConcMatCargos($c){
          $c->addSelectColumn(FacultadPeer::NOMBRE);
          $c->addSelectColumn(SedePeer::NOMBRE);
          $c->addSelectColumn(ConcursoPeer::RES_CONVOCA);
          $c->addSelectColumn(ConcursoPeer::NRO_EXP_FAC);
          $c->addSelectColumn(ConcursoPeer::IS_TRAMITE);
          $c->addSelectColumn(ConcursoPeer::DESIERTO);
          $c->addSelectColumn(ConcursoPeer::SUSPENDIDO);
          $c->addSelectColumn(ConcursoPeer::CANTIDAD_MANUAL);
          $c->addSelectColumn(ConcursoPeer::CANT_CARGOS_CONV);
          $c->addSelectColumn(EstadoPeer::NOMBRE);
          $c->addSelectColumn(CarreraPeer::NOMBRE);
          $c->addSelectColumn(MateriaPeer::NOMBRE);
          $c->addSelectColumn(CargoPeer::NOMBRE);
          $c->addSelectColumn(DedicacionPeer::NOMBRE);
          $c->addSelectColumn(AspirantePeer::APELLIDO);
          $c->addSelectColumn(AspirantePeer::NOMBRE);
          $c->addSelectColumn(ConcursoCargoPeer::RES_DESIGNA);
          
          $c->addJoin(ConcursoPeer::ID, ConcursoCarreraPeer::CON_CONCURSOS_ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoCarreraPeer::CON_CARRERAS_ID, CarreraPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoCarreraPeer::CON_MATERIAS_ID, MateriaPeer::ID, Criteria::LEFT_JOIN);
          
          $c->addJoin(ConcursoPeer::ID, ConcursoCargoPeer::CON_CONCURSOS_ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoCargoPeer::CON_CARGOS_ID, CargoPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoCargoPeer::CON_DEDICACIONES_ID, DedicacionPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoCargoPeer::CON_ASPIRANTES_ID, AspirantePeer::ID);
          
          $c->addJoin(ConcursoPeer::CON_FACULTADES_ID, FacultadPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoPeer::CON_SEDES_ID, SedePeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoPeer::CON_ESTADO_ID, EstadoPeer::ID, Criteria::LEFT_JOIN);
          
          return ConcursoPeer::doSelectRS($c);
        }

        static public function getDocsOrdinarioCargo($c){
          $c->addSelectColumn(FacultadPeer::NOMBRE);
          $c->addSelectColumn(SedePeer::NOMBRE);
          $c->addSelectColumn(AspirantePeer::APELLIDO);
          $c->addSelectColumn(AspirantePeer::NOMBRE);
          $c->addSelectColumn(CargoPeer::NOMBRE);
          $c->addSelectColumn(DedicacionPeer::NOMBRE);
          $c->addSelectColumn(ConcursoCargoPeer::RES_DESIGNA);
          $c->addSelectColumn(ResolucionPeer::NUMERO);
          $c->addSelectColumn(CarreraPeer::NOMBRE);
          $c->addSelectColumn(MateriaPeer::NOMBRE);
          $c->addSelectColumn(ConcursoPeer::ID);
          
          $c->addJoin(ConcursoPeer::ID, ConcursoCargoPeer::CON_CONCURSOS_ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoCargoPeer::CON_CARGOS_ID, CargoPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoCargoPeer::CON_DEDICACIONES_ID, DedicacionPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoCargoPeer::CON_ASPIRANTES_ID, AspirantePeer::ID, Criteria::LEFT_JOIN);
          
          $c->addJoin(ConcursoPeer::CON_FACULTADES_ID, FacultadPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoPeer::CON_SEDES_ID, SedePeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoPeer::CON_ESTADO_ID, EstadoPeer::ID, Criteria::LEFT_JOIN);
          
          $c->addJoin(ConcursoPeer::CON_RESOLUCION_ID, ResolucionPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoPeer::ID, ConcursoCarreraPeer::CON_CONCURSOS_ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoCarreraPeer::CON_CARRERAS_ID, CarreraPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoCarreraPeer::CON_MATERIAS_ID, MateriaPeer::ID, Criteria::LEFT_JOIN);

          $c->add(AspirantePeer::APELLIDO, NULL, Criteria::NOT_EQUAL);
          $c->add(ConcursoCargoPeer::RES_DESIGNA, '', Criteria::NOT_EQUAL);
          $c->add(ConcursoPeer::IS_TRAMITE, 1, Criteria::EQUAL);
          
          return ConcursoPeer::doSelectRS($c);
        }
        
        static public function getDocsOrdinarioCargoCount($c){
          $c->addSelectColumn(ConcursoPeer::COUNT);
          
          $c->addJoin(ConcursoPeer::ID, ConcursoCargoPeer::CON_CONCURSOS_ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoCargoPeer::CON_CARGOS_ID, CargoPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoCargoPeer::CON_DEDICACIONES_ID, DedicacionPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoCargoPeer::CON_ASPIRANTES_ID, AspirantePeer::ID, Criteria::LEFT_JOIN);
          
          $c->addJoin(ConcursoPeer::CON_FACULTADES_ID, FacultadPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoPeer::CON_SEDES_ID, SedePeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoPeer::CON_ESTADO_ID, EstadoPeer::ID, Criteria::LEFT_JOIN);
          
          $c->addJoin(ConcursoPeer::CON_RESOLUCION_ID, ResolucionPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoPeer::ID, ConcursoCarreraPeer::CON_CONCURSOS_ID, Criteria::LEFT_JOIN);

          $c->add(AspirantePeer::APELLIDO, NULL, Criteria::NOT_EQUAL);
          $c->add(ConcursoCargoPeer::RES_DESIGNA, '', Criteria::NOT_EQUAL);
          $c->add(ConcursoPeer::IS_TRAMITE, 1, Criteria::EQUAL);
          
          $rs = ConcursoPeer::doSelectRS($c);
          
          if($rs->next()){
            return $rs->getInt(1);
          }else{
            return 0;
          }
        }
        
        static public function getDocsOrdinarios($c){
          $c->addSelectColumn(FacultadPeer::NOMBRE);
          $c->addSelectColumn(SedePeer::NOMBRE);
          $c->addSelectColumn(AspirantePeer::APELLIDO);
          $c->addSelectColumn(AspirantePeer::NOMBRE);
          $c->addSelectColumn(AspirantePeer::EMAIL);
          
          $c->setDistinct();
          
          $c->addJoin(ConcursoCargoPeer::CON_ASPIRANTES_ID, AspirantePeer::ID);
          $c->addJoin(ConcursoPeer::ID, ConcursoCargoPeer::CON_CONCURSOS_ID);
          $c->addJoin(ConcursoPeer::CON_FACULTADES_ID, FacultadPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoPeer::CON_SEDES_ID, SedePeer::ID, Criteria::LEFT_JOIN);
          
          $c->addAscendingOrderByColumn(AspirantePeer::APELLIDO);
          $c->addAscendingOrderByColumn(AspirantePeer::NOMBRE);
          
          return ConcursoPeer::doSelectRS($c);
        }
        
        static public function getDocsOrdinariosCount($c){
          $c->addSelectColumn(FacultadPeer::NOMBRE);
          $c->addSelectColumn(SedePeer::NOMBRE);
          $c->addSelectColumn(AspirantePeer::APELLIDO);
          $c->addSelectColumn(AspirantePeer::NOMBRE);
          
          $c->addJoin(ConcursoCargoPeer::CON_ASPIRANTES_ID, AspirantePeer::ID);
          $c->addJoin(ConcursoPeer::ID, ConcursoCargoPeer::CON_CONCURSOS_ID);
          $c->addJoin(ConcursoPeer::CON_FACULTADES_ID, FacultadPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoPeer::CON_SEDES_ID, SedePeer::ID, Criteria::LEFT_JOIN);
          
          $c->addGroupByColumn(FacultadPeer::NOMBRE);
          $c->addGroupByColumn(SedePeer::NOMBRE);
          $c->addGroupByColumn(AspirantePeer::APELLIDO);
          $c->addGroupByColumn(AspirantePeer::NOMBRE);
          
          $rs = ConcursoPeer::doSelectRS($c);
          
          $count = 0;
          while($rs->next()){
            $count += 1;
          }
          return $count;
          
        }
        
        static public function getRepConcursos($res=null, $fac=null, $carrera=null, $sede=null, $mat=null, $exp=null, $cargo=null, $tram=null, $est=null, $result=null){
          $c = new Criteria();
          $c->addSelectColumn(ConcursoPeer::RES_CONVOCA);
          $c->addSelectColumn(ConcursoPeer::NRO_EXP_FAC);
          $c->addSelectColumn(FacultadPeer::NOMBRE);
          $c->addSelectColumn(SedePeer::NOMBRE);
          $c->addSelectColumn(MateriaPeer::NOMBRE);
          $c->addSelectColumn(CarreraPeer::NOMBRE);
          $c->addSelectColumn(ConcursoPeer::CANT_CARGOS_CONV);
          $c->addSelectColumn(ResultadoPeer::NOMBRE);
          $c->addSelectColumn(ConcursoPeer::IS_TRAMITE);
          $c->addSelectColumn(EstadoPeer::NOMBRE);         
          $c->addSelectColumn(ConcursoPeer::ID);
          
          $c->addJoin(ConcursoPeer::CON_RESOLUCION_ID, ResolucionPeer::ID, Criteria::LEFT_JOIN);          
          $c->addJoin(ConcursoPeer::CON_FACULTADES_ID, FacultadPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoPeer::CON_SEDES_ID, SedePeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoPeer::ID, ConcursoCarreraPeer::CON_CONCURSOS_ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoCarreraPeer::CON_MATERIAS_ID, MateriaPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoCarreraPeer::CON_CARRERAS_ID, CarreraPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoPeer::CON_RESULTADO_ID, ResultadoPeer::ID, Criteria::LEFT_JOIN);
          $c->addJoin(ConcursoPeer::CON_ESTADO_ID, EstadoPeer::ID, Criteria::LEFT_JOIN);

          If(!empty($res)) $c->add(ConcursoPeer::CON_RESOLUCION_ID, $res, Criteria::EQUAL);
          if(!empty($fac)) $c->add(ConcursoPeer::CON_FACULTADES_ID, $fac, Criteria::EQUAL);
          if(!empty($carrera)) $c->add(ConcursoCarreraPeer::CON_CARRERAS_ID, $carrera, Criteria::EQUAL);
          if(!empty($mat)) $c->add(ConcursoCarreraPeer::CON_MATERIAS_ID, $mat, Criteria::EQUAL);
          if(!empty($sede)) $c->add(ConcursoPeer::CON_SEDES_ID, $sede, Criteria::EQUAL);
          if(!empty($exp)) $c->add(ConcursoPeer::NRO_EXP_FAC, $exp, Criteria::EQUAL);
          if(!empty($cargo)) $c->add(ConcursoPeer::CANT_CARGOS_CONV, $cargo, Criteria::EQUAL);
          if(!empty($tram)) $c->add(ConcursoPeer::IS_TRAMITE, $tram, Criteria::EQUAL);
          if(!empty($est)) $c->add(ConcursoPeer::CON_ESTADO_ID, $est, Criteria::EQUAL);
          if(!empty($result)) $c->add(ConcursoPeer::CON_RESULTADO_ID, $result, Criteria::EQUAL);

          return ConcursoPeer::doSelectRS($c);     
        }
        
        
        static public function getAsignaturasConcursadas($res, $fac, $carr){ /*$fac=1,$carr=1*/
                $where_resolucion ='';
                if($res)
                   $where_resolucion='and con_resolucion.id = '.$res;
                if($fac)
                   $where_resolucion .=' and con_facultades.id = '.$fac;
                if($carr)
                   $where_resolucion .=' and con_carreras.id = '.$carr;
                
                $con = Propel::getConnection(self::DATABASE_NAME);
                
                $sql="(SELECT con_facultades.`nombre_largo` as facultad,
                               con_cargos.`nombre` as cargo,
                               con_materias.`nombre` as asignatura, 
                               con_carreras.NOMBRE as carrera,
                               con_sedes.`nombre` as sede,
                               concat(con_resolucion.`numero`,'/',con_resolucion.`year`) as resolucion,
                               con_dedicaciones.`nombre` as dedicacion,
                               con_concursos.`desierto` as desierto,
                               con_concursos.`suspendido` as suspendido,
                               con_concursos.id,
                               con_cargos.orden as orden
                        FROM   con_concursos LEFT join con_cargos on con_concursos.`con_cargos_id` =  con_cargos.`id`
                                             LEFT join con_facultades on con_concursos.`con_facultades_id` =  con_facultades.`id`
                                             LEFT join con_carreras on con_concursos.`con_carreras_id` =  con_carreras.`id`
                                             LEFT join con_materias on con_concursos.`con_materias_id` =  con_materias.`id`
                                             LEFT join con_sedes on con_concursos.`con_sedes_id` =  con_sedes.`id`
                                             LEFT join con_dedicaciones on con_concursos.`con_dedicaciones_id` =  con_dedicaciones.`id`
                                             LEFT join con_resolucion on con_concursos.`con_resolucion_id` =  con_resolucion.`id`
       
                        WHERE  (con_concursos.`suspendido` = 0) and 
                               (con_concursos.`desierto` = 0)
                               $where_resolucion
       
                        )
                        union all
                        (
                        SELECT con_facultades.`nombre_largo`,
                               'SUSPENDIDO',
                               con_materias.`nombre` , 
                               con_carreras.NOMBRE,
                               con_sedes.`nombre` ,
                               concat(con_resolucion.`numero`,'/',con_resolucion.`year`),
                               con_dedicaciones.`nombre` ,
                               con_concursos.`desierto`,
                               con_concursos.`suspendido`,
                               con_concursos.id,
                               1002
                               
                        FROM   con_concursos LEFT join con_cargos on con_concursos.`con_cargos_id` =  con_cargos.`id`
                                             LEFT join con_facultades on con_concursos.`con_facultades_id` =  con_facultades.`id`
                                             LEFT join con_carreras on con_concursos.`con_carreras_id` =  con_carreras.`id`
                                             LEFT join con_materias on con_concursos.`con_materias_id` =  con_materias.`id`
                                             LEFT join con_sedes on con_concursos.`con_sedes_id` =  con_sedes.`id`
                                             LEFT join con_dedicaciones on con_concursos.`con_dedicaciones_id` =  con_dedicaciones.`id`
                                             LEFT join con_resolucion on con_concursos.`con_resolucion_id` =  con_resolucion.`id`
                        WHERE (con_concursos.`suspendido` = 1) $where_resolucion
       
                        )         
                        union all
                        (
                        SELECT con_facultades.`nombre_largo` ,
                               'DESIERTOS',
                               con_materias.`nombre` , 
                               con_carreras.NOMBRE,
                               con_sedes.`nombre` ,
                               concat(con_resolucion.`numero`,'/',con_resolucion.`year`),
                               con_dedicaciones.`nombre` ,
                               con_concursos.`desierto`,
                               con_concursos.`suspendido`,
                               con_concursos.id,
                               1001      
                        FROM   con_concursos left join con_cargos on con_concursos.`con_cargos_id` =  con_cargos.`id`
                                             left join con_facultades on con_concursos.`con_facultades_id` =  con_facultades.`id`
                                             left join con_carreras on con_concursos.`con_carreras_id` =  con_carreras.`id`
                                             left join con_materias on con_concursos.`con_materias_id` =  con_materias.`id`
                                             left join con_sedes on con_concursos.`con_sedes_id` =  con_sedes.`id`
                                             left join con_dedicaciones on con_concursos.`con_dedicaciones_id` =  con_dedicaciones.`id`
                                             left join con_resolucion on con_concursos.`con_resolucion_id` =  con_resolucion.`id`
                        WHERE (con_concursos.`desierto` = 1) $where_resolucion
                        )
                        order by facultad,
                                 orden,
                                 cargo,
                                 asignatura, 
                                 carrera
                                 ";
                $stmt = $con->createStatement();
                $rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM); //return self::populateObjects($rs);
                return $rs;                                
        }


}
