<?php



class ConcursoMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.ConcursoMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('con_concursos');
		$tMap->setPhpName('Concurso');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('NRO_EXP_FAC', 'NroExpFac', 'string', CreoleTypes::VARCHAR, false, 20);

		$tMap->addColumn('NOMBRE', 'Nombre', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('INICIO_DATE', 'InicioDate', 'int', CreoleTypes::DATE, true, null);

		$tMap->addColumn('RES_CONVOCA', 'ResConvoca', 'string', CreoleTypes::VARCHAR, false, 20);

		$tMap->addColumn('RES_DESIGNA', 'ResDesigna', 'string', CreoleTypes::VARCHAR, false, 20);

		$tMap->addColumn('RES_DESIGNA_FECHA', 'ResDesignaFecha', 'int', CreoleTypes::DATE, false, null);

		$tMap->addColumn('CLASEPUBLICA_DATE', 'ClasepublicaDate', 'int', CreoleTypes::DATE, true, null);

		$tMap->addForeignKey('CON_CARRERAS_ID', 'ConCarrerasId', 'int', CreoleTypes::INTEGER, 'con_carreras', 'ID', false, null);

		$tMap->addForeignKey('CON_SEDES_ID', 'ConSedesId', 'int', CreoleTypes::INTEGER, 'con_sedes', 'ID', false, null);

		$tMap->addForeignKey('CON_FACULTADES_ID', 'ConFacultadesId', 'int', CreoleTypes::INTEGER, 'con_facultades', 'ID', false, null);

		$tMap->addForeignKey('CON_MATERIAS_ID', 'ConMateriasId', 'int', CreoleTypes::INTEGER, 'con_materias', 'ID', false, null);

		$tMap->addForeignKey('CON_DEDICACIONES_ID', 'ConDedicacionesId', 'int', CreoleTypes::INTEGER, 'con_dedicaciones', 'ID', false, null);

		$tMap->addForeignKey('CON_CARGOS_ID', 'ConCargosId', 'int', CreoleTypes::INTEGER, 'con_cargos', 'ID', false, null);

		$tMap->addForeignKey('CARRERA_MATERIA_ID', 'CarreraMateriaId', 'int', CreoleTypes::INTEGER, 'carrera_materia', 'ID', false, null);

		$tMap->addForeignKey('CON_RESOLUCION_ID', 'ConResolucionId', 'int', CreoleTypes::INTEGER, 'con_resolucion', 'ID', false, null);

		$tMap->addColumn('OBSERVACION', 'Observacion', 'string', CreoleTypes::LONGVARCHAR, true, null);

		$tMap->addColumn('CANTIDAD_MANUAL', 'CantidadManual', 'int', CreoleTypes::INTEGER, false, null);

		$tMap->addColumn('ASPIRANTE_NOMBRE', 'AspiranteNombre', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('ASPIRANTE_APELLIDO', 'AspiranteApellido', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('ASPIRANTE_DNI', 'AspiranteDni', 'string', CreoleTypes::VARCHAR, false, 11);

		$tMap->addColumn('ASPIRANTE_TITULO', 'AspiranteTitulo', 'string', CreoleTypes::VARCHAR, false, 70);

		$tMap->addColumn('DESIERTO', 'Desierto', 'boolean', CreoleTypes::BOOLEAN, false, null);

		$tMap->addColumn('SUSPENDIDO', 'Suspendido', 'boolean', CreoleTypes::BOOLEAN, false, null);

		$tMap->addColumn('TRANSFERIDO', 'Transferido', 'boolean', CreoleTypes::BOOLEAN, false, null);

		$tMap->addColumn('IS_TRAMITE', 'IsTramite', 'boolean', CreoleTypes::BOOLEAN, false, null);

		$tMap->addColumn('CANT_CARGOS_CONV', 'CantCargosConv', 'int', CreoleTypes::INTEGER, false, null);

		$tMap->addForeignKey('CON_ESTADO_ID', 'ConEstadoId', 'int', CreoleTypes::INTEGER, 'con_estado', 'ID', false, null);

		$tMap->addForeignKey('CON_RESULTADO_ID', 'ConResultadoId', 'int', CreoleTypes::INTEGER, 'con_resultado', 'ID', false, null);

		$tMap->addColumn('CREATED_AT', 'CreatedAt', 'int', CreoleTypes::TIMESTAMP, false, null);

	} 
} 