<?php


abstract class BaseAspirante extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $nombre;


	
	protected $apellido;


	
	protected $direccion;


	
	protected $dni;


	
	protected $telefono;


	
	protected $email;

	
	protected $collConcursoAspirantes;

	
	protected $lastConcursoAspiranteCriteria = null;

	
	protected $collConcursoCargos;

	
	protected $lastConcursoCargoCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getNombre()
	{

		return $this->nombre;
	}

	
	public function getApellido()
	{

		return $this->apellido;
	}

	
	public function getDireccion()
	{

		return $this->direccion;
	}

	
	public function getDni()
	{

		return $this->dni;
	}

	
	public function getTelefono()
	{

		return $this->telefono;
	}

	
	public function getEmail()
	{

		return $this->email;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = AspirantePeer::ID;
		}

	} 
	
	public function setNombre($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nombre !== $v) {
			$this->nombre = $v;
			$this->modifiedColumns[] = AspirantePeer::NOMBRE;
		}

	} 
	
	public function setApellido($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->apellido !== $v) {
			$this->apellido = $v;
			$this->modifiedColumns[] = AspirantePeer::APELLIDO;
		}

	} 
	
	public function setDireccion($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->direccion !== $v) {
			$this->direccion = $v;
			$this->modifiedColumns[] = AspirantePeer::DIRECCION;
		}

	} 
	
	public function setDni($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->dni !== $v) {
			$this->dni = $v;
			$this->modifiedColumns[] = AspirantePeer::DNI;
		}

	} 
	
	public function setTelefono($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->telefono !== $v) {
			$this->telefono = $v;
			$this->modifiedColumns[] = AspirantePeer::TELEFONO;
		}

	} 
	
	public function setEmail($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->email !== $v) {
			$this->email = $v;
			$this->modifiedColumns[] = AspirantePeer::EMAIL;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->nombre = $rs->getString($startcol + 1);

			$this->apellido = $rs->getString($startcol + 2);

			$this->direccion = $rs->getString($startcol + 3);

			$this->dni = $rs->getString($startcol + 4);

			$this->telefono = $rs->getString($startcol + 5);

			$this->email = $rs->getString($startcol + 6);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 7; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Aspirante object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseAspirante:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(AspirantePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			AspirantePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseAspirante:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseAspirante:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(AspirantePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseAspirante:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = AspirantePeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += AspirantePeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collConcursoAspirantes !== null) {
				foreach($this->collConcursoAspirantes as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collConcursoCargos !== null) {
				foreach($this->collConcursoCargos as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = AspirantePeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collConcursoAspirantes !== null) {
					foreach($this->collConcursoAspirantes as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collConcursoCargos !== null) {
					foreach($this->collConcursoCargos as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = AspirantePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getNombre();
				break;
			case 2:
				return $this->getApellido();
				break;
			case 3:
				return $this->getDireccion();
				break;
			case 4:
				return $this->getDni();
				break;
			case 5:
				return $this->getTelefono();
				break;
			case 6:
				return $this->getEmail();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = AspirantePeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getNombre(),
			$keys[2] => $this->getApellido(),
			$keys[3] => $this->getDireccion(),
			$keys[4] => $this->getDni(),
			$keys[5] => $this->getTelefono(),
			$keys[6] => $this->getEmail(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = AspirantePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setNombre($value);
				break;
			case 2:
				$this->setApellido($value);
				break;
			case 3:
				$this->setDireccion($value);
				break;
			case 4:
				$this->setDni($value);
				break;
			case 5:
				$this->setTelefono($value);
				break;
			case 6:
				$this->setEmail($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = AspirantePeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setNombre($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setApellido($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setDireccion($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setDni($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setTelefono($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setEmail($arr[$keys[6]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(AspirantePeer::DATABASE_NAME);

		if ($this->isColumnModified(AspirantePeer::ID)) $criteria->add(AspirantePeer::ID, $this->id);
		if ($this->isColumnModified(AspirantePeer::NOMBRE)) $criteria->add(AspirantePeer::NOMBRE, $this->nombre);
		if ($this->isColumnModified(AspirantePeer::APELLIDO)) $criteria->add(AspirantePeer::APELLIDO, $this->apellido);
		if ($this->isColumnModified(AspirantePeer::DIRECCION)) $criteria->add(AspirantePeer::DIRECCION, $this->direccion);
		if ($this->isColumnModified(AspirantePeer::DNI)) $criteria->add(AspirantePeer::DNI, $this->dni);
		if ($this->isColumnModified(AspirantePeer::TELEFONO)) $criteria->add(AspirantePeer::TELEFONO, $this->telefono);
		if ($this->isColumnModified(AspirantePeer::EMAIL)) $criteria->add(AspirantePeer::EMAIL, $this->email);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(AspirantePeer::DATABASE_NAME);

		$criteria->add(AspirantePeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setNombre($this->nombre);

		$copyObj->setApellido($this->apellido);

		$copyObj->setDireccion($this->direccion);

		$copyObj->setDni($this->dni);

		$copyObj->setTelefono($this->telefono);

		$copyObj->setEmail($this->email);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getConcursoAspirantes() as $relObj) {
				$copyObj->addConcursoAspirante($relObj->copy($deepCopy));
			}

			foreach($this->getConcursoCargos() as $relObj) {
				$copyObj->addConcursoCargo($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new AspirantePeer();
		}
		return self::$peer;
	}

	
	public function initConcursoAspirantes()
	{
		if ($this->collConcursoAspirantes === null) {
			$this->collConcursoAspirantes = array();
		}
	}

	
	public function getConcursoAspirantes($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoAspirantePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoAspirantes === null) {
			if ($this->isNew()) {
			   $this->collConcursoAspirantes = array();
			} else {

				$criteria->add(ConcursoAspirantePeer::CON_ASPIRANTES_ID, $this->getId());

				ConcursoAspirantePeer::addSelectColumns($criteria);
				$this->collConcursoAspirantes = ConcursoAspirantePeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConcursoAspirantePeer::CON_ASPIRANTES_ID, $this->getId());

				ConcursoAspirantePeer::addSelectColumns($criteria);
				if (!isset($this->lastConcursoAspiranteCriteria) || !$this->lastConcursoAspiranteCriteria->equals($criteria)) {
					$this->collConcursoAspirantes = ConcursoAspirantePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConcursoAspiranteCriteria = $criteria;
		return $this->collConcursoAspirantes;
	}

	
	public function countConcursoAspirantes($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoAspirantePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConcursoAspirantePeer::CON_ASPIRANTES_ID, $this->getId());

		return ConcursoAspirantePeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConcursoAspirante(ConcursoAspirante $l)
	{
		$this->collConcursoAspirantes[] = $l;
		$l->setAspirante($this);
	}


	
	public function getConcursoAspirantesJoinConcurso($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoAspirantePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoAspirantes === null) {
			if ($this->isNew()) {
				$this->collConcursoAspirantes = array();
			} else {

				$criteria->add(ConcursoAspirantePeer::CON_ASPIRANTES_ID, $this->getId());

				$this->collConcursoAspirantes = ConcursoAspirantePeer::doSelectJoinConcurso($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoAspirantePeer::CON_ASPIRANTES_ID, $this->getId());

			if (!isset($this->lastConcursoAspiranteCriteria) || !$this->lastConcursoAspiranteCriteria->equals($criteria)) {
				$this->collConcursoAspirantes = ConcursoAspirantePeer::doSelectJoinConcurso($criteria, $con);
			}
		}
		$this->lastConcursoAspiranteCriteria = $criteria;

		return $this->collConcursoAspirantes;
	}

	
	public function initConcursoCargos()
	{
		if ($this->collConcursoCargos === null) {
			$this->collConcursoCargos = array();
		}
	}

	
	public function getConcursoCargos($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargos === null) {
			if ($this->isNew()) {
			   $this->collConcursoCargos = array();
			} else {

				$criteria->add(ConcursoCargoPeer::CON_ASPIRANTES_ID, $this->getId());

				ConcursoCargoPeer::addSelectColumns($criteria);
				$this->collConcursoCargos = ConcursoCargoPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConcursoCargoPeer::CON_ASPIRANTES_ID, $this->getId());

				ConcursoCargoPeer::addSelectColumns($criteria);
				if (!isset($this->lastConcursoCargoCriteria) || !$this->lastConcursoCargoCriteria->equals($criteria)) {
					$this->collConcursoCargos = ConcursoCargoPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConcursoCargoCriteria = $criteria;
		return $this->collConcursoCargos;
	}

	
	public function countConcursoCargos($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConcursoCargoPeer::CON_ASPIRANTES_ID, $this->getId());

		return ConcursoCargoPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConcursoCargo(ConcursoCargo $l)
	{
		$this->collConcursoCargos[] = $l;
		$l->setAspirante($this);
	}


	
	public function getConcursoCargosJoinConcurso($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargos === null) {
			if ($this->isNew()) {
				$this->collConcursoCargos = array();
			} else {

				$criteria->add(ConcursoCargoPeer::CON_ASPIRANTES_ID, $this->getId());

				$this->collConcursoCargos = ConcursoCargoPeer::doSelectJoinConcurso($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoCargoPeer::CON_ASPIRANTES_ID, $this->getId());

			if (!isset($this->lastConcursoCargoCriteria) || !$this->lastConcursoCargoCriteria->equals($criteria)) {
				$this->collConcursoCargos = ConcursoCargoPeer::doSelectJoinConcurso($criteria, $con);
			}
		}
		$this->lastConcursoCargoCriteria = $criteria;

		return $this->collConcursoCargos;
	}


	
	public function getConcursoCargosJoinCargo($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargos === null) {
			if ($this->isNew()) {
				$this->collConcursoCargos = array();
			} else {

				$criteria->add(ConcursoCargoPeer::CON_ASPIRANTES_ID, $this->getId());

				$this->collConcursoCargos = ConcursoCargoPeer::doSelectJoinCargo($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoCargoPeer::CON_ASPIRANTES_ID, $this->getId());

			if (!isset($this->lastConcursoCargoCriteria) || !$this->lastConcursoCargoCriteria->equals($criteria)) {
				$this->collConcursoCargos = ConcursoCargoPeer::doSelectJoinCargo($criteria, $con);
			}
		}
		$this->lastConcursoCargoCriteria = $criteria;

		return $this->collConcursoCargos;
	}


	
	public function getConcursoCargosJoinDedicacion($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargos === null) {
			if ($this->isNew()) {
				$this->collConcursoCargos = array();
			} else {

				$criteria->add(ConcursoCargoPeer::CON_ASPIRANTES_ID, $this->getId());

				$this->collConcursoCargos = ConcursoCargoPeer::doSelectJoinDedicacion($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoCargoPeer::CON_ASPIRANTES_ID, $this->getId());

			if (!isset($this->lastConcursoCargoCriteria) || !$this->lastConcursoCargoCriteria->equals($criteria)) {
				$this->collConcursoCargos = ConcursoCargoPeer::doSelectJoinDedicacion($criteria, $con);
			}
		}
		$this->lastConcursoCargoCriteria = $criteria;

		return $this->collConcursoCargos;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseAspirante:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseAspirante::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 