<?php


abstract class BaseCarreraMateria extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $con_materias_id;


	
	protected $con_carreras_id;


	
	protected $plan;


	
	protected $id;

	
	protected $aMateria;

	
	protected $aCarrera;

	
	protected $collConcursos;

	
	protected $lastConcursoCriteria = null;

	
	protected $collConcursoPlans;

	
	protected $lastConcursoPlanCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getConMateriasId()
	{

		return $this->con_materias_id;
	}

	
	public function getConCarrerasId()
	{

		return $this->con_carreras_id;
	}

	
	public function getPlan()
	{

		return $this->plan;
	}

	
	public function getId()
	{

		return $this->id;
	}

	
	public function setConMateriasId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_materias_id !== $v) {
			$this->con_materias_id = $v;
			$this->modifiedColumns[] = CarreraMateriaPeer::CON_MATERIAS_ID;
		}

		if ($this->aMateria !== null && $this->aMateria->getId() !== $v) {
			$this->aMateria = null;
		}

	} 
	
	public function setConCarrerasId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_carreras_id !== $v) {
			$this->con_carreras_id = $v;
			$this->modifiedColumns[] = CarreraMateriaPeer::CON_CARRERAS_ID;
		}

		if ($this->aCarrera !== null && $this->aCarrera->getId() !== $v) {
			$this->aCarrera = null;
		}

	} 
	
	public function setPlan($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->plan !== $v) {
			$this->plan = $v;
			$this->modifiedColumns[] = CarreraMateriaPeer::PLAN;
		}

	} 
	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = CarreraMateriaPeer::ID;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->con_materias_id = $rs->getInt($startcol + 0);

			$this->con_carreras_id = $rs->getInt($startcol + 1);

			$this->plan = $rs->getInt($startcol + 2);

			$this->id = $rs->getInt($startcol + 3);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 4; 
		} catch (Exception $e) {
			throw new PropelException("Error populating CarreraMateria object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseCarreraMateria:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CarreraMateriaPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			CarreraMateriaPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseCarreraMateria:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseCarreraMateria:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CarreraMateriaPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseCarreraMateria:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aMateria !== null) {
				if ($this->aMateria->isModified()) {
					$affectedRows += $this->aMateria->save($con);
				}
				$this->setMateria($this->aMateria);
			}

			if ($this->aCarrera !== null) {
				if ($this->aCarrera->isModified()) {
					$affectedRows += $this->aCarrera->save($con);
				}
				$this->setCarrera($this->aCarrera);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CarreraMateriaPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += CarreraMateriaPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collConcursos !== null) {
				foreach($this->collConcursos as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collConcursoPlans !== null) {
				foreach($this->collConcursoPlans as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aMateria !== null) {
				if (!$this->aMateria->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aMateria->getValidationFailures());
				}
			}

			if ($this->aCarrera !== null) {
				if (!$this->aCarrera->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aCarrera->getValidationFailures());
				}
			}


			if (($retval = CarreraMateriaPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collConcursos !== null) {
					foreach($this->collConcursos as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collConcursoPlans !== null) {
					foreach($this->collConcursoPlans as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CarreraMateriaPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getConMateriasId();
				break;
			case 1:
				return $this->getConCarrerasId();
				break;
			case 2:
				return $this->getPlan();
				break;
			case 3:
				return $this->getId();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CarreraMateriaPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getConMateriasId(),
			$keys[1] => $this->getConCarrerasId(),
			$keys[2] => $this->getPlan(),
			$keys[3] => $this->getId(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CarreraMateriaPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setConMateriasId($value);
				break;
			case 1:
				$this->setConCarrerasId($value);
				break;
			case 2:
				$this->setPlan($value);
				break;
			case 3:
				$this->setId($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CarreraMateriaPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setConMateriasId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setConCarrerasId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setPlan($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setId($arr[$keys[3]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(CarreraMateriaPeer::DATABASE_NAME);

		if ($this->isColumnModified(CarreraMateriaPeer::CON_MATERIAS_ID)) $criteria->add(CarreraMateriaPeer::CON_MATERIAS_ID, $this->con_materias_id);
		if ($this->isColumnModified(CarreraMateriaPeer::CON_CARRERAS_ID)) $criteria->add(CarreraMateriaPeer::CON_CARRERAS_ID, $this->con_carreras_id);
		if ($this->isColumnModified(CarreraMateriaPeer::PLAN)) $criteria->add(CarreraMateriaPeer::PLAN, $this->plan);
		if ($this->isColumnModified(CarreraMateriaPeer::ID)) $criteria->add(CarreraMateriaPeer::ID, $this->id);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(CarreraMateriaPeer::DATABASE_NAME);

		$criteria->add(CarreraMateriaPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setConMateriasId($this->con_materias_id);

		$copyObj->setConCarrerasId($this->con_carreras_id);

		$copyObj->setPlan($this->plan);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getConcursos() as $relObj) {
				$copyObj->addConcurso($relObj->copy($deepCopy));
			}

			foreach($this->getConcursoPlans() as $relObj) {
				$copyObj->addConcursoPlan($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CarreraMateriaPeer();
		}
		return self::$peer;
	}

	
	public function setMateria($v)
	{


		if ($v === null) {
			$this->setConMateriasId(NULL);
		} else {
			$this->setConMateriasId($v->getId());
		}


		$this->aMateria = $v;
	}


	
	public function getMateria($con = null)
	{
		if ($this->aMateria === null && ($this->con_materias_id !== null)) {
						include_once 'lib/model/om/BaseMateriaPeer.php';

			$this->aMateria = MateriaPeer::retrieveByPK($this->con_materias_id, $con);

			
		}
		return $this->aMateria;
	}

	
	public function setCarrera($v)
	{


		if ($v === null) {
			$this->setConCarrerasId(NULL);
		} else {
			$this->setConCarrerasId($v->getId());
		}


		$this->aCarrera = $v;
	}


	
	public function getCarrera($con = null)
	{
		if ($this->aCarrera === null && ($this->con_carreras_id !== null)) {
						include_once 'lib/model/om/BaseCarreraPeer.php';

			$this->aCarrera = CarreraPeer::retrieveByPK($this->con_carreras_id, $con);

			
		}
		return $this->aCarrera;
	}

	
	public function initConcursos()
	{
		if ($this->collConcursos === null) {
			$this->collConcursos = array();
		}
	}

	
	public function getConcursos($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
			   $this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

				ConcursoPeer::addSelectColumns($criteria);
				$this->collConcursos = ConcursoPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

				ConcursoPeer::addSelectColumns($criteria);
				if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
					$this->collConcursos = ConcursoPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConcursoCriteria = $criteria;
		return $this->collConcursos;
	}

	
	public function countConcursos($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

		return ConcursoPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConcurso(Concurso $l)
	{
		$this->collConcursos[] = $l;
		$l->setCarreraMateria($this);
	}


	
	public function getConcursosJoinCarrera($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinCarrera($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinCarrera($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinSede($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinSede($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinSede($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinFacultad($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinFacultad($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinFacultad($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinMateria($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinMateria($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinMateria($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinDedicacion($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinDedicacion($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinDedicacion($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinCargo($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinCargo($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinCargo($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinResolucion($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinResolucion($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinResolucion($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinEstado($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinEstado($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinEstado($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinResultado($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinResultado($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinResultado($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}

	
	public function initConcursoPlans()
	{
		if ($this->collConcursoPlans === null) {
			$this->collConcursoPlans = array();
		}
	}

	
	public function getConcursoPlans($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPlanPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoPlans === null) {
			if ($this->isNew()) {
			   $this->collConcursoPlans = array();
			} else {

				$criteria->add(ConcursoPlanPeer::CARRERA_MATERIA_ID, $this->getId());

				ConcursoPlanPeer::addSelectColumns($criteria);
				$this->collConcursoPlans = ConcursoPlanPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConcursoPlanPeer::CARRERA_MATERIA_ID, $this->getId());

				ConcursoPlanPeer::addSelectColumns($criteria);
				if (!isset($this->lastConcursoPlanCriteria) || !$this->lastConcursoPlanCriteria->equals($criteria)) {
					$this->collConcursoPlans = ConcursoPlanPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConcursoPlanCriteria = $criteria;
		return $this->collConcursoPlans;
	}

	
	public function countConcursoPlans($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPlanPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConcursoPlanPeer::CARRERA_MATERIA_ID, $this->getId());

		return ConcursoPlanPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConcursoPlan(ConcursoPlan $l)
	{
		$this->collConcursoPlans[] = $l;
		$l->setCarreraMateria($this);
	}


	
	public function getConcursoPlansJoinConcurso($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPlanPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoPlans === null) {
			if ($this->isNew()) {
				$this->collConcursoPlans = array();
			} else {

				$criteria->add(ConcursoPlanPeer::CARRERA_MATERIA_ID, $this->getId());

				$this->collConcursoPlans = ConcursoPlanPeer::doSelectJoinConcurso($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPlanPeer::CARRERA_MATERIA_ID, $this->getId());

			if (!isset($this->lastConcursoPlanCriteria) || !$this->lastConcursoPlanCriteria->equals($criteria)) {
				$this->collConcursoPlans = ConcursoPlanPeer::doSelectJoinConcurso($criteria, $con);
			}
		}
		$this->lastConcursoPlanCriteria = $criteria;

		return $this->collConcursoPlans;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseCarreraMateria:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseCarreraMateria::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 