<?php


abstract class BaseConFacultades extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;

	
	protected $collCarreras;

	
	protected $lastCarreraCriteria = null;

	
	protected $collMaterias;

	
	protected $lastMateriaCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ConFacultadesPeer::ID;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 1; 
		} catch (Exception $e) {
			throw new PropelException("Error populating ConFacultades object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ConFacultadesPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			ConFacultadesPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ConFacultadesPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ConFacultadesPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ConFacultadesPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collCarreras !== null) {
				foreach($this->collCarreras as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collMaterias !== null) {
				foreach($this->collMaterias as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = ConFacultadesPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collCarreras !== null) {
					foreach($this->collCarreras as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collMaterias !== null) {
					foreach($this->collMaterias as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ConFacultadesPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ConFacultadesPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ConFacultadesPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ConFacultadesPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ConFacultadesPeer::DATABASE_NAME);

		if ($this->isColumnModified(ConFacultadesPeer::ID)) $criteria->add(ConFacultadesPeer::ID, $this->id);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ConFacultadesPeer::DATABASE_NAME);

		$criteria->add(ConFacultadesPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getCarreras() as $relObj) {
				$copyObj->addCarrera($relObj->copy($deepCopy));
			}

			foreach($this->getMaterias() as $relObj) {
				$copyObj->addMateria($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ConFacultadesPeer();
		}
		return self::$peer;
	}

	
	public function initCarreras()
	{
		if ($this->collCarreras === null) {
			$this->collCarreras = array();
		}
	}

	
	public function getCarreras($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseCarreraPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCarreras === null) {
			if ($this->isNew()) {
			   $this->collCarreras = array();
			} else {

				$criteria->add(CarreraPeer::CON_FACULTADES_ID, $this->getId());

				CarreraPeer::addSelectColumns($criteria);
				$this->collCarreras = CarreraPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CarreraPeer::CON_FACULTADES_ID, $this->getId());

				CarreraPeer::addSelectColumns($criteria);
				if (!isset($this->lastCarreraCriteria) || !$this->lastCarreraCriteria->equals($criteria)) {
					$this->collCarreras = CarreraPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCarreraCriteria = $criteria;
		return $this->collCarreras;
	}

	
	public function countCarreras($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseCarreraPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(CarreraPeer::CON_FACULTADES_ID, $this->getId());

		return CarreraPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addCarrera(Carrera $l)
	{
		$this->collCarreras[] = $l;
		$l->setConFacultades($this);
	}

	
	public function initMaterias()
	{
		if ($this->collMaterias === null) {
			$this->collMaterias = array();
		}
	}

	
	public function getMaterias($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseMateriaPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collMaterias === null) {
			if ($this->isNew()) {
			   $this->collMaterias = array();
			} else {

				$criteria->add(MateriaPeer::CON_FACULTADES_ID, $this->getId());

				MateriaPeer::addSelectColumns($criteria);
				$this->collMaterias = MateriaPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(MateriaPeer::CON_FACULTADES_ID, $this->getId());

				MateriaPeer::addSelectColumns($criteria);
				if (!isset($this->lastMateriaCriteria) || !$this->lastMateriaCriteria->equals($criteria)) {
					$this->collMaterias = MateriaPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMateriaCriteria = $criteria;
		return $this->collMaterias;
	}

	
	public function countMaterias($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseMateriaPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(MateriaPeer::CON_FACULTADES_ID, $this->getId());

		return MateriaPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addMateria(Materia $l)
	{
		$this->collMaterias[] = $l;
		$l->setConFacultades($this);
	}


	
	public function getMateriasJoinSede($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseMateriaPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collMaterias === null) {
			if ($this->isNew()) {
				$this->collMaterias = array();
			} else {

				$criteria->add(MateriaPeer::CON_FACULTADES_ID, $this->getId());

				$this->collMaterias = MateriaPeer::doSelectJoinSede($criteria, $con);
			}
		} else {
									
			$criteria->add(MateriaPeer::CON_FACULTADES_ID, $this->getId());

			if (!isset($this->lastMateriaCriteria) || !$this->lastMateriaCriteria->equals($criteria)) {
				$this->collMaterias = MateriaPeer::doSelectJoinSede($criteria, $con);
			}
		}
		$this->lastMateriaCriteria = $criteria;

		return $this->collMaterias;
	}


	
	public function getMateriasJoinCarrera($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseMateriaPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collMaterias === null) {
			if ($this->isNew()) {
				$this->collMaterias = array();
			} else {

				$criteria->add(MateriaPeer::CON_FACULTADES_ID, $this->getId());

				$this->collMaterias = MateriaPeer::doSelectJoinCarrera($criteria, $con);
			}
		} else {
									
			$criteria->add(MateriaPeer::CON_FACULTADES_ID, $this->getId());

			if (!isset($this->lastMateriaCriteria) || !$this->lastMateriaCriteria->equals($criteria)) {
				$this->collMaterias = MateriaPeer::doSelectJoinCarrera($criteria, $con);
			}
		}
		$this->lastMateriaCriteria = $criteria;

		return $this->collMaterias;
	}

} 