<?php


abstract class BaseConcurso extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $nro_exp_fac;


	
	protected $nombre;


	
	protected $inicio_date;


	
	protected $res_convoca;


	
	protected $res_designa;


	
	protected $res_designa_fecha;


	
	protected $clasepublica_date;


	
	protected $con_carreras_id;


	
	protected $con_sedes_id;


	
	protected $con_facultades_id;


	
	protected $con_materias_id;


	
	protected $con_dedicaciones_id;


	
	protected $con_cargos_id;


	
	protected $carrera_materia_id;


	
	protected $con_resolucion_id;


	
	protected $observacion;


	
	protected $cantidad_manual = 0;


	
	protected $aspirante_nombre;


	
	protected $aspirante_apellido;


	
	protected $aspirante_dni;


	
	protected $aspirante_titulo;


	
	protected $desierto = false;


	
	protected $suspendido = false;


	
	protected $transferido = false;


	
	protected $is_tramite = false;


	
	protected $cant_cargos_conv;


	
	protected $con_estado_id;


	
	protected $con_resultado_id;


	
	protected $created_at;

	
	protected $aCarrera;

	
	protected $aSede;

	
	protected $aFacultad;

	
	protected $aMateria;

	
	protected $aDedicacion;

	
	protected $aCargo;

	
	protected $aCarreraMateria;

	
	protected $aResolucion;

	
	protected $aEstado;

	
	protected $aResultado;

	
	protected $collConcursoAspirantes;

	
	protected $lastConcursoAspiranteCriteria = null;

	
	protected $collConcursoJurados;

	
	protected $lastConcursoJuradoCriteria = null;

	
	protected $collConcursoCargoDedicacions;

	
	protected $lastConcursoCargoDedicacionCriteria = null;

	
	protected $collHistoricos;

	
	protected $lastHistoricoCriteria = null;

	
	protected $collConcursoNovedads;

	
	protected $lastConcursoNovedadCriteria = null;

	
	protected $collConcursoPlans;

	
	protected $lastConcursoPlanCriteria = null;

	
	protected $collConcursoCarreras;

	
	protected $lastConcursoCarreraCriteria = null;

	
	protected $collConcursoCargos;

	
	protected $lastConcursoCargoCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getNroExpFac()
	{

		return $this->nro_exp_fac;
	}

	
	public function getNombre()
	{

		return $this->nombre;
	}

	
	public function getInicioDate($format = '%d/%m/%Y')
	{

		if ($this->inicio_date === null || $this->inicio_date === '') {
			return null;
		} elseif (!is_int($this->inicio_date)) {
						$ts = strtotime($this->inicio_date);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [inicio_date] as date/time value: " . var_export($this->inicio_date, true));
			}
		} else {
			$ts = $this->inicio_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getResConvoca()
	{

		return $this->res_convoca;
	}

	
	public function getResDesigna()
	{

		return $this->res_designa;
	}

	
	public function getResDesignaFecha($format = '%d/%m/%Y')
	{

		if ($this->res_designa_fecha === null || $this->res_designa_fecha === '') {
			return null;
		} elseif (!is_int($this->res_designa_fecha)) {
						$ts = strtotime($this->res_designa_fecha);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [res_designa_fecha] as date/time value: " . var_export($this->res_designa_fecha, true));
			}
		} else {
			$ts = $this->res_designa_fecha;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getClasepublicaDate($format = '%d/%m/%Y')
	{

		if ($this->clasepublica_date === null || $this->clasepublica_date === '') {
			return null;
		} elseif (!is_int($this->clasepublica_date)) {
						$ts = strtotime($this->clasepublica_date);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [clasepublica_date] as date/time value: " . var_export($this->clasepublica_date, true));
			}
		} else {
			$ts = $this->clasepublica_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getConCarrerasId()
	{

		return $this->con_carreras_id;
	}

	
	public function getConSedesId()
	{

		return $this->con_sedes_id;
	}

	
	public function getConFacultadesId()
	{

		return $this->con_facultades_id;
	}

	
	public function getConMateriasId()
	{

		return $this->con_materias_id;
	}

	
	public function getConDedicacionesId()
	{

		return $this->con_dedicaciones_id;
	}

	
	public function getConCargosId()
	{

		return $this->con_cargos_id;
	}

	
	public function getCarreraMateriaId()
	{

		return $this->carrera_materia_id;
	}

	
	public function getConResolucionId()
	{

		return $this->con_resolucion_id;
	}

	
	public function getObservacion()
	{

		return $this->observacion;
	}

	
	public function getCantidadManual()
	{

		return $this->cantidad_manual;
	}

	
	public function getAspiranteNombre()
	{

		return $this->aspirante_nombre;
	}

	
	public function getAspiranteApellido()
	{

		return $this->aspirante_apellido;
	}

	
	public function getAspiranteDni()
	{

		return $this->aspirante_dni;
	}

	
	public function getAspiranteTitulo()
	{

		return $this->aspirante_titulo;
	}

	
	public function getDesierto()
	{

		return $this->desierto;
	}

	
	public function getSuspendido()
	{

		return $this->suspendido;
	}

	
	public function getTransferido()
	{

		return $this->transferido;
	}

	
	public function getIsTramite()
	{

		return $this->is_tramite;
	}

	
	public function getCantCargosConv()
	{

		return $this->cant_cargos_conv;
	}

	
	public function getConEstadoId()
	{

		return $this->con_estado_id;
	}

	
	public function getConResultadoId()
	{

		return $this->con_resultado_id;
	}

	
	public function getCreatedAt($format = 'd/m/Y H:i:s')
	{

		if ($this->created_at === null || $this->created_at === '') {
			return null;
		} elseif (!is_int($this->created_at)) {
						$ts = strtotime($this->created_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [created_at] as date/time value: " . var_export($this->created_at, true));
			}
		} else {
			$ts = $this->created_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ConcursoPeer::ID;
		}

	} 
	
	public function setNroExpFac($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nro_exp_fac !== $v) {
			$this->nro_exp_fac = $v;
			$this->modifiedColumns[] = ConcursoPeer::NRO_EXP_FAC;
		}

	} 
	
	public function setNombre($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nombre !== $v) {
			$this->nombre = $v;
			$this->modifiedColumns[] = ConcursoPeer::NOMBRE;
		}

	} 
	
	public function setInicioDate($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [inicio_date] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->inicio_date !== $ts) {
			$this->inicio_date = $ts;
			$this->modifiedColumns[] = ConcursoPeer::INICIO_DATE;
		}

	} 
	
	public function setResConvoca($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->res_convoca !== $v) {
			$this->res_convoca = $v;
			$this->modifiedColumns[] = ConcursoPeer::RES_CONVOCA;
		}

	} 
	
	public function setResDesigna($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->res_designa !== $v) {
			$this->res_designa = $v;
			$this->modifiedColumns[] = ConcursoPeer::RES_DESIGNA;
		}

	} 
	
	public function setResDesignaFecha($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [res_designa_fecha] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->res_designa_fecha !== $ts) {
			$this->res_designa_fecha = $ts;
			$this->modifiedColumns[] = ConcursoPeer::RES_DESIGNA_FECHA;
		}

	} 
	
	public function setClasepublicaDate($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [clasepublica_date] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->clasepublica_date !== $ts) {
			$this->clasepublica_date = $ts;
			$this->modifiedColumns[] = ConcursoPeer::CLASEPUBLICA_DATE;
		}

	} 
	
	public function setConCarrerasId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_carreras_id !== $v) {
			$this->con_carreras_id = $v;
			$this->modifiedColumns[] = ConcursoPeer::CON_CARRERAS_ID;
		}

		if ($this->aCarrera !== null && $this->aCarrera->getId() !== $v) {
			$this->aCarrera = null;
		}

	} 
	
	public function setConSedesId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_sedes_id !== $v) {
			$this->con_sedes_id = $v;
			$this->modifiedColumns[] = ConcursoPeer::CON_SEDES_ID;
		}

		if ($this->aSede !== null && $this->aSede->getId() !== $v) {
			$this->aSede = null;
		}

	} 
	
	public function setConFacultadesId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_facultades_id !== $v) {
			$this->con_facultades_id = $v;
			$this->modifiedColumns[] = ConcursoPeer::CON_FACULTADES_ID;
		}

		if ($this->aFacultad !== null && $this->aFacultad->getId() !== $v) {
			$this->aFacultad = null;
		}

	} 
	
	public function setConMateriasId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_materias_id !== $v) {
			$this->con_materias_id = $v;
			$this->modifiedColumns[] = ConcursoPeer::CON_MATERIAS_ID;
		}

		if ($this->aMateria !== null && $this->aMateria->getId() !== $v) {
			$this->aMateria = null;
		}

	} 
	
	public function setConDedicacionesId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_dedicaciones_id !== $v) {
			$this->con_dedicaciones_id = $v;
			$this->modifiedColumns[] = ConcursoPeer::CON_DEDICACIONES_ID;
		}

		if ($this->aDedicacion !== null && $this->aDedicacion->getId() !== $v) {
			$this->aDedicacion = null;
		}

	} 
	
	public function setConCargosId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_cargos_id !== $v) {
			$this->con_cargos_id = $v;
			$this->modifiedColumns[] = ConcursoPeer::CON_CARGOS_ID;
		}

		if ($this->aCargo !== null && $this->aCargo->getId() !== $v) {
			$this->aCargo = null;
		}

	} 
	
	public function setCarreraMateriaId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->carrera_materia_id !== $v) {
			$this->carrera_materia_id = $v;
			$this->modifiedColumns[] = ConcursoPeer::CARRERA_MATERIA_ID;
		}

		if ($this->aCarreraMateria !== null && $this->aCarreraMateria->getId() !== $v) {
			$this->aCarreraMateria = null;
		}

	} 
	
	public function setConResolucionId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_resolucion_id !== $v) {
			$this->con_resolucion_id = $v;
			$this->modifiedColumns[] = ConcursoPeer::CON_RESOLUCION_ID;
		}

		if ($this->aResolucion !== null && $this->aResolucion->getId() !== $v) {
			$this->aResolucion = null;
		}

	} 
	
	public function setObservacion($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->observacion !== $v) {
			$this->observacion = $v;
			$this->modifiedColumns[] = ConcursoPeer::OBSERVACION;
		}

	} 
	
	public function setCantidadManual($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->cantidad_manual !== $v || $v === 0) {
			$this->cantidad_manual = $v;
			$this->modifiedColumns[] = ConcursoPeer::CANTIDAD_MANUAL;
		}

	} 
	
	public function setAspiranteNombre($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->aspirante_nombre !== $v) {
			$this->aspirante_nombre = $v;
			$this->modifiedColumns[] = ConcursoPeer::ASPIRANTE_NOMBRE;
		}

	} 
	
	public function setAspiranteApellido($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->aspirante_apellido !== $v) {
			$this->aspirante_apellido = $v;
			$this->modifiedColumns[] = ConcursoPeer::ASPIRANTE_APELLIDO;
		}

	} 
	
	public function setAspiranteDni($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->aspirante_dni !== $v) {
			$this->aspirante_dni = $v;
			$this->modifiedColumns[] = ConcursoPeer::ASPIRANTE_DNI;
		}

	} 
	
	public function setAspiranteTitulo($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->aspirante_titulo !== $v) {
			$this->aspirante_titulo = $v;
			$this->modifiedColumns[] = ConcursoPeer::ASPIRANTE_TITULO;
		}

	} 
	
	public function setDesierto($v)
	{

		if ($this->desierto !== $v || $v === false) {
			$this->desierto = $v;
			$this->modifiedColumns[] = ConcursoPeer::DESIERTO;
		}

	} 
	
	public function setSuspendido($v)
	{

		if ($this->suspendido !== $v || $v === false) {
			$this->suspendido = $v;
			$this->modifiedColumns[] = ConcursoPeer::SUSPENDIDO;
		}

	} 
	
	public function setTransferido($v)
	{

		if ($this->transferido !== $v || $v === false) {
			$this->transferido = $v;
			$this->modifiedColumns[] = ConcursoPeer::TRANSFERIDO;
		}

	} 
	
	public function setIsTramite($v)
	{

		if ($this->is_tramite !== $v || $v === false) {
			$this->is_tramite = $v;
			$this->modifiedColumns[] = ConcursoPeer::IS_TRAMITE;
		}

	} 
	
	public function setCantCargosConv($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->cant_cargos_conv !== $v) {
			$this->cant_cargos_conv = $v;
			$this->modifiedColumns[] = ConcursoPeer::CANT_CARGOS_CONV;
		}

	} 
	
	public function setConEstadoId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_estado_id !== $v) {
			$this->con_estado_id = $v;
			$this->modifiedColumns[] = ConcursoPeer::CON_ESTADO_ID;
		}

		if ($this->aEstado !== null && $this->aEstado->getId() !== $v) {
			$this->aEstado = null;
		}

	} 
	
	public function setConResultadoId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_resultado_id !== $v) {
			$this->con_resultado_id = $v;
			$this->modifiedColumns[] = ConcursoPeer::CON_RESULTADO_ID;
		}

		if ($this->aResultado !== null && $this->aResultado->getId() !== $v) {
			$this->aResultado = null;
		}

	} 
	
	public function setCreatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [created_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->created_at !== $ts) {
			$this->created_at = $ts;
			$this->modifiedColumns[] = ConcursoPeer::CREATED_AT;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->nro_exp_fac = $rs->getString($startcol + 1);

			$this->nombre = $rs->getString($startcol + 2);

			$this->inicio_date = $rs->getDate($startcol + 3, null);

			$this->res_convoca = $rs->getString($startcol + 4);

			$this->res_designa = $rs->getString($startcol + 5);

			$this->res_designa_fecha = $rs->getDate($startcol + 6, null);

			$this->clasepublica_date = $rs->getDate($startcol + 7, null);

			$this->con_carreras_id = $rs->getInt($startcol + 8);

			$this->con_sedes_id = $rs->getInt($startcol + 9);

			$this->con_facultades_id = $rs->getInt($startcol + 10);

			$this->con_materias_id = $rs->getInt($startcol + 11);

			$this->con_dedicaciones_id = $rs->getInt($startcol + 12);

			$this->con_cargos_id = $rs->getInt($startcol + 13);

			$this->carrera_materia_id = $rs->getInt($startcol + 14);

			$this->con_resolucion_id = $rs->getInt($startcol + 15);

			$this->observacion = $rs->getString($startcol + 16);

			$this->cantidad_manual = $rs->getInt($startcol + 17);

			$this->aspirante_nombre = $rs->getString($startcol + 18);

			$this->aspirante_apellido = $rs->getString($startcol + 19);

			$this->aspirante_dni = $rs->getString($startcol + 20);

			$this->aspirante_titulo = $rs->getString($startcol + 21);

			$this->desierto = $rs->getBoolean($startcol + 22);

			$this->suspendido = $rs->getBoolean($startcol + 23);

			$this->transferido = $rs->getBoolean($startcol + 24);

			$this->is_tramite = $rs->getBoolean($startcol + 25);

			$this->cant_cargos_conv = $rs->getInt($startcol + 26);

			$this->con_estado_id = $rs->getInt($startcol + 27);

			$this->con_resultado_id = $rs->getInt($startcol + 28);

			$this->created_at = $rs->getTimestamp($startcol + 29, null);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 30; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Concurso object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseConcurso:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ConcursoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			ConcursoPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseConcurso:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseConcurso:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


    if ($this->isNew() && !$this->isColumnModified(ConcursoPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ConcursoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseConcurso:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aCarrera !== null) {
				if ($this->aCarrera->isModified()) {
					$affectedRows += $this->aCarrera->save($con);
				}
				$this->setCarrera($this->aCarrera);
			}

			if ($this->aSede !== null) {
				if ($this->aSede->isModified()) {
					$affectedRows += $this->aSede->save($con);
				}
				$this->setSede($this->aSede);
			}

			if ($this->aFacultad !== null) {
				if ($this->aFacultad->isModified()) {
					$affectedRows += $this->aFacultad->save($con);
				}
				$this->setFacultad($this->aFacultad);
			}

			if ($this->aMateria !== null) {
				if ($this->aMateria->isModified()) {
					$affectedRows += $this->aMateria->save($con);
				}
				$this->setMateria($this->aMateria);
			}

			if ($this->aDedicacion !== null) {
				if ($this->aDedicacion->isModified()) {
					$affectedRows += $this->aDedicacion->save($con);
				}
				$this->setDedicacion($this->aDedicacion);
			}

			if ($this->aCargo !== null) {
				if ($this->aCargo->isModified()) {
					$affectedRows += $this->aCargo->save($con);
				}
				$this->setCargo($this->aCargo);
			}

			if ($this->aCarreraMateria !== null) {
				if ($this->aCarreraMateria->isModified()) {
					$affectedRows += $this->aCarreraMateria->save($con);
				}
				$this->setCarreraMateria($this->aCarreraMateria);
			}

			if ($this->aResolucion !== null) {
				if ($this->aResolucion->isModified()) {
					$affectedRows += $this->aResolucion->save($con);
				}
				$this->setResolucion($this->aResolucion);
			}

			if ($this->aEstado !== null) {
				if ($this->aEstado->isModified()) {
					$affectedRows += $this->aEstado->save($con);
				}
				$this->setEstado($this->aEstado);
			}

			if ($this->aResultado !== null) {
				if ($this->aResultado->isModified()) {
					$affectedRows += $this->aResultado->save($con);
				}
				$this->setResultado($this->aResultado);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ConcursoPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ConcursoPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collConcursoAspirantes !== null) {
				foreach($this->collConcursoAspirantes as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collConcursoJurados !== null) {
				foreach($this->collConcursoJurados as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collConcursoCargoDedicacions !== null) {
				foreach($this->collConcursoCargoDedicacions as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collHistoricos !== null) {
				foreach($this->collHistoricos as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collConcursoNovedads !== null) {
				foreach($this->collConcursoNovedads as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collConcursoPlans !== null) {
				foreach($this->collConcursoPlans as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collConcursoCarreras !== null) {
				foreach($this->collConcursoCarreras as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collConcursoCargos !== null) {
				foreach($this->collConcursoCargos as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aCarrera !== null) {
				if (!$this->aCarrera->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aCarrera->getValidationFailures());
				}
			}

			if ($this->aSede !== null) {
				if (!$this->aSede->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aSede->getValidationFailures());
				}
			}

			if ($this->aFacultad !== null) {
				if (!$this->aFacultad->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aFacultad->getValidationFailures());
				}
			}

			if ($this->aMateria !== null) {
				if (!$this->aMateria->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aMateria->getValidationFailures());
				}
			}

			if ($this->aDedicacion !== null) {
				if (!$this->aDedicacion->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aDedicacion->getValidationFailures());
				}
			}

			if ($this->aCargo !== null) {
				if (!$this->aCargo->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aCargo->getValidationFailures());
				}
			}

			if ($this->aCarreraMateria !== null) {
				if (!$this->aCarreraMateria->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aCarreraMateria->getValidationFailures());
				}
			}

			if ($this->aResolucion !== null) {
				if (!$this->aResolucion->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aResolucion->getValidationFailures());
				}
			}

			if ($this->aEstado !== null) {
				if (!$this->aEstado->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aEstado->getValidationFailures());
				}
			}

			if ($this->aResultado !== null) {
				if (!$this->aResultado->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aResultado->getValidationFailures());
				}
			}


			if (($retval = ConcursoPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collConcursoAspirantes !== null) {
					foreach($this->collConcursoAspirantes as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collConcursoJurados !== null) {
					foreach($this->collConcursoJurados as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collConcursoCargoDedicacions !== null) {
					foreach($this->collConcursoCargoDedicacions as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collHistoricos !== null) {
					foreach($this->collHistoricos as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collConcursoNovedads !== null) {
					foreach($this->collConcursoNovedads as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collConcursoPlans !== null) {
					foreach($this->collConcursoPlans as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collConcursoCarreras !== null) {
					foreach($this->collConcursoCarreras as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collConcursoCargos !== null) {
					foreach($this->collConcursoCargos as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ConcursoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getNroExpFac();
				break;
			case 2:
				return $this->getNombre();
				break;
			case 3:
				return $this->getInicioDate();
				break;
			case 4:
				return $this->getResConvoca();
				break;
			case 5:
				return $this->getResDesigna();
				break;
			case 6:
				return $this->getResDesignaFecha();
				break;
			case 7:
				return $this->getClasepublicaDate();
				break;
			case 8:
				return $this->getConCarrerasId();
				break;
			case 9:
				return $this->getConSedesId();
				break;
			case 10:
				return $this->getConFacultadesId();
				break;
			case 11:
				return $this->getConMateriasId();
				break;
			case 12:
				return $this->getConDedicacionesId();
				break;
			case 13:
				return $this->getConCargosId();
				break;
			case 14:
				return $this->getCarreraMateriaId();
				break;
			case 15:
				return $this->getConResolucionId();
				break;
			case 16:
				return $this->getObservacion();
				break;
			case 17:
				return $this->getCantidadManual();
				break;
			case 18:
				return $this->getAspiranteNombre();
				break;
			case 19:
				return $this->getAspiranteApellido();
				break;
			case 20:
				return $this->getAspiranteDni();
				break;
			case 21:
				return $this->getAspiranteTitulo();
				break;
			case 22:
				return $this->getDesierto();
				break;
			case 23:
				return $this->getSuspendido();
				break;
			case 24:
				return $this->getTransferido();
				break;
			case 25:
				return $this->getIsTramite();
				break;
			case 26:
				return $this->getCantCargosConv();
				break;
			case 27:
				return $this->getConEstadoId();
				break;
			case 28:
				return $this->getConResultadoId();
				break;
			case 29:
				return $this->getCreatedAt();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ConcursoPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getNroExpFac(),
			$keys[2] => $this->getNombre(),
			$keys[3] => $this->getInicioDate(),
			$keys[4] => $this->getResConvoca(),
			$keys[5] => $this->getResDesigna(),
			$keys[6] => $this->getResDesignaFecha(),
			$keys[7] => $this->getClasepublicaDate(),
			$keys[8] => $this->getConCarrerasId(),
			$keys[9] => $this->getConSedesId(),
			$keys[10] => $this->getConFacultadesId(),
			$keys[11] => $this->getConMateriasId(),
			$keys[12] => $this->getConDedicacionesId(),
			$keys[13] => $this->getConCargosId(),
			$keys[14] => $this->getCarreraMateriaId(),
			$keys[15] => $this->getConResolucionId(),
			$keys[16] => $this->getObservacion(),
			$keys[17] => $this->getCantidadManual(),
			$keys[18] => $this->getAspiranteNombre(),
			$keys[19] => $this->getAspiranteApellido(),
			$keys[20] => $this->getAspiranteDni(),
			$keys[21] => $this->getAspiranteTitulo(),
			$keys[22] => $this->getDesierto(),
			$keys[23] => $this->getSuspendido(),
			$keys[24] => $this->getTransferido(),
			$keys[25] => $this->getIsTramite(),
			$keys[26] => $this->getCantCargosConv(),
			$keys[27] => $this->getConEstadoId(),
			$keys[28] => $this->getConResultadoId(),
			$keys[29] => $this->getCreatedAt(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ConcursoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setNroExpFac($value);
				break;
			case 2:
				$this->setNombre($value);
				break;
			case 3:
				$this->setInicioDate($value);
				break;
			case 4:
				$this->setResConvoca($value);
				break;
			case 5:
				$this->setResDesigna($value);
				break;
			case 6:
				$this->setResDesignaFecha($value);
				break;
			case 7:
				$this->setClasepublicaDate($value);
				break;
			case 8:
				$this->setConCarrerasId($value);
				break;
			case 9:
				$this->setConSedesId($value);
				break;
			case 10:
				$this->setConFacultadesId($value);
				break;
			case 11:
				$this->setConMateriasId($value);
				break;
			case 12:
				$this->setConDedicacionesId($value);
				break;
			case 13:
				$this->setConCargosId($value);
				break;
			case 14:
				$this->setCarreraMateriaId($value);
				break;
			case 15:
				$this->setConResolucionId($value);
				break;
			case 16:
				$this->setObservacion($value);
				break;
			case 17:
				$this->setCantidadManual($value);
				break;
			case 18:
				$this->setAspiranteNombre($value);
				break;
			case 19:
				$this->setAspiranteApellido($value);
				break;
			case 20:
				$this->setAspiranteDni($value);
				break;
			case 21:
				$this->setAspiranteTitulo($value);
				break;
			case 22:
				$this->setDesierto($value);
				break;
			case 23:
				$this->setSuspendido($value);
				break;
			case 24:
				$this->setTransferido($value);
				break;
			case 25:
				$this->setIsTramite($value);
				break;
			case 26:
				$this->setCantCargosConv($value);
				break;
			case 27:
				$this->setConEstadoId($value);
				break;
			case 28:
				$this->setConResultadoId($value);
				break;
			case 29:
				$this->setCreatedAt($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ConcursoPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setNroExpFac($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setNombre($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setInicioDate($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setResConvoca($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setResDesigna($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setResDesignaFecha($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setClasepublicaDate($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setConCarrerasId($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setConSedesId($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setConFacultadesId($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setConMateriasId($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setConDedicacionesId($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setConCargosId($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setCarreraMateriaId($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setConResolucionId($arr[$keys[15]]);
		if (array_key_exists($keys[16], $arr)) $this->setObservacion($arr[$keys[16]]);
		if (array_key_exists($keys[17], $arr)) $this->setCantidadManual($arr[$keys[17]]);
		if (array_key_exists($keys[18], $arr)) $this->setAspiranteNombre($arr[$keys[18]]);
		if (array_key_exists($keys[19], $arr)) $this->setAspiranteApellido($arr[$keys[19]]);
		if (array_key_exists($keys[20], $arr)) $this->setAspiranteDni($arr[$keys[20]]);
		if (array_key_exists($keys[21], $arr)) $this->setAspiranteTitulo($arr[$keys[21]]);
		if (array_key_exists($keys[22], $arr)) $this->setDesierto($arr[$keys[22]]);
		if (array_key_exists($keys[23], $arr)) $this->setSuspendido($arr[$keys[23]]);
		if (array_key_exists($keys[24], $arr)) $this->setTransferido($arr[$keys[24]]);
		if (array_key_exists($keys[25], $arr)) $this->setIsTramite($arr[$keys[25]]);
		if (array_key_exists($keys[26], $arr)) $this->setCantCargosConv($arr[$keys[26]]);
		if (array_key_exists($keys[27], $arr)) $this->setConEstadoId($arr[$keys[27]]);
		if (array_key_exists($keys[28], $arr)) $this->setConResultadoId($arr[$keys[28]]);
		if (array_key_exists($keys[29], $arr)) $this->setCreatedAt($arr[$keys[29]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ConcursoPeer::DATABASE_NAME);

		if ($this->isColumnModified(ConcursoPeer::ID)) $criteria->add(ConcursoPeer::ID, $this->id);
		if ($this->isColumnModified(ConcursoPeer::NRO_EXP_FAC)) $criteria->add(ConcursoPeer::NRO_EXP_FAC, $this->nro_exp_fac);
		if ($this->isColumnModified(ConcursoPeer::NOMBRE)) $criteria->add(ConcursoPeer::NOMBRE, $this->nombre);
		if ($this->isColumnModified(ConcursoPeer::INICIO_DATE)) $criteria->add(ConcursoPeer::INICIO_DATE, $this->inicio_date);
		if ($this->isColumnModified(ConcursoPeer::RES_CONVOCA)) $criteria->add(ConcursoPeer::RES_CONVOCA, $this->res_convoca);
		if ($this->isColumnModified(ConcursoPeer::RES_DESIGNA)) $criteria->add(ConcursoPeer::RES_DESIGNA, $this->res_designa);
		if ($this->isColumnModified(ConcursoPeer::RES_DESIGNA_FECHA)) $criteria->add(ConcursoPeer::RES_DESIGNA_FECHA, $this->res_designa_fecha);
		if ($this->isColumnModified(ConcursoPeer::CLASEPUBLICA_DATE)) $criteria->add(ConcursoPeer::CLASEPUBLICA_DATE, $this->clasepublica_date);
		if ($this->isColumnModified(ConcursoPeer::CON_CARRERAS_ID)) $criteria->add(ConcursoPeer::CON_CARRERAS_ID, $this->con_carreras_id);
		if ($this->isColumnModified(ConcursoPeer::CON_SEDES_ID)) $criteria->add(ConcursoPeer::CON_SEDES_ID, $this->con_sedes_id);
		if ($this->isColumnModified(ConcursoPeer::CON_FACULTADES_ID)) $criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->con_facultades_id);
		if ($this->isColumnModified(ConcursoPeer::CON_MATERIAS_ID)) $criteria->add(ConcursoPeer::CON_MATERIAS_ID, $this->con_materias_id);
		if ($this->isColumnModified(ConcursoPeer::CON_DEDICACIONES_ID)) $criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->con_dedicaciones_id);
		if ($this->isColumnModified(ConcursoPeer::CON_CARGOS_ID)) $criteria->add(ConcursoPeer::CON_CARGOS_ID, $this->con_cargos_id);
		if ($this->isColumnModified(ConcursoPeer::CARRERA_MATERIA_ID)) $criteria->add(ConcursoPeer::CARRERA_MATERIA_ID, $this->carrera_materia_id);
		if ($this->isColumnModified(ConcursoPeer::CON_RESOLUCION_ID)) $criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->con_resolucion_id);
		if ($this->isColumnModified(ConcursoPeer::OBSERVACION)) $criteria->add(ConcursoPeer::OBSERVACION, $this->observacion);
		if ($this->isColumnModified(ConcursoPeer::CANTIDAD_MANUAL)) $criteria->add(ConcursoPeer::CANTIDAD_MANUAL, $this->cantidad_manual);
		if ($this->isColumnModified(ConcursoPeer::ASPIRANTE_NOMBRE)) $criteria->add(ConcursoPeer::ASPIRANTE_NOMBRE, $this->aspirante_nombre);
		if ($this->isColumnModified(ConcursoPeer::ASPIRANTE_APELLIDO)) $criteria->add(ConcursoPeer::ASPIRANTE_APELLIDO, $this->aspirante_apellido);
		if ($this->isColumnModified(ConcursoPeer::ASPIRANTE_DNI)) $criteria->add(ConcursoPeer::ASPIRANTE_DNI, $this->aspirante_dni);
		if ($this->isColumnModified(ConcursoPeer::ASPIRANTE_TITULO)) $criteria->add(ConcursoPeer::ASPIRANTE_TITULO, $this->aspirante_titulo);
		if ($this->isColumnModified(ConcursoPeer::DESIERTO)) $criteria->add(ConcursoPeer::DESIERTO, $this->desierto);
		if ($this->isColumnModified(ConcursoPeer::SUSPENDIDO)) $criteria->add(ConcursoPeer::SUSPENDIDO, $this->suspendido);
		if ($this->isColumnModified(ConcursoPeer::TRANSFERIDO)) $criteria->add(ConcursoPeer::TRANSFERIDO, $this->transferido);
		if ($this->isColumnModified(ConcursoPeer::IS_TRAMITE)) $criteria->add(ConcursoPeer::IS_TRAMITE, $this->is_tramite);
		if ($this->isColumnModified(ConcursoPeer::CANT_CARGOS_CONV)) $criteria->add(ConcursoPeer::CANT_CARGOS_CONV, $this->cant_cargos_conv);
		if ($this->isColumnModified(ConcursoPeer::CON_ESTADO_ID)) $criteria->add(ConcursoPeer::CON_ESTADO_ID, $this->con_estado_id);
		if ($this->isColumnModified(ConcursoPeer::CON_RESULTADO_ID)) $criteria->add(ConcursoPeer::CON_RESULTADO_ID, $this->con_resultado_id);
		if ($this->isColumnModified(ConcursoPeer::CREATED_AT)) $criteria->add(ConcursoPeer::CREATED_AT, $this->created_at);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ConcursoPeer::DATABASE_NAME);

		$criteria->add(ConcursoPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setNroExpFac($this->nro_exp_fac);

		$copyObj->setNombre($this->nombre);

		$copyObj->setInicioDate($this->inicio_date);

		$copyObj->setResConvoca($this->res_convoca);

		$copyObj->setResDesigna($this->res_designa);

		$copyObj->setResDesignaFecha($this->res_designa_fecha);

		$copyObj->setClasepublicaDate($this->clasepublica_date);

		$copyObj->setConCarrerasId($this->con_carreras_id);

		$copyObj->setConSedesId($this->con_sedes_id);

		$copyObj->setConFacultadesId($this->con_facultades_id);

		$copyObj->setConMateriasId($this->con_materias_id);

		$copyObj->setConDedicacionesId($this->con_dedicaciones_id);

		$copyObj->setConCargosId($this->con_cargos_id);

		$copyObj->setCarreraMateriaId($this->carrera_materia_id);

		$copyObj->setConResolucionId($this->con_resolucion_id);

		$copyObj->setObservacion($this->observacion);

		$copyObj->setCantidadManual($this->cantidad_manual);

		$copyObj->setAspiranteNombre($this->aspirante_nombre);

		$copyObj->setAspiranteApellido($this->aspirante_apellido);

		$copyObj->setAspiranteDni($this->aspirante_dni);

		$copyObj->setAspiranteTitulo($this->aspirante_titulo);

		$copyObj->setDesierto($this->desierto);

		$copyObj->setSuspendido($this->suspendido);

		$copyObj->setTransferido($this->transferido);

		$copyObj->setIsTramite($this->is_tramite);

		$copyObj->setCantCargosConv($this->cant_cargos_conv);

		$copyObj->setConEstadoId($this->con_estado_id);

		$copyObj->setConResultadoId($this->con_resultado_id);

		$copyObj->setCreatedAt($this->created_at);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getConcursoAspirantes() as $relObj) {
				$copyObj->addConcursoAspirante($relObj->copy($deepCopy));
			}

			foreach($this->getConcursoJurados() as $relObj) {
				$copyObj->addConcursoJurado($relObj->copy($deepCopy));
			}

			foreach($this->getConcursoCargoDedicacions() as $relObj) {
				$copyObj->addConcursoCargoDedicacion($relObj->copy($deepCopy));
			}

			foreach($this->getHistoricos() as $relObj) {
				$copyObj->addHistorico($relObj->copy($deepCopy));
			}

			foreach($this->getConcursoNovedads() as $relObj) {
				$copyObj->addConcursoNovedad($relObj->copy($deepCopy));
			}

			foreach($this->getConcursoPlans() as $relObj) {
				$copyObj->addConcursoPlan($relObj->copy($deepCopy));
			}

			foreach($this->getConcursoCarreras() as $relObj) {
				$copyObj->addConcursoCarrera($relObj->copy($deepCopy));
			}

			foreach($this->getConcursoCargos() as $relObj) {
				$copyObj->addConcursoCargo($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ConcursoPeer();
		}
		return self::$peer;
	}

	
	public function setCarrera($v)
	{


		if ($v === null) {
			$this->setConCarrerasId(NULL);
		} else {
			$this->setConCarrerasId($v->getId());
		}


		$this->aCarrera = $v;
	}


	
	public function getCarrera($con = null)
	{
		if ($this->aCarrera === null && ($this->con_carreras_id !== null)) {
						include_once 'lib/model/om/BaseCarreraPeer.php';

			$this->aCarrera = CarreraPeer::retrieveByPK($this->con_carreras_id, $con);

			
		}
		return $this->aCarrera;
	}

	
	public function setSede($v)
	{


		if ($v === null) {
			$this->setConSedesId(NULL);
		} else {
			$this->setConSedesId($v->getId());
		}


		$this->aSede = $v;
	}


	
	public function getSede($con = null)
	{
		if ($this->aSede === null && ($this->con_sedes_id !== null)) {
						include_once 'lib/model/om/BaseSedePeer.php';

			$this->aSede = SedePeer::retrieveByPK($this->con_sedes_id, $con);

			
		}
		return $this->aSede;
	}

	
	public function setFacultad($v)
	{


		if ($v === null) {
			$this->setConFacultadesId(NULL);
		} else {
			$this->setConFacultadesId($v->getId());
		}


		$this->aFacultad = $v;
	}


	
	public function getFacultad($con = null)
	{
		if ($this->aFacultad === null && ($this->con_facultades_id !== null)) {
						include_once 'lib/model/om/BaseFacultadPeer.php';

			$this->aFacultad = FacultadPeer::retrieveByPK($this->con_facultades_id, $con);

			
		}
		return $this->aFacultad;
	}

	
	public function setMateria($v)
	{


		if ($v === null) {
			$this->setConMateriasId(NULL);
		} else {
			$this->setConMateriasId($v->getId());
		}


		$this->aMateria = $v;
	}


	
	public function getMateria($con = null)
	{
		if ($this->aMateria === null && ($this->con_materias_id !== null)) {
						include_once 'lib/model/om/BaseMateriaPeer.php';

			$this->aMateria = MateriaPeer::retrieveByPK($this->con_materias_id, $con);

			
		}
		return $this->aMateria;
	}

	
	public function setDedicacion($v)
	{


		if ($v === null) {
			$this->setConDedicacionesId(NULL);
		} else {
			$this->setConDedicacionesId($v->getId());
		}


		$this->aDedicacion = $v;
	}


	
	public function getDedicacion($con = null)
	{
		if ($this->aDedicacion === null && ($this->con_dedicaciones_id !== null)) {
						include_once 'lib/model/om/BaseDedicacionPeer.php';

			$this->aDedicacion = DedicacionPeer::retrieveByPK($this->con_dedicaciones_id, $con);

			
		}
		return $this->aDedicacion;
	}

	
	public function setCargo($v)
	{


		if ($v === null) {
			$this->setConCargosId(NULL);
		} else {
			$this->setConCargosId($v->getId());
		}


		$this->aCargo = $v;
	}


	
	public function getCargo($con = null)
	{
		if ($this->aCargo === null && ($this->con_cargos_id !== null)) {
						include_once 'lib/model/om/BaseCargoPeer.php';

			$this->aCargo = CargoPeer::retrieveByPK($this->con_cargos_id, $con);

			
		}
		return $this->aCargo;
	}

	
	public function setCarreraMateria($v)
	{


		if ($v === null) {
			$this->setCarreraMateriaId(NULL);
		} else {
			$this->setCarreraMateriaId($v->getId());
		}


		$this->aCarreraMateria = $v;
	}


	
	public function getCarreraMateria($con = null)
	{
		if ($this->aCarreraMateria === null && ($this->carrera_materia_id !== null)) {
						include_once 'lib/model/om/BaseCarreraMateriaPeer.php';

			$this->aCarreraMateria = CarreraMateriaPeer::retrieveByPK($this->carrera_materia_id, $con);

			
		}
		return $this->aCarreraMateria;
	}

	
	public function setResolucion($v)
	{


		if ($v === null) {
			$this->setConResolucionId(NULL);
		} else {
			$this->setConResolucionId($v->getId());
		}


		$this->aResolucion = $v;
	}


	
	public function getResolucion($con = null)
	{
		if ($this->aResolucion === null && ($this->con_resolucion_id !== null)) {
						include_once 'lib/model/om/BaseResolucionPeer.php';

			$this->aResolucion = ResolucionPeer::retrieveByPK($this->con_resolucion_id, $con);

			
		}
		return $this->aResolucion;
	}

	
	public function setEstado($v)
	{


		if ($v === null) {
			$this->setConEstadoId(NULL);
		} else {
			$this->setConEstadoId($v->getId());
		}


		$this->aEstado = $v;
	}


	
	public function getEstado($con = null)
	{
		if ($this->aEstado === null && ($this->con_estado_id !== null)) {
						include_once 'lib/model/om/BaseEstadoPeer.php';

			$this->aEstado = EstadoPeer::retrieveByPK($this->con_estado_id, $con);

			
		}
		return $this->aEstado;
	}

	
	public function setResultado($v)
	{


		if ($v === null) {
			$this->setConResultadoId(NULL);
		} else {
			$this->setConResultadoId($v->getId());
		}


		$this->aResultado = $v;
	}


	
	public function getResultado($con = null)
	{
		if ($this->aResultado === null && ($this->con_resultado_id !== null)) {
						include_once 'lib/model/om/BaseResultadoPeer.php';

			$this->aResultado = ResultadoPeer::retrieveByPK($this->con_resultado_id, $con);

			
		}
		return $this->aResultado;
	}

	
	public function initConcursoAspirantes()
	{
		if ($this->collConcursoAspirantes === null) {
			$this->collConcursoAspirantes = array();
		}
	}

	
	public function getConcursoAspirantes($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoAspirantePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoAspirantes === null) {
			if ($this->isNew()) {
			   $this->collConcursoAspirantes = array();
			} else {

				$criteria->add(ConcursoAspirantePeer::CON_CONCURSOS_ID, $this->getId());

				ConcursoAspirantePeer::addSelectColumns($criteria);
				$this->collConcursoAspirantes = ConcursoAspirantePeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConcursoAspirantePeer::CON_CONCURSOS_ID, $this->getId());

				ConcursoAspirantePeer::addSelectColumns($criteria);
				if (!isset($this->lastConcursoAspiranteCriteria) || !$this->lastConcursoAspiranteCriteria->equals($criteria)) {
					$this->collConcursoAspirantes = ConcursoAspirantePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConcursoAspiranteCriteria = $criteria;
		return $this->collConcursoAspirantes;
	}

	
	public function countConcursoAspirantes($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoAspirantePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConcursoAspirantePeer::CON_CONCURSOS_ID, $this->getId());

		return ConcursoAspirantePeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConcursoAspirante(ConcursoAspirante $l)
	{
		$this->collConcursoAspirantes[] = $l;
		$l->setConcurso($this);
	}


	
	public function getConcursoAspirantesJoinAspirante($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoAspirantePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoAspirantes === null) {
			if ($this->isNew()) {
				$this->collConcursoAspirantes = array();
			} else {

				$criteria->add(ConcursoAspirantePeer::CON_CONCURSOS_ID, $this->getId());

				$this->collConcursoAspirantes = ConcursoAspirantePeer::doSelectJoinAspirante($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoAspirantePeer::CON_CONCURSOS_ID, $this->getId());

			if (!isset($this->lastConcursoAspiranteCriteria) || !$this->lastConcursoAspiranteCriteria->equals($criteria)) {
				$this->collConcursoAspirantes = ConcursoAspirantePeer::doSelectJoinAspirante($criteria, $con);
			}
		}
		$this->lastConcursoAspiranteCriteria = $criteria;

		return $this->collConcursoAspirantes;
	}

	
	public function initConcursoJurados()
	{
		if ($this->collConcursoJurados === null) {
			$this->collConcursoJurados = array();
		}
	}

	
	public function getConcursoJurados($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoJuradoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoJurados === null) {
			if ($this->isNew()) {
			   $this->collConcursoJurados = array();
			} else {

				$criteria->add(ConcursoJuradoPeer::CON_CONCURSOS_ID, $this->getId());

				ConcursoJuradoPeer::addSelectColumns($criteria);
				$this->collConcursoJurados = ConcursoJuradoPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConcursoJuradoPeer::CON_CONCURSOS_ID, $this->getId());

				ConcursoJuradoPeer::addSelectColumns($criteria);
				if (!isset($this->lastConcursoJuradoCriteria) || !$this->lastConcursoJuradoCriteria->equals($criteria)) {
					$this->collConcursoJurados = ConcursoJuradoPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConcursoJuradoCriteria = $criteria;
		return $this->collConcursoJurados;
	}

	
	public function countConcursoJurados($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoJuradoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConcursoJuradoPeer::CON_CONCURSOS_ID, $this->getId());

		return ConcursoJuradoPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConcursoJurado(ConcursoJurado $l)
	{
		$this->collConcursoJurados[] = $l;
		$l->setConcurso($this);
	}


	
	public function getConcursoJuradosJoinJurado($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoJuradoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoJurados === null) {
			if ($this->isNew()) {
				$this->collConcursoJurados = array();
			} else {

				$criteria->add(ConcursoJuradoPeer::CON_CONCURSOS_ID, $this->getId());

				$this->collConcursoJurados = ConcursoJuradoPeer::doSelectJoinJurado($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoJuradoPeer::CON_CONCURSOS_ID, $this->getId());

			if (!isset($this->lastConcursoJuradoCriteria) || !$this->lastConcursoJuradoCriteria->equals($criteria)) {
				$this->collConcursoJurados = ConcursoJuradoPeer::doSelectJoinJurado($criteria, $con);
			}
		}
		$this->lastConcursoJuradoCriteria = $criteria;

		return $this->collConcursoJurados;
	}

	
	public function initConcursoCargoDedicacions()
	{
		if ($this->collConcursoCargoDedicacions === null) {
			$this->collConcursoCargoDedicacions = array();
		}
	}

	
	public function getConcursoCargoDedicacions($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoDedicacionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargoDedicacions === null) {
			if ($this->isNew()) {
			   $this->collConcursoCargoDedicacions = array();
			} else {

				$criteria->add(ConcursoCargoDedicacionPeer::CON_CONCURSOS_ID, $this->getId());

				ConcursoCargoDedicacionPeer::addSelectColumns($criteria);
				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConcursoCargoDedicacionPeer::CON_CONCURSOS_ID, $this->getId());

				ConcursoCargoDedicacionPeer::addSelectColumns($criteria);
				if (!isset($this->lastConcursoCargoDedicacionCriteria) || !$this->lastConcursoCargoDedicacionCriteria->equals($criteria)) {
					$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConcursoCargoDedicacionCriteria = $criteria;
		return $this->collConcursoCargoDedicacions;
	}

	
	public function countConcursoCargoDedicacions($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoDedicacionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConcursoCargoDedicacionPeer::CON_CONCURSOS_ID, $this->getId());

		return ConcursoCargoDedicacionPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConcursoCargoDedicacion(ConcursoCargoDedicacion $l)
	{
		$this->collConcursoCargoDedicacions[] = $l;
		$l->setConcurso($this);
	}


	
	public function getConcursoCargoDedicacionsJoinCargo($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoDedicacionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargoDedicacions === null) {
			if ($this->isNew()) {
				$this->collConcursoCargoDedicacions = array();
			} else {

				$criteria->add(ConcursoCargoDedicacionPeer::CON_CONCURSOS_ID, $this->getId());

				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelectJoinCargo($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoCargoDedicacionPeer::CON_CONCURSOS_ID, $this->getId());

			if (!isset($this->lastConcursoCargoDedicacionCriteria) || !$this->lastConcursoCargoDedicacionCriteria->equals($criteria)) {
				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelectJoinCargo($criteria, $con);
			}
		}
		$this->lastConcursoCargoDedicacionCriteria = $criteria;

		return $this->collConcursoCargoDedicacions;
	}


	
	public function getConcursoCargoDedicacionsJoinDedicacion($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoDedicacionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargoDedicacions === null) {
			if ($this->isNew()) {
				$this->collConcursoCargoDedicacions = array();
			} else {

				$criteria->add(ConcursoCargoDedicacionPeer::CON_CONCURSOS_ID, $this->getId());

				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelectJoinDedicacion($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoCargoDedicacionPeer::CON_CONCURSOS_ID, $this->getId());

			if (!isset($this->lastConcursoCargoDedicacionCriteria) || !$this->lastConcursoCargoDedicacionCriteria->equals($criteria)) {
				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelectJoinDedicacion($criteria, $con);
			}
		}
		$this->lastConcursoCargoDedicacionCriteria = $criteria;

		return $this->collConcursoCargoDedicacions;
	}


	
	public function getConcursoCargoDedicacionsJoinConcursoAspirante($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoDedicacionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargoDedicacions === null) {
			if ($this->isNew()) {
				$this->collConcursoCargoDedicacions = array();
			} else {

				$criteria->add(ConcursoCargoDedicacionPeer::CON_CONCURSOS_ID, $this->getId());

				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelectJoinConcursoAspirante($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoCargoDedicacionPeer::CON_CONCURSOS_ID, $this->getId());

			if (!isset($this->lastConcursoCargoDedicacionCriteria) || !$this->lastConcursoCargoDedicacionCriteria->equals($criteria)) {
				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelectJoinConcursoAspirante($criteria, $con);
			}
		}
		$this->lastConcursoCargoDedicacionCriteria = $criteria;

		return $this->collConcursoCargoDedicacions;
	}

	
	public function initHistoricos()
	{
		if ($this->collHistoricos === null) {
			$this->collHistoricos = array();
		}
	}

	
	public function getHistoricos($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseHistoricoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collHistoricos === null) {
			if ($this->isNew()) {
			   $this->collHistoricos = array();
			} else {

				$criteria->add(HistoricoPeer::CON_CONCURSOS_ID, $this->getId());

				HistoricoPeer::addSelectColumns($criteria);
				$this->collHistoricos = HistoricoPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(HistoricoPeer::CON_CONCURSOS_ID, $this->getId());

				HistoricoPeer::addSelectColumns($criteria);
				if (!isset($this->lastHistoricoCriteria) || !$this->lastHistoricoCriteria->equals($criteria)) {
					$this->collHistoricos = HistoricoPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastHistoricoCriteria = $criteria;
		return $this->collHistoricos;
	}

	
	public function countHistoricos($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseHistoricoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(HistoricoPeer::CON_CONCURSOS_ID, $this->getId());

		return HistoricoPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addHistorico(Historico $l)
	{
		$this->collHistoricos[] = $l;
		$l->setConcurso($this);
	}

	
	public function initConcursoNovedads()
	{
		if ($this->collConcursoNovedads === null) {
			$this->collConcursoNovedads = array();
		}
	}

	
	public function getConcursoNovedads($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoNovedadPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoNovedads === null) {
			if ($this->isNew()) {
			   $this->collConcursoNovedads = array();
			} else {

				$criteria->add(ConcursoNovedadPeer::CON_CONCURSOS_ID, $this->getId());

				ConcursoNovedadPeer::addSelectColumns($criteria);
				$this->collConcursoNovedads = ConcursoNovedadPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConcursoNovedadPeer::CON_CONCURSOS_ID, $this->getId());

				ConcursoNovedadPeer::addSelectColumns($criteria);
				if (!isset($this->lastConcursoNovedadCriteria) || !$this->lastConcursoNovedadCriteria->equals($criteria)) {
					$this->collConcursoNovedads = ConcursoNovedadPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConcursoNovedadCriteria = $criteria;
		return $this->collConcursoNovedads;
	}

	
	public function countConcursoNovedads($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoNovedadPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConcursoNovedadPeer::CON_CONCURSOS_ID, $this->getId());

		return ConcursoNovedadPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConcursoNovedad(ConcursoNovedad $l)
	{
		$this->collConcursoNovedads[] = $l;
		$l->setConcurso($this);
	}

	
	public function initConcursoPlans()
	{
		if ($this->collConcursoPlans === null) {
			$this->collConcursoPlans = array();
		}
	}

	
	public function getConcursoPlans($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPlanPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoPlans === null) {
			if ($this->isNew()) {
			   $this->collConcursoPlans = array();
			} else {

				$criteria->add(ConcursoPlanPeer::CON_CONCURSOS_ID, $this->getId());

				ConcursoPlanPeer::addSelectColumns($criteria);
				$this->collConcursoPlans = ConcursoPlanPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConcursoPlanPeer::CON_CONCURSOS_ID, $this->getId());

				ConcursoPlanPeer::addSelectColumns($criteria);
				if (!isset($this->lastConcursoPlanCriteria) || !$this->lastConcursoPlanCriteria->equals($criteria)) {
					$this->collConcursoPlans = ConcursoPlanPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConcursoPlanCriteria = $criteria;
		return $this->collConcursoPlans;
	}

	
	public function countConcursoPlans($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPlanPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConcursoPlanPeer::CON_CONCURSOS_ID, $this->getId());

		return ConcursoPlanPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConcursoPlan(ConcursoPlan $l)
	{
		$this->collConcursoPlans[] = $l;
		$l->setConcurso($this);
	}


	
	public function getConcursoPlansJoinCarreraMateria($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPlanPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoPlans === null) {
			if ($this->isNew()) {
				$this->collConcursoPlans = array();
			} else {

				$criteria->add(ConcursoPlanPeer::CON_CONCURSOS_ID, $this->getId());

				$this->collConcursoPlans = ConcursoPlanPeer::doSelectJoinCarreraMateria($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPlanPeer::CON_CONCURSOS_ID, $this->getId());

			if (!isset($this->lastConcursoPlanCriteria) || !$this->lastConcursoPlanCriteria->equals($criteria)) {
				$this->collConcursoPlans = ConcursoPlanPeer::doSelectJoinCarreraMateria($criteria, $con);
			}
		}
		$this->lastConcursoPlanCriteria = $criteria;

		return $this->collConcursoPlans;
	}

	
	public function initConcursoCarreras()
	{
		if ($this->collConcursoCarreras === null) {
			$this->collConcursoCarreras = array();
		}
	}

	
	public function getConcursoCarreras($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCarreraPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCarreras === null) {
			if ($this->isNew()) {
			   $this->collConcursoCarreras = array();
			} else {

				$criteria->add(ConcursoCarreraPeer::CON_CONCURSOS_ID, $this->getId());

				ConcursoCarreraPeer::addSelectColumns($criteria);
				$this->collConcursoCarreras = ConcursoCarreraPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConcursoCarreraPeer::CON_CONCURSOS_ID, $this->getId());

				ConcursoCarreraPeer::addSelectColumns($criteria);
				if (!isset($this->lastConcursoCarreraCriteria) || !$this->lastConcursoCarreraCriteria->equals($criteria)) {
					$this->collConcursoCarreras = ConcursoCarreraPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConcursoCarreraCriteria = $criteria;
		return $this->collConcursoCarreras;
	}

	
	public function countConcursoCarreras($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCarreraPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConcursoCarreraPeer::CON_CONCURSOS_ID, $this->getId());

		return ConcursoCarreraPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConcursoCarrera(ConcursoCarrera $l)
	{
		$this->collConcursoCarreras[] = $l;
		$l->setConcurso($this);
	}


	
	public function getConcursoCarrerasJoinCarrera($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCarreraPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCarreras === null) {
			if ($this->isNew()) {
				$this->collConcursoCarreras = array();
			} else {

				$criteria->add(ConcursoCarreraPeer::CON_CONCURSOS_ID, $this->getId());

				$this->collConcursoCarreras = ConcursoCarreraPeer::doSelectJoinCarrera($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoCarreraPeer::CON_CONCURSOS_ID, $this->getId());

			if (!isset($this->lastConcursoCarreraCriteria) || !$this->lastConcursoCarreraCriteria->equals($criteria)) {
				$this->collConcursoCarreras = ConcursoCarreraPeer::doSelectJoinCarrera($criteria, $con);
			}
		}
		$this->lastConcursoCarreraCriteria = $criteria;

		return $this->collConcursoCarreras;
	}


	
	public function getConcursoCarrerasJoinMateria($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCarreraPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCarreras === null) {
			if ($this->isNew()) {
				$this->collConcursoCarreras = array();
			} else {

				$criteria->add(ConcursoCarreraPeer::CON_CONCURSOS_ID, $this->getId());

				$this->collConcursoCarreras = ConcursoCarreraPeer::doSelectJoinMateria($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoCarreraPeer::CON_CONCURSOS_ID, $this->getId());

			if (!isset($this->lastConcursoCarreraCriteria) || !$this->lastConcursoCarreraCriteria->equals($criteria)) {
				$this->collConcursoCarreras = ConcursoCarreraPeer::doSelectJoinMateria($criteria, $con);
			}
		}
		$this->lastConcursoCarreraCriteria = $criteria;

		return $this->collConcursoCarreras;
	}

	
	public function initConcursoCargos()
	{
		if ($this->collConcursoCargos === null) {
			$this->collConcursoCargos = array();
		}
	}

	
	public function getConcursoCargos($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargos === null) {
			if ($this->isNew()) {
			   $this->collConcursoCargos = array();
			} else {

				$criteria->add(ConcursoCargoPeer::CON_CONCURSOS_ID, $this->getId());

				ConcursoCargoPeer::addSelectColumns($criteria);
				$this->collConcursoCargos = ConcursoCargoPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConcursoCargoPeer::CON_CONCURSOS_ID, $this->getId());

				ConcursoCargoPeer::addSelectColumns($criteria);
				if (!isset($this->lastConcursoCargoCriteria) || !$this->lastConcursoCargoCriteria->equals($criteria)) {
					$this->collConcursoCargos = ConcursoCargoPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConcursoCargoCriteria = $criteria;
		return $this->collConcursoCargos;
	}

	
	public function countConcursoCargos($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConcursoCargoPeer::CON_CONCURSOS_ID, $this->getId());

		return ConcursoCargoPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConcursoCargo(ConcursoCargo $l)
	{
		$this->collConcursoCargos[] = $l;
		$l->setConcurso($this);
	}


	
	public function getConcursoCargosJoinCargo($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargos === null) {
			if ($this->isNew()) {
				$this->collConcursoCargos = array();
			} else {

				$criteria->add(ConcursoCargoPeer::CON_CONCURSOS_ID, $this->getId());

				$this->collConcursoCargos = ConcursoCargoPeer::doSelectJoinCargo($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoCargoPeer::CON_CONCURSOS_ID, $this->getId());

			if (!isset($this->lastConcursoCargoCriteria) || !$this->lastConcursoCargoCriteria->equals($criteria)) {
				$this->collConcursoCargos = ConcursoCargoPeer::doSelectJoinCargo($criteria, $con);
			}
		}
		$this->lastConcursoCargoCriteria = $criteria;

		return $this->collConcursoCargos;
	}


	
	public function getConcursoCargosJoinDedicacion($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargos === null) {
			if ($this->isNew()) {
				$this->collConcursoCargos = array();
			} else {

				$criteria->add(ConcursoCargoPeer::CON_CONCURSOS_ID, $this->getId());

				$this->collConcursoCargos = ConcursoCargoPeer::doSelectJoinDedicacion($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoCargoPeer::CON_CONCURSOS_ID, $this->getId());

			if (!isset($this->lastConcursoCargoCriteria) || !$this->lastConcursoCargoCriteria->equals($criteria)) {
				$this->collConcursoCargos = ConcursoCargoPeer::doSelectJoinDedicacion($criteria, $con);
			}
		}
		$this->lastConcursoCargoCriteria = $criteria;

		return $this->collConcursoCargos;
	}


	
	public function getConcursoCargosJoinAspirante($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargos === null) {
			if ($this->isNew()) {
				$this->collConcursoCargos = array();
			} else {

				$criteria->add(ConcursoCargoPeer::CON_CONCURSOS_ID, $this->getId());

				$this->collConcursoCargos = ConcursoCargoPeer::doSelectJoinAspirante($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoCargoPeer::CON_CONCURSOS_ID, $this->getId());

			if (!isset($this->lastConcursoCargoCriteria) || !$this->lastConcursoCargoCriteria->equals($criteria)) {
				$this->collConcursoCargos = ConcursoCargoPeer::doSelectJoinAspirante($criteria, $con);
			}
		}
		$this->lastConcursoCargoCriteria = $criteria;

		return $this->collConcursoCargos;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseConcurso:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseConcurso::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 