<?php


abstract class BaseConcursoAspirante extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $con_aspirantes_id;


	
	protected $con_concursos_id;


	
	protected $created_at;


	
	protected $fecha_inscripcion;


	
	protected $observacion;


	
	protected $doc_completa = false;

	
	protected $aAspirante;

	
	protected $aConcurso;

	
	protected $collConcursoCargoDedicacions;

	
	protected $lastConcursoCargoDedicacionCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getConAspirantesId()
	{

		return $this->con_aspirantes_id;
	}

	
	public function getConConcursosId()
	{

		return $this->con_concursos_id;
	}

	
	public function getCreatedAt($format = 'd/m/Y H:i:s')
	{

		if ($this->created_at === null || $this->created_at === '') {
			return null;
		} elseif (!is_int($this->created_at)) {
						$ts = strtotime($this->created_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [created_at] as date/time value: " . var_export($this->created_at, true));
			}
		} else {
			$ts = $this->created_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getFechaInscripcion($format = '%d/%m/%Y')
	{

		if ($this->fecha_inscripcion === null || $this->fecha_inscripcion === '') {
			return null;
		} elseif (!is_int($this->fecha_inscripcion)) {
						$ts = strtotime($this->fecha_inscripcion);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha_inscripcion] as date/time value: " . var_export($this->fecha_inscripcion, true));
			}
		} else {
			$ts = $this->fecha_inscripcion;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getObservacion()
	{

		return $this->observacion;
	}

	
	public function getDocCompleta()
	{

		return $this->doc_completa;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ConcursoAspirantePeer::ID;
		}

	} 
	
	public function setConAspirantesId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_aspirantes_id !== $v) {
			$this->con_aspirantes_id = $v;
			$this->modifiedColumns[] = ConcursoAspirantePeer::CON_ASPIRANTES_ID;
		}

		if ($this->aAspirante !== null && $this->aAspirante->getId() !== $v) {
			$this->aAspirante = null;
		}

	} 
	
	public function setConConcursosId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_concursos_id !== $v) {
			$this->con_concursos_id = $v;
			$this->modifiedColumns[] = ConcursoAspirantePeer::CON_CONCURSOS_ID;
		}

		if ($this->aConcurso !== null && $this->aConcurso->getId() !== $v) {
			$this->aConcurso = null;
		}

	} 
	
	public function setCreatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [created_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->created_at !== $ts) {
			$this->created_at = $ts;
			$this->modifiedColumns[] = ConcursoAspirantePeer::CREATED_AT;
		}

	} 
	
	public function setFechaInscripcion($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha_inscripcion] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha_inscripcion !== $ts) {
			$this->fecha_inscripcion = $ts;
			$this->modifiedColumns[] = ConcursoAspirantePeer::FECHA_INSCRIPCION;
		}

	} 
	
	public function setObservacion($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->observacion !== $v) {
			$this->observacion = $v;
			$this->modifiedColumns[] = ConcursoAspirantePeer::OBSERVACION;
		}

	} 
	
	public function setDocCompleta($v)
	{

		if ($this->doc_completa !== $v || $v === false) {
			$this->doc_completa = $v;
			$this->modifiedColumns[] = ConcursoAspirantePeer::DOC_COMPLETA;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->con_aspirantes_id = $rs->getInt($startcol + 1);

			$this->con_concursos_id = $rs->getInt($startcol + 2);

			$this->created_at = $rs->getTimestamp($startcol + 3, null);

			$this->fecha_inscripcion = $rs->getDate($startcol + 4, null);

			$this->observacion = $rs->getString($startcol + 5);

			$this->doc_completa = $rs->getBoolean($startcol + 6);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 7; 
		} catch (Exception $e) {
			throw new PropelException("Error populating ConcursoAspirante object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseConcursoAspirante:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ConcursoAspirantePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			ConcursoAspirantePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseConcursoAspirante:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseConcursoAspirante:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


    if ($this->isNew() && !$this->isColumnModified(ConcursoAspirantePeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ConcursoAspirantePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseConcursoAspirante:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aAspirante !== null) {
				if ($this->aAspirante->isModified()) {
					$affectedRows += $this->aAspirante->save($con);
				}
				$this->setAspirante($this->aAspirante);
			}

			if ($this->aConcurso !== null) {
				if ($this->aConcurso->isModified()) {
					$affectedRows += $this->aConcurso->save($con);
				}
				$this->setConcurso($this->aConcurso);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ConcursoAspirantePeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ConcursoAspirantePeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collConcursoCargoDedicacions !== null) {
				foreach($this->collConcursoCargoDedicacions as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aAspirante !== null) {
				if (!$this->aAspirante->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aAspirante->getValidationFailures());
				}
			}

			if ($this->aConcurso !== null) {
				if (!$this->aConcurso->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aConcurso->getValidationFailures());
				}
			}


			if (($retval = ConcursoAspirantePeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collConcursoCargoDedicacions !== null) {
					foreach($this->collConcursoCargoDedicacions as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ConcursoAspirantePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getConAspirantesId();
				break;
			case 2:
				return $this->getConConcursosId();
				break;
			case 3:
				return $this->getCreatedAt();
				break;
			case 4:
				return $this->getFechaInscripcion();
				break;
			case 5:
				return $this->getObservacion();
				break;
			case 6:
				return $this->getDocCompleta();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ConcursoAspirantePeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getConAspirantesId(),
			$keys[2] => $this->getConConcursosId(),
			$keys[3] => $this->getCreatedAt(),
			$keys[4] => $this->getFechaInscripcion(),
			$keys[5] => $this->getObservacion(),
			$keys[6] => $this->getDocCompleta(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ConcursoAspirantePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setConAspirantesId($value);
				break;
			case 2:
				$this->setConConcursosId($value);
				break;
			case 3:
				$this->setCreatedAt($value);
				break;
			case 4:
				$this->setFechaInscripcion($value);
				break;
			case 5:
				$this->setObservacion($value);
				break;
			case 6:
				$this->setDocCompleta($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ConcursoAspirantePeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setConAspirantesId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setConConcursosId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setCreatedAt($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setFechaInscripcion($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setObservacion($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setDocCompleta($arr[$keys[6]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ConcursoAspirantePeer::DATABASE_NAME);

		if ($this->isColumnModified(ConcursoAspirantePeer::ID)) $criteria->add(ConcursoAspirantePeer::ID, $this->id);
		if ($this->isColumnModified(ConcursoAspirantePeer::CON_ASPIRANTES_ID)) $criteria->add(ConcursoAspirantePeer::CON_ASPIRANTES_ID, $this->con_aspirantes_id);
		if ($this->isColumnModified(ConcursoAspirantePeer::CON_CONCURSOS_ID)) $criteria->add(ConcursoAspirantePeer::CON_CONCURSOS_ID, $this->con_concursos_id);
		if ($this->isColumnModified(ConcursoAspirantePeer::CREATED_AT)) $criteria->add(ConcursoAspirantePeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(ConcursoAspirantePeer::FECHA_INSCRIPCION)) $criteria->add(ConcursoAspirantePeer::FECHA_INSCRIPCION, $this->fecha_inscripcion);
		if ($this->isColumnModified(ConcursoAspirantePeer::OBSERVACION)) $criteria->add(ConcursoAspirantePeer::OBSERVACION, $this->observacion);
		if ($this->isColumnModified(ConcursoAspirantePeer::DOC_COMPLETA)) $criteria->add(ConcursoAspirantePeer::DOC_COMPLETA, $this->doc_completa);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ConcursoAspirantePeer::DATABASE_NAME);

		$criteria->add(ConcursoAspirantePeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setConAspirantesId($this->con_aspirantes_id);

		$copyObj->setConConcursosId($this->con_concursos_id);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setFechaInscripcion($this->fecha_inscripcion);

		$copyObj->setObservacion($this->observacion);

		$copyObj->setDocCompleta($this->doc_completa);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getConcursoCargoDedicacions() as $relObj) {
				$copyObj->addConcursoCargoDedicacion($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ConcursoAspirantePeer();
		}
		return self::$peer;
	}

	
	public function setAspirante($v)
	{


		if ($v === null) {
			$this->setConAspirantesId(NULL);
		} else {
			$this->setConAspirantesId($v->getId());
		}


		$this->aAspirante = $v;
	}


	
	public function getAspirante($con = null)
	{
		if ($this->aAspirante === null && ($this->con_aspirantes_id !== null)) {
						include_once 'lib/model/om/BaseAspirantePeer.php';

			$this->aAspirante = AspirantePeer::retrieveByPK($this->con_aspirantes_id, $con);

			
		}
		return $this->aAspirante;
	}

	
	public function setConcurso($v)
	{


		if ($v === null) {
			$this->setConConcursosId(NULL);
		} else {
			$this->setConConcursosId($v->getId());
		}


		$this->aConcurso = $v;
	}


	
	public function getConcurso($con = null)
	{
		if ($this->aConcurso === null && ($this->con_concursos_id !== null)) {
						include_once 'lib/model/om/BaseConcursoPeer.php';

			$this->aConcurso = ConcursoPeer::retrieveByPK($this->con_concursos_id, $con);

			
		}
		return $this->aConcurso;
	}

	
	public function initConcursoCargoDedicacions()
	{
		if ($this->collConcursoCargoDedicacions === null) {
			$this->collConcursoCargoDedicacions = array();
		}
	}

	
	public function getConcursoCargoDedicacions($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoDedicacionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargoDedicacions === null) {
			if ($this->isNew()) {
			   $this->collConcursoCargoDedicacions = array();
			} else {

				$criteria->add(ConcursoCargoDedicacionPeer::CON_CONCURSOS_ASPIRANTES_ID, $this->getId());

				ConcursoCargoDedicacionPeer::addSelectColumns($criteria);
				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConcursoCargoDedicacionPeer::CON_CONCURSOS_ASPIRANTES_ID, $this->getId());

				ConcursoCargoDedicacionPeer::addSelectColumns($criteria);
				if (!isset($this->lastConcursoCargoDedicacionCriteria) || !$this->lastConcursoCargoDedicacionCriteria->equals($criteria)) {
					$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConcursoCargoDedicacionCriteria = $criteria;
		return $this->collConcursoCargoDedicacions;
	}

	
	public function countConcursoCargoDedicacions($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoDedicacionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConcursoCargoDedicacionPeer::CON_CONCURSOS_ASPIRANTES_ID, $this->getId());

		return ConcursoCargoDedicacionPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConcursoCargoDedicacion(ConcursoCargoDedicacion $l)
	{
		$this->collConcursoCargoDedicacions[] = $l;
		$l->setConcursoAspirante($this);
	}


	
	public function getConcursoCargoDedicacionsJoinConcurso($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoDedicacionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargoDedicacions === null) {
			if ($this->isNew()) {
				$this->collConcursoCargoDedicacions = array();
			} else {

				$criteria->add(ConcursoCargoDedicacionPeer::CON_CONCURSOS_ASPIRANTES_ID, $this->getId());

				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelectJoinConcurso($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoCargoDedicacionPeer::CON_CONCURSOS_ASPIRANTES_ID, $this->getId());

			if (!isset($this->lastConcursoCargoDedicacionCriteria) || !$this->lastConcursoCargoDedicacionCriteria->equals($criteria)) {
				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelectJoinConcurso($criteria, $con);
			}
		}
		$this->lastConcursoCargoDedicacionCriteria = $criteria;

		return $this->collConcursoCargoDedicacions;
	}


	
	public function getConcursoCargoDedicacionsJoinCargo($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoDedicacionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargoDedicacions === null) {
			if ($this->isNew()) {
				$this->collConcursoCargoDedicacions = array();
			} else {

				$criteria->add(ConcursoCargoDedicacionPeer::CON_CONCURSOS_ASPIRANTES_ID, $this->getId());

				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelectJoinCargo($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoCargoDedicacionPeer::CON_CONCURSOS_ASPIRANTES_ID, $this->getId());

			if (!isset($this->lastConcursoCargoDedicacionCriteria) || !$this->lastConcursoCargoDedicacionCriteria->equals($criteria)) {
				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelectJoinCargo($criteria, $con);
			}
		}
		$this->lastConcursoCargoDedicacionCriteria = $criteria;

		return $this->collConcursoCargoDedicacions;
	}


	
	public function getConcursoCargoDedicacionsJoinDedicacion($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoDedicacionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargoDedicacions === null) {
			if ($this->isNew()) {
				$this->collConcursoCargoDedicacions = array();
			} else {

				$criteria->add(ConcursoCargoDedicacionPeer::CON_CONCURSOS_ASPIRANTES_ID, $this->getId());

				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelectJoinDedicacion($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoCargoDedicacionPeer::CON_CONCURSOS_ASPIRANTES_ID, $this->getId());

			if (!isset($this->lastConcursoCargoDedicacionCriteria) || !$this->lastConcursoCargoDedicacionCriteria->equals($criteria)) {
				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelectJoinDedicacion($criteria, $con);
			}
		}
		$this->lastConcursoCargoDedicacionCriteria = $criteria;

		return $this->collConcursoCargoDedicacions;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseConcursoAspirante:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseConcursoAspirante::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 