<?php


abstract class BaseConcursoCargo extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $con_concursos_id;


	
	protected $con_cargos_id;


	
	protected $con_dedicaciones_id;


	
	protected $con_aspirantes_id;


	
	protected $res_designa;


	
	protected $fec_res_designa;


	
	protected $fec_final_desig;


	
	protected $id;

	
	protected $aConcurso;

	
	protected $aCargo;

	
	protected $aDedicacion;

	
	protected $aAspirante;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getConConcursosId()
	{

		return $this->con_concursos_id;
	}

	
	public function getConCargosId()
	{

		return $this->con_cargos_id;
	}

	
	public function getConDedicacionesId()
	{

		return $this->con_dedicaciones_id;
	}

	
	public function getConAspirantesId()
	{

		return $this->con_aspirantes_id;
	}

	
	public function getResDesigna()
	{

		return $this->res_designa;
	}

	
	public function getFecResDesigna($format = '%d/%m/%Y')
	{

		if ($this->fec_res_designa === null || $this->fec_res_designa === '') {
			return null;
		} elseif (!is_int($this->fec_res_designa)) {
						$ts = strtotime($this->fec_res_designa);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fec_res_designa] as date/time value: " . var_export($this->fec_res_designa, true));
			}
		} else {
			$ts = $this->fec_res_designa;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getFecFinalDesig($format = '%d/%m/%Y')
	{

		if ($this->fec_final_desig === null || $this->fec_final_desig === '') {
			return null;
		} elseif (!is_int($this->fec_final_desig)) {
						$ts = strtotime($this->fec_final_desig);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fec_final_desig] as date/time value: " . var_export($this->fec_final_desig, true));
			}
		} else {
			$ts = $this->fec_final_desig;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getId()
	{

		return $this->id;
	}

	
	public function setConConcursosId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_concursos_id !== $v) {
			$this->con_concursos_id = $v;
			$this->modifiedColumns[] = ConcursoCargoPeer::CON_CONCURSOS_ID;
		}

		if ($this->aConcurso !== null && $this->aConcurso->getId() !== $v) {
			$this->aConcurso = null;
		}

	} 
	
	public function setConCargosId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_cargos_id !== $v) {
			$this->con_cargos_id = $v;
			$this->modifiedColumns[] = ConcursoCargoPeer::CON_CARGOS_ID;
		}

		if ($this->aCargo !== null && $this->aCargo->getId() !== $v) {
			$this->aCargo = null;
		}

	} 
	
	public function setConDedicacionesId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_dedicaciones_id !== $v) {
			$this->con_dedicaciones_id = $v;
			$this->modifiedColumns[] = ConcursoCargoPeer::CON_DEDICACIONES_ID;
		}

		if ($this->aDedicacion !== null && $this->aDedicacion->getId() !== $v) {
			$this->aDedicacion = null;
		}

	} 
	
	public function setConAspirantesId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_aspirantes_id !== $v) {
			$this->con_aspirantes_id = $v;
			$this->modifiedColumns[] = ConcursoCargoPeer::CON_ASPIRANTES_ID;
		}

		if ($this->aAspirante !== null && $this->aAspirante->getId() !== $v) {
			$this->aAspirante = null;
		}

	} 
	
	public function setResDesigna($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->res_designa !== $v) {
			$this->res_designa = $v;
			$this->modifiedColumns[] = ConcursoCargoPeer::RES_DESIGNA;
		}

	} 
	
	public function setFecResDesigna($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fec_res_designa] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fec_res_designa !== $ts) {
			$this->fec_res_designa = $ts;
			$this->modifiedColumns[] = ConcursoCargoPeer::FEC_RES_DESIGNA;
		}

	} 
	
	public function setFecFinalDesig($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fec_final_desig] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fec_final_desig !== $ts) {
			$this->fec_final_desig = $ts;
			$this->modifiedColumns[] = ConcursoCargoPeer::FEC_FINAL_DESIG;
		}

	} 
	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ConcursoCargoPeer::ID;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->con_concursos_id = $rs->getInt($startcol + 0);

			$this->con_cargos_id = $rs->getInt($startcol + 1);

			$this->con_dedicaciones_id = $rs->getInt($startcol + 2);

			$this->con_aspirantes_id = $rs->getInt($startcol + 3);

			$this->res_designa = $rs->getString($startcol + 4);

			$this->fec_res_designa = $rs->getDate($startcol + 5, null);

			$this->fec_final_desig = $rs->getDate($startcol + 6, null);

			$this->id = $rs->getInt($startcol + 7);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 8; 
		} catch (Exception $e) {
			throw new PropelException("Error populating ConcursoCargo object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseConcursoCargo:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ConcursoCargoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			ConcursoCargoPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseConcursoCargo:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseConcursoCargo:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ConcursoCargoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseConcursoCargo:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aConcurso !== null) {
				if ($this->aConcurso->isModified()) {
					$affectedRows += $this->aConcurso->save($con);
				}
				$this->setConcurso($this->aConcurso);
			}

			if ($this->aCargo !== null) {
				if ($this->aCargo->isModified()) {
					$affectedRows += $this->aCargo->save($con);
				}
				$this->setCargo($this->aCargo);
			}

			if ($this->aDedicacion !== null) {
				if ($this->aDedicacion->isModified()) {
					$affectedRows += $this->aDedicacion->save($con);
				}
				$this->setDedicacion($this->aDedicacion);
			}

			if ($this->aAspirante !== null) {
				if ($this->aAspirante->isModified()) {
					$affectedRows += $this->aAspirante->save($con);
				}
				$this->setAspirante($this->aAspirante);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ConcursoCargoPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ConcursoCargoPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aConcurso !== null) {
				if (!$this->aConcurso->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aConcurso->getValidationFailures());
				}
			}

			if ($this->aCargo !== null) {
				if (!$this->aCargo->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aCargo->getValidationFailures());
				}
			}

			if ($this->aDedicacion !== null) {
				if (!$this->aDedicacion->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aDedicacion->getValidationFailures());
				}
			}

			if ($this->aAspirante !== null) {
				if (!$this->aAspirante->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aAspirante->getValidationFailures());
				}
			}


			if (($retval = ConcursoCargoPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ConcursoCargoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getConConcursosId();
				break;
			case 1:
				return $this->getConCargosId();
				break;
			case 2:
				return $this->getConDedicacionesId();
				break;
			case 3:
				return $this->getConAspirantesId();
				break;
			case 4:
				return $this->getResDesigna();
				break;
			case 5:
				return $this->getFecResDesigna();
				break;
			case 6:
				return $this->getFecFinalDesig();
				break;
			case 7:
				return $this->getId();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ConcursoCargoPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getConConcursosId(),
			$keys[1] => $this->getConCargosId(),
			$keys[2] => $this->getConDedicacionesId(),
			$keys[3] => $this->getConAspirantesId(),
			$keys[4] => $this->getResDesigna(),
			$keys[5] => $this->getFecResDesigna(),
			$keys[6] => $this->getFecFinalDesig(),
			$keys[7] => $this->getId(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ConcursoCargoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setConConcursosId($value);
				break;
			case 1:
				$this->setConCargosId($value);
				break;
			case 2:
				$this->setConDedicacionesId($value);
				break;
			case 3:
				$this->setConAspirantesId($value);
				break;
			case 4:
				$this->setResDesigna($value);
				break;
			case 5:
				$this->setFecResDesigna($value);
				break;
			case 6:
				$this->setFecFinalDesig($value);
				break;
			case 7:
				$this->setId($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ConcursoCargoPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setConConcursosId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setConCargosId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setConDedicacionesId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setConAspirantesId($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setResDesigna($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setFecResDesigna($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setFecFinalDesig($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setId($arr[$keys[7]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ConcursoCargoPeer::DATABASE_NAME);

		if ($this->isColumnModified(ConcursoCargoPeer::CON_CONCURSOS_ID)) $criteria->add(ConcursoCargoPeer::CON_CONCURSOS_ID, $this->con_concursos_id);
		if ($this->isColumnModified(ConcursoCargoPeer::CON_CARGOS_ID)) $criteria->add(ConcursoCargoPeer::CON_CARGOS_ID, $this->con_cargos_id);
		if ($this->isColumnModified(ConcursoCargoPeer::CON_DEDICACIONES_ID)) $criteria->add(ConcursoCargoPeer::CON_DEDICACIONES_ID, $this->con_dedicaciones_id);
		if ($this->isColumnModified(ConcursoCargoPeer::CON_ASPIRANTES_ID)) $criteria->add(ConcursoCargoPeer::CON_ASPIRANTES_ID, $this->con_aspirantes_id);
		if ($this->isColumnModified(ConcursoCargoPeer::RES_DESIGNA)) $criteria->add(ConcursoCargoPeer::RES_DESIGNA, $this->res_designa);
		if ($this->isColumnModified(ConcursoCargoPeer::FEC_RES_DESIGNA)) $criteria->add(ConcursoCargoPeer::FEC_RES_DESIGNA, $this->fec_res_designa);
		if ($this->isColumnModified(ConcursoCargoPeer::FEC_FINAL_DESIG)) $criteria->add(ConcursoCargoPeer::FEC_FINAL_DESIG, $this->fec_final_desig);
		if ($this->isColumnModified(ConcursoCargoPeer::ID)) $criteria->add(ConcursoCargoPeer::ID, $this->id);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ConcursoCargoPeer::DATABASE_NAME);

		$criteria->add(ConcursoCargoPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setConConcursosId($this->con_concursos_id);

		$copyObj->setConCargosId($this->con_cargos_id);

		$copyObj->setConDedicacionesId($this->con_dedicaciones_id);

		$copyObj->setConAspirantesId($this->con_aspirantes_id);

		$copyObj->setResDesigna($this->res_designa);

		$copyObj->setFecResDesigna($this->fec_res_designa);

		$copyObj->setFecFinalDesig($this->fec_final_desig);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ConcursoCargoPeer();
		}
		return self::$peer;
	}

	
	public function setConcurso($v)
	{


		if ($v === null) {
			$this->setConConcursosId(NULL);
		} else {
			$this->setConConcursosId($v->getId());
		}


		$this->aConcurso = $v;
	}


	
	public function getConcurso($con = null)
	{
		if ($this->aConcurso === null && ($this->con_concursos_id !== null)) {
						include_once 'lib/model/om/BaseConcursoPeer.php';

			$this->aConcurso = ConcursoPeer::retrieveByPK($this->con_concursos_id, $con);

			
		}
		return $this->aConcurso;
	}

	
	public function setCargo($v)
	{


		if ($v === null) {
			$this->setConCargosId(NULL);
		} else {
			$this->setConCargosId($v->getId());
		}


		$this->aCargo = $v;
	}


	
	public function getCargo($con = null)
	{
		if ($this->aCargo === null && ($this->con_cargos_id !== null)) {
						include_once 'lib/model/om/BaseCargoPeer.php';

			$this->aCargo = CargoPeer::retrieveByPK($this->con_cargos_id, $con);

			
		}
		return $this->aCargo;
	}

	
	public function setDedicacion($v)
	{


		if ($v === null) {
			$this->setConDedicacionesId(NULL);
		} else {
			$this->setConDedicacionesId($v->getId());
		}


		$this->aDedicacion = $v;
	}


	
	public function getDedicacion($con = null)
	{
		if ($this->aDedicacion === null && ($this->con_dedicaciones_id !== null)) {
						include_once 'lib/model/om/BaseDedicacionPeer.php';

			$this->aDedicacion = DedicacionPeer::retrieveByPK($this->con_dedicaciones_id, $con);

			
		}
		return $this->aDedicacion;
	}

	
	public function setAspirante($v)
	{


		if ($v === null) {
			$this->setConAspirantesId(NULL);
		} else {
			$this->setConAspirantesId($v->getId());
		}


		$this->aAspirante = $v;
	}


	
	public function getAspirante($con = null)
	{
		if ($this->aAspirante === null && ($this->con_aspirantes_id !== null)) {
						include_once 'lib/model/om/BaseAspirantePeer.php';

			$this->aAspirante = AspirantePeer::retrieveByPK($this->con_aspirantes_id, $con);

			
		}
		return $this->aAspirante;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseConcursoCargo:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseConcursoCargo::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 