<?php


abstract class BaseConcursoJurado extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $con_jurados_id;


	
	protected $con_concursos_id;


	
	protected $observacion;

	
	protected $aJurado;

	
	protected $aConcurso;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getConJuradosId()
	{

		return $this->con_jurados_id;
	}

	
	public function getConConcursosId()
	{

		return $this->con_concursos_id;
	}

	
	public function getObservacion()
	{

		return $this->observacion;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ConcursoJuradoPeer::ID;
		}

	} 
	
	public function setConJuradosId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_jurados_id !== $v) {
			$this->con_jurados_id = $v;
			$this->modifiedColumns[] = ConcursoJuradoPeer::CON_JURADOS_ID;
		}

		if ($this->aJurado !== null && $this->aJurado->getId() !== $v) {
			$this->aJurado = null;
		}

	} 
	
	public function setConConcursosId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_concursos_id !== $v) {
			$this->con_concursos_id = $v;
			$this->modifiedColumns[] = ConcursoJuradoPeer::CON_CONCURSOS_ID;
		}

		if ($this->aConcurso !== null && $this->aConcurso->getId() !== $v) {
			$this->aConcurso = null;
		}

	} 
	
	public function setObservacion($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->observacion !== $v) {
			$this->observacion = $v;
			$this->modifiedColumns[] = ConcursoJuradoPeer::OBSERVACION;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->con_jurados_id = $rs->getInt($startcol + 1);

			$this->con_concursos_id = $rs->getInt($startcol + 2);

			$this->observacion = $rs->getString($startcol + 3);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 4; 
		} catch (Exception $e) {
			throw new PropelException("Error populating ConcursoJurado object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseConcursoJurado:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ConcursoJuradoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			ConcursoJuradoPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseConcursoJurado:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseConcursoJurado:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ConcursoJuradoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseConcursoJurado:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aJurado !== null) {
				if ($this->aJurado->isModified()) {
					$affectedRows += $this->aJurado->save($con);
				}
				$this->setJurado($this->aJurado);
			}

			if ($this->aConcurso !== null) {
				if ($this->aConcurso->isModified()) {
					$affectedRows += $this->aConcurso->save($con);
				}
				$this->setConcurso($this->aConcurso);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ConcursoJuradoPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ConcursoJuradoPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aJurado !== null) {
				if (!$this->aJurado->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aJurado->getValidationFailures());
				}
			}

			if ($this->aConcurso !== null) {
				if (!$this->aConcurso->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aConcurso->getValidationFailures());
				}
			}


			if (($retval = ConcursoJuradoPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ConcursoJuradoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getConJuradosId();
				break;
			case 2:
				return $this->getConConcursosId();
				break;
			case 3:
				return $this->getObservacion();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ConcursoJuradoPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getConJuradosId(),
			$keys[2] => $this->getConConcursosId(),
			$keys[3] => $this->getObservacion(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ConcursoJuradoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setConJuradosId($value);
				break;
			case 2:
				$this->setConConcursosId($value);
				break;
			case 3:
				$this->setObservacion($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ConcursoJuradoPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setConJuradosId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setConConcursosId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setObservacion($arr[$keys[3]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ConcursoJuradoPeer::DATABASE_NAME);

		if ($this->isColumnModified(ConcursoJuradoPeer::ID)) $criteria->add(ConcursoJuradoPeer::ID, $this->id);
		if ($this->isColumnModified(ConcursoJuradoPeer::CON_JURADOS_ID)) $criteria->add(ConcursoJuradoPeer::CON_JURADOS_ID, $this->con_jurados_id);
		if ($this->isColumnModified(ConcursoJuradoPeer::CON_CONCURSOS_ID)) $criteria->add(ConcursoJuradoPeer::CON_CONCURSOS_ID, $this->con_concursos_id);
		if ($this->isColumnModified(ConcursoJuradoPeer::OBSERVACION)) $criteria->add(ConcursoJuradoPeer::OBSERVACION, $this->observacion);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ConcursoJuradoPeer::DATABASE_NAME);

		$criteria->add(ConcursoJuradoPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setConJuradosId($this->con_jurados_id);

		$copyObj->setConConcursosId($this->con_concursos_id);

		$copyObj->setObservacion($this->observacion);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ConcursoJuradoPeer();
		}
		return self::$peer;
	}

	
	public function setJurado($v)
	{


		if ($v === null) {
			$this->setConJuradosId(NULL);
		} else {
			$this->setConJuradosId($v->getId());
		}


		$this->aJurado = $v;
	}


	
	public function getJurado($con = null)
	{
		if ($this->aJurado === null && ($this->con_jurados_id !== null)) {
						include_once 'lib/model/om/BaseJuradoPeer.php';

			$this->aJurado = JuradoPeer::retrieveByPK($this->con_jurados_id, $con);

			
		}
		return $this->aJurado;
	}

	
	public function setConcurso($v)
	{


		if ($v === null) {
			$this->setConConcursosId(NULL);
		} else {
			$this->setConConcursosId($v->getId());
		}


		$this->aConcurso = $v;
	}


	
	public function getConcurso($con = null)
	{
		if ($this->aConcurso === null && ($this->con_concursos_id !== null)) {
						include_once 'lib/model/om/BaseConcursoPeer.php';

			$this->aConcurso = ConcursoPeer::retrieveByPK($this->con_concursos_id, $con);

			
		}
		return $this->aConcurso;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseConcursoJurado:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseConcursoJurado::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 