<?php


abstract class BaseConcursoNovedad extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $con_concursos_id;


	
	protected $created_at;


	
	protected $descripcion;


	
	protected $seg_usuario_id;

	
	protected $aConcurso;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getConConcursosId()
	{

		return $this->con_concursos_id;
	}

	
	public function getCreatedAt($format = 'd/m/Y H:i:s')
	{

		if ($this->created_at === null || $this->created_at === '') {
			return null;
		} elseif (!is_int($this->created_at)) {
						$ts = strtotime($this->created_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [created_at] as date/time value: " . var_export($this->created_at, true));
			}
		} else {
			$ts = $this->created_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getDescripcion()
	{

		return $this->descripcion;
	}

	
	public function getSegUsuarioId()
	{

		return $this->seg_usuario_id;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ConcursoNovedadPeer::ID;
		}

	} 
	
	public function setConConcursosId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_concursos_id !== $v) {
			$this->con_concursos_id = $v;
			$this->modifiedColumns[] = ConcursoNovedadPeer::CON_CONCURSOS_ID;
		}

		if ($this->aConcurso !== null && $this->aConcurso->getId() !== $v) {
			$this->aConcurso = null;
		}

	} 
	
	public function setCreatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [created_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->created_at !== $ts) {
			$this->created_at = $ts;
			$this->modifiedColumns[] = ConcursoNovedadPeer::CREATED_AT;
		}

	} 
	
	public function setDescripcion($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->descripcion !== $v) {
			$this->descripcion = $v;
			$this->modifiedColumns[] = ConcursoNovedadPeer::DESCRIPCION;
		}

	} 
	
	public function setSegUsuarioId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->seg_usuario_id !== $v) {
			$this->seg_usuario_id = $v;
			$this->modifiedColumns[] = ConcursoNovedadPeer::SEG_USUARIO_ID;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->con_concursos_id = $rs->getInt($startcol + 1);

			$this->created_at = $rs->getTimestamp($startcol + 2, null);

			$this->descripcion = $rs->getString($startcol + 3);

			$this->seg_usuario_id = $rs->getInt($startcol + 4);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 5; 
		} catch (Exception $e) {
			throw new PropelException("Error populating ConcursoNovedad object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseConcursoNovedad:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ConcursoNovedadPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			ConcursoNovedadPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseConcursoNovedad:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseConcursoNovedad:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


    if ($this->isNew() && !$this->isColumnModified(ConcursoNovedadPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ConcursoNovedadPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseConcursoNovedad:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aConcurso !== null) {
				if ($this->aConcurso->isModified()) {
					$affectedRows += $this->aConcurso->save($con);
				}
				$this->setConcurso($this->aConcurso);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ConcursoNovedadPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ConcursoNovedadPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aConcurso !== null) {
				if (!$this->aConcurso->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aConcurso->getValidationFailures());
				}
			}


			if (($retval = ConcursoNovedadPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ConcursoNovedadPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getConConcursosId();
				break;
			case 2:
				return $this->getCreatedAt();
				break;
			case 3:
				return $this->getDescripcion();
				break;
			case 4:
				return $this->getSegUsuarioId();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ConcursoNovedadPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getConConcursosId(),
			$keys[2] => $this->getCreatedAt(),
			$keys[3] => $this->getDescripcion(),
			$keys[4] => $this->getSegUsuarioId(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ConcursoNovedadPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setConConcursosId($value);
				break;
			case 2:
				$this->setCreatedAt($value);
				break;
			case 3:
				$this->setDescripcion($value);
				break;
			case 4:
				$this->setSegUsuarioId($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ConcursoNovedadPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setConConcursosId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setCreatedAt($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setDescripcion($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setSegUsuarioId($arr[$keys[4]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ConcursoNovedadPeer::DATABASE_NAME);

		if ($this->isColumnModified(ConcursoNovedadPeer::ID)) $criteria->add(ConcursoNovedadPeer::ID, $this->id);
		if ($this->isColumnModified(ConcursoNovedadPeer::CON_CONCURSOS_ID)) $criteria->add(ConcursoNovedadPeer::CON_CONCURSOS_ID, $this->con_concursos_id);
		if ($this->isColumnModified(ConcursoNovedadPeer::CREATED_AT)) $criteria->add(ConcursoNovedadPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(ConcursoNovedadPeer::DESCRIPCION)) $criteria->add(ConcursoNovedadPeer::DESCRIPCION, $this->descripcion);
		if ($this->isColumnModified(ConcursoNovedadPeer::SEG_USUARIO_ID)) $criteria->add(ConcursoNovedadPeer::SEG_USUARIO_ID, $this->seg_usuario_id);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ConcursoNovedadPeer::DATABASE_NAME);

		$criteria->add(ConcursoNovedadPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setConConcursosId($this->con_concursos_id);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setDescripcion($this->descripcion);

		$copyObj->setSegUsuarioId($this->seg_usuario_id);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ConcursoNovedadPeer();
		}
		return self::$peer;
	}

	
	public function setConcurso($v)
	{


		if ($v === null) {
			$this->setConConcursosId(NULL);
		} else {
			$this->setConConcursosId($v->getId());
		}


		$this->aConcurso = $v;
	}


	
	public function getConcurso($con = null)
	{
		if ($this->aConcurso === null && ($this->con_concursos_id !== null)) {
						include_once 'lib/model/om/BaseConcursoPeer.php';

			$this->aConcurso = ConcursoPeer::retrieveByPK($this->con_concursos_id, $con);

			
		}
		return $this->aConcurso;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseConcursoNovedad:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseConcursoNovedad::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 