<?php


abstract class BaseDedicacion extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $nombre = 'null';

	
	protected $collConcursos;

	
	protected $lastConcursoCriteria = null;

	
	protected $collConcursoCargoDedicacions;

	
	protected $lastConcursoCargoDedicacionCriteria = null;

	
	protected $collConcursoCargos;

	
	protected $lastConcursoCargoCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getNombre()
	{

		return $this->nombre;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = DedicacionPeer::ID;
		}

	} 
	
	public function setNombre($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nombre !== $v || $v === 'null') {
			$this->nombre = $v;
			$this->modifiedColumns[] = DedicacionPeer::NOMBRE;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->nombre = $rs->getString($startcol + 1);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 2; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Dedicacion object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseDedicacion:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(DedicacionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			DedicacionPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseDedicacion:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseDedicacion:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(DedicacionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseDedicacion:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = DedicacionPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += DedicacionPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collConcursos !== null) {
				foreach($this->collConcursos as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collConcursoCargoDedicacions !== null) {
				foreach($this->collConcursoCargoDedicacions as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collConcursoCargos !== null) {
				foreach($this->collConcursoCargos as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = DedicacionPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collConcursos !== null) {
					foreach($this->collConcursos as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collConcursoCargoDedicacions !== null) {
					foreach($this->collConcursoCargoDedicacions as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collConcursoCargos !== null) {
					foreach($this->collConcursoCargos as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = DedicacionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getNombre();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = DedicacionPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getNombre(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = DedicacionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setNombre($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = DedicacionPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setNombre($arr[$keys[1]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(DedicacionPeer::DATABASE_NAME);

		if ($this->isColumnModified(DedicacionPeer::ID)) $criteria->add(DedicacionPeer::ID, $this->id);
		if ($this->isColumnModified(DedicacionPeer::NOMBRE)) $criteria->add(DedicacionPeer::NOMBRE, $this->nombre);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(DedicacionPeer::DATABASE_NAME);

		$criteria->add(DedicacionPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setNombre($this->nombre);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getConcursos() as $relObj) {
				$copyObj->addConcurso($relObj->copy($deepCopy));
			}

			foreach($this->getConcursoCargoDedicacions() as $relObj) {
				$copyObj->addConcursoCargoDedicacion($relObj->copy($deepCopy));
			}

			foreach($this->getConcursoCargos() as $relObj) {
				$copyObj->addConcursoCargo($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new DedicacionPeer();
		}
		return self::$peer;
	}

	
	public function initConcursos()
	{
		if ($this->collConcursos === null) {
			$this->collConcursos = array();
		}
	}

	
	public function getConcursos($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
			   $this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

				ConcursoPeer::addSelectColumns($criteria);
				$this->collConcursos = ConcursoPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

				ConcursoPeer::addSelectColumns($criteria);
				if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
					$this->collConcursos = ConcursoPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConcursoCriteria = $criteria;
		return $this->collConcursos;
	}

	
	public function countConcursos($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

		return ConcursoPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConcurso(Concurso $l)
	{
		$this->collConcursos[] = $l;
		$l->setDedicacion($this);
	}


	
	public function getConcursosJoinCarrera($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinCarrera($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinCarrera($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinSede($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinSede($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinSede($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinFacultad($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinFacultad($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinFacultad($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinMateria($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinMateria($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinMateria($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinCargo($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinCargo($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinCargo($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinCarreraMateria($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinCarreraMateria($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinCarreraMateria($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinResolucion($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinResolucion($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinResolucion($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinEstado($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinEstado($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinEstado($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinResultado($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinResultado($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_DEDICACIONES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinResultado($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}

	
	public function initConcursoCargoDedicacions()
	{
		if ($this->collConcursoCargoDedicacions === null) {
			$this->collConcursoCargoDedicacions = array();
		}
	}

	
	public function getConcursoCargoDedicacions($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoDedicacionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargoDedicacions === null) {
			if ($this->isNew()) {
			   $this->collConcursoCargoDedicacions = array();
			} else {

				$criteria->add(ConcursoCargoDedicacionPeer::CON_DEDICACIONES_ID, $this->getId());

				ConcursoCargoDedicacionPeer::addSelectColumns($criteria);
				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConcursoCargoDedicacionPeer::CON_DEDICACIONES_ID, $this->getId());

				ConcursoCargoDedicacionPeer::addSelectColumns($criteria);
				if (!isset($this->lastConcursoCargoDedicacionCriteria) || !$this->lastConcursoCargoDedicacionCriteria->equals($criteria)) {
					$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConcursoCargoDedicacionCriteria = $criteria;
		return $this->collConcursoCargoDedicacions;
	}

	
	public function countConcursoCargoDedicacions($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoDedicacionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConcursoCargoDedicacionPeer::CON_DEDICACIONES_ID, $this->getId());

		return ConcursoCargoDedicacionPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConcursoCargoDedicacion(ConcursoCargoDedicacion $l)
	{
		$this->collConcursoCargoDedicacions[] = $l;
		$l->setDedicacion($this);
	}


	
	public function getConcursoCargoDedicacionsJoinConcurso($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoDedicacionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargoDedicacions === null) {
			if ($this->isNew()) {
				$this->collConcursoCargoDedicacions = array();
			} else {

				$criteria->add(ConcursoCargoDedicacionPeer::CON_DEDICACIONES_ID, $this->getId());

				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelectJoinConcurso($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoCargoDedicacionPeer::CON_DEDICACIONES_ID, $this->getId());

			if (!isset($this->lastConcursoCargoDedicacionCriteria) || !$this->lastConcursoCargoDedicacionCriteria->equals($criteria)) {
				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelectJoinConcurso($criteria, $con);
			}
		}
		$this->lastConcursoCargoDedicacionCriteria = $criteria;

		return $this->collConcursoCargoDedicacions;
	}


	
	public function getConcursoCargoDedicacionsJoinCargo($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoDedicacionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargoDedicacions === null) {
			if ($this->isNew()) {
				$this->collConcursoCargoDedicacions = array();
			} else {

				$criteria->add(ConcursoCargoDedicacionPeer::CON_DEDICACIONES_ID, $this->getId());

				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelectJoinCargo($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoCargoDedicacionPeer::CON_DEDICACIONES_ID, $this->getId());

			if (!isset($this->lastConcursoCargoDedicacionCriteria) || !$this->lastConcursoCargoDedicacionCriteria->equals($criteria)) {
				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelectJoinCargo($criteria, $con);
			}
		}
		$this->lastConcursoCargoDedicacionCriteria = $criteria;

		return $this->collConcursoCargoDedicacions;
	}


	
	public function getConcursoCargoDedicacionsJoinConcursoAspirante($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoDedicacionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargoDedicacions === null) {
			if ($this->isNew()) {
				$this->collConcursoCargoDedicacions = array();
			} else {

				$criteria->add(ConcursoCargoDedicacionPeer::CON_DEDICACIONES_ID, $this->getId());

				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelectJoinConcursoAspirante($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoCargoDedicacionPeer::CON_DEDICACIONES_ID, $this->getId());

			if (!isset($this->lastConcursoCargoDedicacionCriteria) || !$this->lastConcursoCargoDedicacionCriteria->equals($criteria)) {
				$this->collConcursoCargoDedicacions = ConcursoCargoDedicacionPeer::doSelectJoinConcursoAspirante($criteria, $con);
			}
		}
		$this->lastConcursoCargoDedicacionCriteria = $criteria;

		return $this->collConcursoCargoDedicacions;
	}

	
	public function initConcursoCargos()
	{
		if ($this->collConcursoCargos === null) {
			$this->collConcursoCargos = array();
		}
	}

	
	public function getConcursoCargos($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargos === null) {
			if ($this->isNew()) {
			   $this->collConcursoCargos = array();
			} else {

				$criteria->add(ConcursoCargoPeer::CON_DEDICACIONES_ID, $this->getId());

				ConcursoCargoPeer::addSelectColumns($criteria);
				$this->collConcursoCargos = ConcursoCargoPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConcursoCargoPeer::CON_DEDICACIONES_ID, $this->getId());

				ConcursoCargoPeer::addSelectColumns($criteria);
				if (!isset($this->lastConcursoCargoCriteria) || !$this->lastConcursoCargoCriteria->equals($criteria)) {
					$this->collConcursoCargos = ConcursoCargoPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConcursoCargoCriteria = $criteria;
		return $this->collConcursoCargos;
	}

	
	public function countConcursoCargos($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConcursoCargoPeer::CON_DEDICACIONES_ID, $this->getId());

		return ConcursoCargoPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConcursoCargo(ConcursoCargo $l)
	{
		$this->collConcursoCargos[] = $l;
		$l->setDedicacion($this);
	}


	
	public function getConcursoCargosJoinConcurso($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargos === null) {
			if ($this->isNew()) {
				$this->collConcursoCargos = array();
			} else {

				$criteria->add(ConcursoCargoPeer::CON_DEDICACIONES_ID, $this->getId());

				$this->collConcursoCargos = ConcursoCargoPeer::doSelectJoinConcurso($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoCargoPeer::CON_DEDICACIONES_ID, $this->getId());

			if (!isset($this->lastConcursoCargoCriteria) || !$this->lastConcursoCargoCriteria->equals($criteria)) {
				$this->collConcursoCargos = ConcursoCargoPeer::doSelectJoinConcurso($criteria, $con);
			}
		}
		$this->lastConcursoCargoCriteria = $criteria;

		return $this->collConcursoCargos;
	}


	
	public function getConcursoCargosJoinCargo($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargos === null) {
			if ($this->isNew()) {
				$this->collConcursoCargos = array();
			} else {

				$criteria->add(ConcursoCargoPeer::CON_DEDICACIONES_ID, $this->getId());

				$this->collConcursoCargos = ConcursoCargoPeer::doSelectJoinCargo($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoCargoPeer::CON_DEDICACIONES_ID, $this->getId());

			if (!isset($this->lastConcursoCargoCriteria) || !$this->lastConcursoCargoCriteria->equals($criteria)) {
				$this->collConcursoCargos = ConcursoCargoPeer::doSelectJoinCargo($criteria, $con);
			}
		}
		$this->lastConcursoCargoCriteria = $criteria;

		return $this->collConcursoCargos;
	}


	
	public function getConcursoCargosJoinAspirante($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoCargoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoCargos === null) {
			if ($this->isNew()) {
				$this->collConcursoCargos = array();
			} else {

				$criteria->add(ConcursoCargoPeer::CON_DEDICACIONES_ID, $this->getId());

				$this->collConcursoCargos = ConcursoCargoPeer::doSelectJoinAspirante($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoCargoPeer::CON_DEDICACIONES_ID, $this->getId());

			if (!isset($this->lastConcursoCargoCriteria) || !$this->lastConcursoCargoCriteria->equals($criteria)) {
				$this->collConcursoCargos = ConcursoCargoPeer::doSelectJoinAspirante($criteria, $con);
			}
		}
		$this->lastConcursoCargoCriteria = $criteria;

		return $this->collConcursoCargos;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseDedicacion:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseDedicacion::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 