<?php


abstract class BaseFacultad extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $nombre;


	
	protected $nombre_largo;


	
	protected $establecimiento_id;


	
	protected $activa = 1;

	
	protected $collCarreras;

	
	protected $lastCarreraCriteria = null;

	
	protected $collConcursos;

	
	protected $lastConcursoCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getNombre()
	{

		return $this->nombre;
	}

	
	public function getNombreLargo()
	{

		return $this->nombre_largo;
	}

	
	public function getEstablecimientoId()
	{

		return $this->establecimiento_id;
	}

	
	public function getActiva()
	{

		return $this->activa;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = FacultadPeer::ID;
		}

	} 
	
	public function setNombre($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nombre !== $v) {
			$this->nombre = $v;
			$this->modifiedColumns[] = FacultadPeer::NOMBRE;
		}

	} 
	
	public function setNombreLargo($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nombre_largo !== $v) {
			$this->nombre_largo = $v;
			$this->modifiedColumns[] = FacultadPeer::NOMBRE_LARGO;
		}

	} 
	
	public function setEstablecimientoId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->establecimiento_id !== $v) {
			$this->establecimiento_id = $v;
			$this->modifiedColumns[] = FacultadPeer::ESTABLECIMIENTO_ID;
		}

	} 
	
	public function setActiva($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->activa !== $v || $v === 1) {
			$this->activa = $v;
			$this->modifiedColumns[] = FacultadPeer::ACTIVA;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->nombre = $rs->getString($startcol + 1);

			$this->nombre_largo = $rs->getString($startcol + 2);

			$this->establecimiento_id = $rs->getInt($startcol + 3);

			$this->activa = $rs->getInt($startcol + 4);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 5; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Facultad object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseFacultad:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(FacultadPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			FacultadPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseFacultad:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseFacultad:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(FacultadPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseFacultad:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = FacultadPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += FacultadPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collCarreras !== null) {
				foreach($this->collCarreras as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collConcursos !== null) {
				foreach($this->collConcursos as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = FacultadPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collCarreras !== null) {
					foreach($this->collCarreras as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collConcursos !== null) {
					foreach($this->collConcursos as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = FacultadPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getNombre();
				break;
			case 2:
				return $this->getNombreLargo();
				break;
			case 3:
				return $this->getEstablecimientoId();
				break;
			case 4:
				return $this->getActiva();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = FacultadPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getNombre(),
			$keys[2] => $this->getNombreLargo(),
			$keys[3] => $this->getEstablecimientoId(),
			$keys[4] => $this->getActiva(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = FacultadPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setNombre($value);
				break;
			case 2:
				$this->setNombreLargo($value);
				break;
			case 3:
				$this->setEstablecimientoId($value);
				break;
			case 4:
				$this->setActiva($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = FacultadPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setNombre($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setNombreLargo($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setEstablecimientoId($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setActiva($arr[$keys[4]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(FacultadPeer::DATABASE_NAME);

		if ($this->isColumnModified(FacultadPeer::ID)) $criteria->add(FacultadPeer::ID, $this->id);
		if ($this->isColumnModified(FacultadPeer::NOMBRE)) $criteria->add(FacultadPeer::NOMBRE, $this->nombre);
		if ($this->isColumnModified(FacultadPeer::NOMBRE_LARGO)) $criteria->add(FacultadPeer::NOMBRE_LARGO, $this->nombre_largo);
		if ($this->isColumnModified(FacultadPeer::ESTABLECIMIENTO_ID)) $criteria->add(FacultadPeer::ESTABLECIMIENTO_ID, $this->establecimiento_id);
		if ($this->isColumnModified(FacultadPeer::ACTIVA)) $criteria->add(FacultadPeer::ACTIVA, $this->activa);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(FacultadPeer::DATABASE_NAME);

		$criteria->add(FacultadPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setNombre($this->nombre);

		$copyObj->setNombreLargo($this->nombre_largo);

		$copyObj->setEstablecimientoId($this->establecimiento_id);

		$copyObj->setActiva($this->activa);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getCarreras() as $relObj) {
				$copyObj->addCarrera($relObj->copy($deepCopy));
			}

			foreach($this->getConcursos() as $relObj) {
				$copyObj->addConcurso($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new FacultadPeer();
		}
		return self::$peer;
	}

	
	public function initCarreras()
	{
		if ($this->collCarreras === null) {
			$this->collCarreras = array();
		}
	}

	
	public function getCarreras($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseCarreraPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCarreras === null) {
			if ($this->isNew()) {
			   $this->collCarreras = array();
			} else {

				$criteria->add(CarreraPeer::CON_FACULTADES_ID, $this->getId());

				CarreraPeer::addSelectColumns($criteria);
				$this->collCarreras = CarreraPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CarreraPeer::CON_FACULTADES_ID, $this->getId());

				CarreraPeer::addSelectColumns($criteria);
				if (!isset($this->lastCarreraCriteria) || !$this->lastCarreraCriteria->equals($criteria)) {
					$this->collCarreras = CarreraPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCarreraCriteria = $criteria;
		return $this->collCarreras;
	}

	
	public function countCarreras($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseCarreraPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(CarreraPeer::CON_FACULTADES_ID, $this->getId());

		return CarreraPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addCarrera(Carrera $l)
	{
		$this->collCarreras[] = $l;
		$l->setFacultad($this);
	}

	
	public function initConcursos()
	{
		if ($this->collConcursos === null) {
			$this->collConcursos = array();
		}
	}

	
	public function getConcursos($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
			   $this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

				ConcursoPeer::addSelectColumns($criteria);
				$this->collConcursos = ConcursoPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

				ConcursoPeer::addSelectColumns($criteria);
				if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
					$this->collConcursos = ConcursoPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConcursoCriteria = $criteria;
		return $this->collConcursos;
	}

	
	public function countConcursos($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

		return ConcursoPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConcurso(Concurso $l)
	{
		$this->collConcursos[] = $l;
		$l->setFacultad($this);
	}


	
	public function getConcursosJoinCarrera($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinCarrera($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinCarrera($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinSede($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinSede($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinSede($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinMateria($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinMateria($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinMateria($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinDedicacion($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinDedicacion($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinDedicacion($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinCargo($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinCargo($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinCargo($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinCarreraMateria($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinCarreraMateria($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinCarreraMateria($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinResolucion($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinResolucion($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinResolucion($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinEstado($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinEstado($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinEstado($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinResultado($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinResultado($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_FACULTADES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinResultado($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseFacultad:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseFacultad::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 