<?php


abstract class BaseHistorico extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $con_concursos_id;


	
	protected $con_estados_type_id;


	
	protected $fecha_inicio_date;


	
	protected $fecha_fin_date;


	
	protected $observacion;


	
	protected $id;

	
	protected $aConcurso;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getConConcursosId()
	{

		return $this->con_concursos_id;
	}

	
	public function getConEstadosTypeId()
	{

		return $this->con_estados_type_id;
	}

	
	public function getFechaInicioDate($format = '%d/%m/%Y')
	{

		if ($this->fecha_inicio_date === null || $this->fecha_inicio_date === '') {
			return null;
		} elseif (!is_int($this->fecha_inicio_date)) {
						$ts = strtotime($this->fecha_inicio_date);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha_inicio_date] as date/time value: " . var_export($this->fecha_inicio_date, true));
			}
		} else {
			$ts = $this->fecha_inicio_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getFechaFinDate($format = '%d/%m/%Y')
	{

		if ($this->fecha_fin_date === null || $this->fecha_fin_date === '') {
			return null;
		} elseif (!is_int($this->fecha_fin_date)) {
						$ts = strtotime($this->fecha_fin_date);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha_fin_date] as date/time value: " . var_export($this->fecha_fin_date, true));
			}
		} else {
			$ts = $this->fecha_fin_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getObservacion()
	{

		return $this->observacion;
	}

	
	public function getId()
	{

		return $this->id;
	}

	
	public function setConConcursosId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_concursos_id !== $v) {
			$this->con_concursos_id = $v;
			$this->modifiedColumns[] = HistoricoPeer::CON_CONCURSOS_ID;
		}

		if ($this->aConcurso !== null && $this->aConcurso->getId() !== $v) {
			$this->aConcurso = null;
		}

	} 
	
	public function setConEstadosTypeId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_estados_type_id !== $v) {
			$this->con_estados_type_id = $v;
			$this->modifiedColumns[] = HistoricoPeer::CON_ESTADOS_TYPE_ID;
		}

	} 
	
	public function setFechaInicioDate($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha_inicio_date] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha_inicio_date !== $ts) {
			$this->fecha_inicio_date = $ts;
			$this->modifiedColumns[] = HistoricoPeer::FECHA_INICIO_DATE;
		}

	} 
	
	public function setFechaFinDate($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha_fin_date] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha_fin_date !== $ts) {
			$this->fecha_fin_date = $ts;
			$this->modifiedColumns[] = HistoricoPeer::FECHA_FIN_DATE;
		}

	} 
	
	public function setObservacion($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->observacion !== $v) {
			$this->observacion = $v;
			$this->modifiedColumns[] = HistoricoPeer::OBSERVACION;
		}

	} 
	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = HistoricoPeer::ID;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->con_concursos_id = $rs->getInt($startcol + 0);

			$this->con_estados_type_id = $rs->getInt($startcol + 1);

			$this->fecha_inicio_date = $rs->getDate($startcol + 2, null);

			$this->fecha_fin_date = $rs->getDate($startcol + 3, null);

			$this->observacion = $rs->getInt($startcol + 4);

			$this->id = $rs->getInt($startcol + 5);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 6; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Historico object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseHistorico:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(HistoricoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			HistoricoPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseHistorico:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseHistorico:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(HistoricoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseHistorico:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aConcurso !== null) {
				if ($this->aConcurso->isModified()) {
					$affectedRows += $this->aConcurso->save($con);
				}
				$this->setConcurso($this->aConcurso);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = HistoricoPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += HistoricoPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aConcurso !== null) {
				if (!$this->aConcurso->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aConcurso->getValidationFailures());
				}
			}


			if (($retval = HistoricoPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = HistoricoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getConConcursosId();
				break;
			case 1:
				return $this->getConEstadosTypeId();
				break;
			case 2:
				return $this->getFechaInicioDate();
				break;
			case 3:
				return $this->getFechaFinDate();
				break;
			case 4:
				return $this->getObservacion();
				break;
			case 5:
				return $this->getId();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = HistoricoPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getConConcursosId(),
			$keys[1] => $this->getConEstadosTypeId(),
			$keys[2] => $this->getFechaInicioDate(),
			$keys[3] => $this->getFechaFinDate(),
			$keys[4] => $this->getObservacion(),
			$keys[5] => $this->getId(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = HistoricoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setConConcursosId($value);
				break;
			case 1:
				$this->setConEstadosTypeId($value);
				break;
			case 2:
				$this->setFechaInicioDate($value);
				break;
			case 3:
				$this->setFechaFinDate($value);
				break;
			case 4:
				$this->setObservacion($value);
				break;
			case 5:
				$this->setId($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = HistoricoPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setConConcursosId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setConEstadosTypeId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setFechaInicioDate($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setFechaFinDate($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setObservacion($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setId($arr[$keys[5]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(HistoricoPeer::DATABASE_NAME);

		if ($this->isColumnModified(HistoricoPeer::CON_CONCURSOS_ID)) $criteria->add(HistoricoPeer::CON_CONCURSOS_ID, $this->con_concursos_id);
		if ($this->isColumnModified(HistoricoPeer::CON_ESTADOS_TYPE_ID)) $criteria->add(HistoricoPeer::CON_ESTADOS_TYPE_ID, $this->con_estados_type_id);
		if ($this->isColumnModified(HistoricoPeer::FECHA_INICIO_DATE)) $criteria->add(HistoricoPeer::FECHA_INICIO_DATE, $this->fecha_inicio_date);
		if ($this->isColumnModified(HistoricoPeer::FECHA_FIN_DATE)) $criteria->add(HistoricoPeer::FECHA_FIN_DATE, $this->fecha_fin_date);
		if ($this->isColumnModified(HistoricoPeer::OBSERVACION)) $criteria->add(HistoricoPeer::OBSERVACION, $this->observacion);
		if ($this->isColumnModified(HistoricoPeer::ID)) $criteria->add(HistoricoPeer::ID, $this->id);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(HistoricoPeer::DATABASE_NAME);

		$criteria->add(HistoricoPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setConConcursosId($this->con_concursos_id);

		$copyObj->setConEstadosTypeId($this->con_estados_type_id);

		$copyObj->setFechaInicioDate($this->fecha_inicio_date);

		$copyObj->setFechaFinDate($this->fecha_fin_date);

		$copyObj->setObservacion($this->observacion);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new HistoricoPeer();
		}
		return self::$peer;
	}

	
	public function setConcurso($v)
	{


		if ($v === null) {
			$this->setConConcursosId(NULL);
		} else {
			$this->setConConcursosId($v->getId());
		}


		$this->aConcurso = $v;
	}


	
	public function getConcurso($con = null)
	{
		if ($this->aConcurso === null && ($this->con_concursos_id !== null)) {
						include_once 'lib/model/om/BaseConcursoPeer.php';

			$this->aConcurso = ConcursoPeer::retrieveByPK($this->con_concursos_id, $con);

			
		}
		return $this->aConcurso;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseHistorico:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseHistorico::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 