<?php


abstract class BaseJurado extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $nombre;


	
	protected $apellido;


	
	protected $direccion;


	
	protected $dni;


	
	protected $telefono;


	
	protected $email;


	
	protected $lugar_nac;


	
	protected $fecha_nac;


	
	protected $nacionalidad;


	
	protected $estado_civil;


	
	protected $claustro;


	
	protected $universidad;


	
	protected $facultad;


	
	protected $carrera;


	
	protected $cargo;


	
	protected $catedra;


	
	protected $habilitado = true;

	
	protected $collConcursoJurados;

	
	protected $lastConcursoJuradoCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getNombre()
	{

		return $this->nombre;
	}

	
	public function getApellido()
	{

		return $this->apellido;
	}

	
	public function getDireccion()
	{

		return $this->direccion;
	}

	
	public function getDni()
	{

		return $this->dni;
	}

	
	public function getTelefono()
	{

		return $this->telefono;
	}

	
	public function getEmail()
	{

		return $this->email;
	}

	
	public function getLugarNac()
	{

		return $this->lugar_nac;
	}

	
	public function getFechaNac($format = '%d/%m/%Y')
	{

		if ($this->fecha_nac === null || $this->fecha_nac === '') {
			return null;
		} elseif (!is_int($this->fecha_nac)) {
						$ts = strtotime($this->fecha_nac);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha_nac] as date/time value: " . var_export($this->fecha_nac, true));
			}
		} else {
			$ts = $this->fecha_nac;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getNacionalidad()
	{

		return $this->nacionalidad;
	}

	
	public function getEstadoCivil()
	{

		return $this->estado_civil;
	}

	
	public function getClaustro()
	{

		return $this->claustro;
	}

	
	public function getUniversidad()
	{

		return $this->universidad;
	}

	
	public function getFacultad()
	{

		return $this->facultad;
	}

	
	public function getCarrera()
	{

		return $this->carrera;
	}

	
	public function getCargo()
	{

		return $this->cargo;
	}

	
	public function getCatedra()
	{

		return $this->catedra;
	}

	
	public function getHabilitado()
	{

		return $this->habilitado;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = JuradoPeer::ID;
		}

	} 
	
	public function setNombre($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nombre !== $v) {
			$this->nombre = $v;
			$this->modifiedColumns[] = JuradoPeer::NOMBRE;
		}

	} 
	
	public function setApellido($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->apellido !== $v) {
			$this->apellido = $v;
			$this->modifiedColumns[] = JuradoPeer::APELLIDO;
		}

	} 
	
	public function setDireccion($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->direccion !== $v) {
			$this->direccion = $v;
			$this->modifiedColumns[] = JuradoPeer::DIRECCION;
		}

	} 
	
	public function setDni($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->dni !== $v) {
			$this->dni = $v;
			$this->modifiedColumns[] = JuradoPeer::DNI;
		}

	} 
	
	public function setTelefono($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->telefono !== $v) {
			$this->telefono = $v;
			$this->modifiedColumns[] = JuradoPeer::TELEFONO;
		}

	} 
	
	public function setEmail($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->email !== $v) {
			$this->email = $v;
			$this->modifiedColumns[] = JuradoPeer::EMAIL;
		}

	} 
	
	public function setLugarNac($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->lugar_nac !== $v) {
			$this->lugar_nac = $v;
			$this->modifiedColumns[] = JuradoPeer::LUGAR_NAC;
		}

	} 
	
	public function setFechaNac($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha_nac] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha_nac !== $ts) {
			$this->fecha_nac = $ts;
			$this->modifiedColumns[] = JuradoPeer::FECHA_NAC;
		}

	} 
	
	public function setNacionalidad($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nacionalidad !== $v) {
			$this->nacionalidad = $v;
			$this->modifiedColumns[] = JuradoPeer::NACIONALIDAD;
		}

	} 
	
	public function setEstadoCivil($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->estado_civil !== $v) {
			$this->estado_civil = $v;
			$this->modifiedColumns[] = JuradoPeer::ESTADO_CIVIL;
		}

	} 
	
	public function setClaustro($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->claustro !== $v) {
			$this->claustro = $v;
			$this->modifiedColumns[] = JuradoPeer::CLAUSTRO;
		}

	} 
	
	public function setUniversidad($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->universidad !== $v) {
			$this->universidad = $v;
			$this->modifiedColumns[] = JuradoPeer::UNIVERSIDAD;
		}

	} 
	
	public function setFacultad($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->facultad !== $v) {
			$this->facultad = $v;
			$this->modifiedColumns[] = JuradoPeer::FACULTAD;
		}

	} 
	
	public function setCarrera($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->carrera !== $v) {
			$this->carrera = $v;
			$this->modifiedColumns[] = JuradoPeer::CARRERA;
		}

	} 
	
	public function setCargo($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->cargo !== $v) {
			$this->cargo = $v;
			$this->modifiedColumns[] = JuradoPeer::CARGO;
		}

	} 
	
	public function setCatedra($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->catedra !== $v) {
			$this->catedra = $v;
			$this->modifiedColumns[] = JuradoPeer::CATEDRA;
		}

	} 
	
	public function setHabilitado($v)
	{

		if ($this->habilitado !== $v || $v === true) {
			$this->habilitado = $v;
			$this->modifiedColumns[] = JuradoPeer::HABILITADO;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->nombre = $rs->getString($startcol + 1);

			$this->apellido = $rs->getString($startcol + 2);

			$this->direccion = $rs->getString($startcol + 3);

			$this->dni = $rs->getString($startcol + 4);

			$this->telefono = $rs->getString($startcol + 5);

			$this->email = $rs->getString($startcol + 6);

			$this->lugar_nac = $rs->getString($startcol + 7);

			$this->fecha_nac = $rs->getDate($startcol + 8, null);

			$this->nacionalidad = $rs->getString($startcol + 9);

			$this->estado_civil = $rs->getString($startcol + 10);

			$this->claustro = $rs->getString($startcol + 11);

			$this->universidad = $rs->getString($startcol + 12);

			$this->facultad = $rs->getString($startcol + 13);

			$this->carrera = $rs->getString($startcol + 14);

			$this->cargo = $rs->getString($startcol + 15);

			$this->catedra = $rs->getString($startcol + 16);

			$this->habilitado = $rs->getBoolean($startcol + 17);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 18; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Jurado object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseJurado:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(JuradoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			JuradoPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseJurado:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseJurado:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(JuradoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseJurado:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = JuradoPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += JuradoPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collConcursoJurados !== null) {
				foreach($this->collConcursoJurados as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = JuradoPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collConcursoJurados !== null) {
					foreach($this->collConcursoJurados as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = JuradoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getNombre();
				break;
			case 2:
				return $this->getApellido();
				break;
			case 3:
				return $this->getDireccion();
				break;
			case 4:
				return $this->getDni();
				break;
			case 5:
				return $this->getTelefono();
				break;
			case 6:
				return $this->getEmail();
				break;
			case 7:
				return $this->getLugarNac();
				break;
			case 8:
				return $this->getFechaNac();
				break;
			case 9:
				return $this->getNacionalidad();
				break;
			case 10:
				return $this->getEstadoCivil();
				break;
			case 11:
				return $this->getClaustro();
				break;
			case 12:
				return $this->getUniversidad();
				break;
			case 13:
				return $this->getFacultad();
				break;
			case 14:
				return $this->getCarrera();
				break;
			case 15:
				return $this->getCargo();
				break;
			case 16:
				return $this->getCatedra();
				break;
			case 17:
				return $this->getHabilitado();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = JuradoPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getNombre(),
			$keys[2] => $this->getApellido(),
			$keys[3] => $this->getDireccion(),
			$keys[4] => $this->getDni(),
			$keys[5] => $this->getTelefono(),
			$keys[6] => $this->getEmail(),
			$keys[7] => $this->getLugarNac(),
			$keys[8] => $this->getFechaNac(),
			$keys[9] => $this->getNacionalidad(),
			$keys[10] => $this->getEstadoCivil(),
			$keys[11] => $this->getClaustro(),
			$keys[12] => $this->getUniversidad(),
			$keys[13] => $this->getFacultad(),
			$keys[14] => $this->getCarrera(),
			$keys[15] => $this->getCargo(),
			$keys[16] => $this->getCatedra(),
			$keys[17] => $this->getHabilitado(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = JuradoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setNombre($value);
				break;
			case 2:
				$this->setApellido($value);
				break;
			case 3:
				$this->setDireccion($value);
				break;
			case 4:
				$this->setDni($value);
				break;
			case 5:
				$this->setTelefono($value);
				break;
			case 6:
				$this->setEmail($value);
				break;
			case 7:
				$this->setLugarNac($value);
				break;
			case 8:
				$this->setFechaNac($value);
				break;
			case 9:
				$this->setNacionalidad($value);
				break;
			case 10:
				$this->setEstadoCivil($value);
				break;
			case 11:
				$this->setClaustro($value);
				break;
			case 12:
				$this->setUniversidad($value);
				break;
			case 13:
				$this->setFacultad($value);
				break;
			case 14:
				$this->setCarrera($value);
				break;
			case 15:
				$this->setCargo($value);
				break;
			case 16:
				$this->setCatedra($value);
				break;
			case 17:
				$this->setHabilitado($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = JuradoPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setNombre($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setApellido($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setDireccion($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setDni($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setTelefono($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setEmail($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setLugarNac($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setFechaNac($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setNacionalidad($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setEstadoCivil($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setClaustro($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setUniversidad($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setFacultad($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setCarrera($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setCargo($arr[$keys[15]]);
		if (array_key_exists($keys[16], $arr)) $this->setCatedra($arr[$keys[16]]);
		if (array_key_exists($keys[17], $arr)) $this->setHabilitado($arr[$keys[17]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(JuradoPeer::DATABASE_NAME);

		if ($this->isColumnModified(JuradoPeer::ID)) $criteria->add(JuradoPeer::ID, $this->id);
		if ($this->isColumnModified(JuradoPeer::NOMBRE)) $criteria->add(JuradoPeer::NOMBRE, $this->nombre);
		if ($this->isColumnModified(JuradoPeer::APELLIDO)) $criteria->add(JuradoPeer::APELLIDO, $this->apellido);
		if ($this->isColumnModified(JuradoPeer::DIRECCION)) $criteria->add(JuradoPeer::DIRECCION, $this->direccion);
		if ($this->isColumnModified(JuradoPeer::DNI)) $criteria->add(JuradoPeer::DNI, $this->dni);
		if ($this->isColumnModified(JuradoPeer::TELEFONO)) $criteria->add(JuradoPeer::TELEFONO, $this->telefono);
		if ($this->isColumnModified(JuradoPeer::EMAIL)) $criteria->add(JuradoPeer::EMAIL, $this->email);
		if ($this->isColumnModified(JuradoPeer::LUGAR_NAC)) $criteria->add(JuradoPeer::LUGAR_NAC, $this->lugar_nac);
		if ($this->isColumnModified(JuradoPeer::FECHA_NAC)) $criteria->add(JuradoPeer::FECHA_NAC, $this->fecha_nac);
		if ($this->isColumnModified(JuradoPeer::NACIONALIDAD)) $criteria->add(JuradoPeer::NACIONALIDAD, $this->nacionalidad);
		if ($this->isColumnModified(JuradoPeer::ESTADO_CIVIL)) $criteria->add(JuradoPeer::ESTADO_CIVIL, $this->estado_civil);
		if ($this->isColumnModified(JuradoPeer::CLAUSTRO)) $criteria->add(JuradoPeer::CLAUSTRO, $this->claustro);
		if ($this->isColumnModified(JuradoPeer::UNIVERSIDAD)) $criteria->add(JuradoPeer::UNIVERSIDAD, $this->universidad);
		if ($this->isColumnModified(JuradoPeer::FACULTAD)) $criteria->add(JuradoPeer::FACULTAD, $this->facultad);
		if ($this->isColumnModified(JuradoPeer::CARRERA)) $criteria->add(JuradoPeer::CARRERA, $this->carrera);
		if ($this->isColumnModified(JuradoPeer::CARGO)) $criteria->add(JuradoPeer::CARGO, $this->cargo);
		if ($this->isColumnModified(JuradoPeer::CATEDRA)) $criteria->add(JuradoPeer::CATEDRA, $this->catedra);
		if ($this->isColumnModified(JuradoPeer::HABILITADO)) $criteria->add(JuradoPeer::HABILITADO, $this->habilitado);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(JuradoPeer::DATABASE_NAME);

		$criteria->add(JuradoPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setNombre($this->nombre);

		$copyObj->setApellido($this->apellido);

		$copyObj->setDireccion($this->direccion);

		$copyObj->setDni($this->dni);

		$copyObj->setTelefono($this->telefono);

		$copyObj->setEmail($this->email);

		$copyObj->setLugarNac($this->lugar_nac);

		$copyObj->setFechaNac($this->fecha_nac);

		$copyObj->setNacionalidad($this->nacionalidad);

		$copyObj->setEstadoCivil($this->estado_civil);

		$copyObj->setClaustro($this->claustro);

		$copyObj->setUniversidad($this->universidad);

		$copyObj->setFacultad($this->facultad);

		$copyObj->setCarrera($this->carrera);

		$copyObj->setCargo($this->cargo);

		$copyObj->setCatedra($this->catedra);

		$copyObj->setHabilitado($this->habilitado);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getConcursoJurados() as $relObj) {
				$copyObj->addConcursoJurado($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new JuradoPeer();
		}
		return self::$peer;
	}

	
	public function initConcursoJurados()
	{
		if ($this->collConcursoJurados === null) {
			$this->collConcursoJurados = array();
		}
	}

	
	public function getConcursoJurados($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoJuradoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoJurados === null) {
			if ($this->isNew()) {
			   $this->collConcursoJurados = array();
			} else {

				$criteria->add(ConcursoJuradoPeer::CON_JURADOS_ID, $this->getId());

				ConcursoJuradoPeer::addSelectColumns($criteria);
				$this->collConcursoJurados = ConcursoJuradoPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConcursoJuradoPeer::CON_JURADOS_ID, $this->getId());

				ConcursoJuradoPeer::addSelectColumns($criteria);
				if (!isset($this->lastConcursoJuradoCriteria) || !$this->lastConcursoJuradoCriteria->equals($criteria)) {
					$this->collConcursoJurados = ConcursoJuradoPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConcursoJuradoCriteria = $criteria;
		return $this->collConcursoJurados;
	}

	
	public function countConcursoJurados($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoJuradoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConcursoJuradoPeer::CON_JURADOS_ID, $this->getId());

		return ConcursoJuradoPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConcursoJurado(ConcursoJurado $l)
	{
		$this->collConcursoJurados[] = $l;
		$l->setJurado($this);
	}


	
	public function getConcursoJuradosJoinConcurso($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoJuradoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursoJurados === null) {
			if ($this->isNew()) {
				$this->collConcursoJurados = array();
			} else {

				$criteria->add(ConcursoJuradoPeer::CON_JURADOS_ID, $this->getId());

				$this->collConcursoJurados = ConcursoJuradoPeer::doSelectJoinConcurso($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoJuradoPeer::CON_JURADOS_ID, $this->getId());

			if (!isset($this->lastConcursoJuradoCriteria) || !$this->lastConcursoJuradoCriteria->equals($criteria)) {
				$this->collConcursoJurados = ConcursoJuradoPeer::doSelectJoinConcurso($criteria, $con);
			}
		}
		$this->lastConcursoJuradoCriteria = $criteria;

		return $this->collConcursoJurados;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseJurado:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseJurado::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 