<?php


abstract class BaseLocalidad extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $nombre;


	
	protected $con_provincias_id;


	
	protected $cod_postal;

	
	protected $aProvincia;

	
	protected $collSedes;

	
	protected $lastSedeCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getNombre()
	{

		return $this->nombre;
	}

	
	public function getConProvinciasId()
	{

		return $this->con_provincias_id;
	}

	
	public function getCodPostal()
	{

		return $this->cod_postal;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = LocalidadPeer::ID;
		}

	} 
	
	public function setNombre($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nombre !== $v) {
			$this->nombre = $v;
			$this->modifiedColumns[] = LocalidadPeer::NOMBRE;
		}

	} 
	
	public function setConProvinciasId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_provincias_id !== $v) {
			$this->con_provincias_id = $v;
			$this->modifiedColumns[] = LocalidadPeer::CON_PROVINCIAS_ID;
		}

		if ($this->aProvincia !== null && $this->aProvincia->getId() !== $v) {
			$this->aProvincia = null;
		}

	} 
	
	public function setCodPostal($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->cod_postal !== $v) {
			$this->cod_postal = $v;
			$this->modifiedColumns[] = LocalidadPeer::COD_POSTAL;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->nombre = $rs->getString($startcol + 1);

			$this->con_provincias_id = $rs->getInt($startcol + 2);

			$this->cod_postal = $rs->getString($startcol + 3);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 4; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Localidad object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseLocalidad:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(LocalidadPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			LocalidadPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseLocalidad:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseLocalidad:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(LocalidadPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseLocalidad:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aProvincia !== null) {
				if ($this->aProvincia->isModified()) {
					$affectedRows += $this->aProvincia->save($con);
				}
				$this->setProvincia($this->aProvincia);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = LocalidadPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += LocalidadPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collSedes !== null) {
				foreach($this->collSedes as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aProvincia !== null) {
				if (!$this->aProvincia->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aProvincia->getValidationFailures());
				}
			}


			if (($retval = LocalidadPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collSedes !== null) {
					foreach($this->collSedes as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = LocalidadPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getNombre();
				break;
			case 2:
				return $this->getConProvinciasId();
				break;
			case 3:
				return $this->getCodPostal();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = LocalidadPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getNombre(),
			$keys[2] => $this->getConProvinciasId(),
			$keys[3] => $this->getCodPostal(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = LocalidadPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setNombre($value);
				break;
			case 2:
				$this->setConProvinciasId($value);
				break;
			case 3:
				$this->setCodPostal($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = LocalidadPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setNombre($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setConProvinciasId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setCodPostal($arr[$keys[3]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(LocalidadPeer::DATABASE_NAME);

		if ($this->isColumnModified(LocalidadPeer::ID)) $criteria->add(LocalidadPeer::ID, $this->id);
		if ($this->isColumnModified(LocalidadPeer::NOMBRE)) $criteria->add(LocalidadPeer::NOMBRE, $this->nombre);
		if ($this->isColumnModified(LocalidadPeer::CON_PROVINCIAS_ID)) $criteria->add(LocalidadPeer::CON_PROVINCIAS_ID, $this->con_provincias_id);
		if ($this->isColumnModified(LocalidadPeer::COD_POSTAL)) $criteria->add(LocalidadPeer::COD_POSTAL, $this->cod_postal);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(LocalidadPeer::DATABASE_NAME);

		$criteria->add(LocalidadPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setNombre($this->nombre);

		$copyObj->setConProvinciasId($this->con_provincias_id);

		$copyObj->setCodPostal($this->cod_postal);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getSedes() as $relObj) {
				$copyObj->addSede($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new LocalidadPeer();
		}
		return self::$peer;
	}

	
	public function setProvincia($v)
	{


		if ($v === null) {
			$this->setConProvinciasId(NULL);
		} else {
			$this->setConProvinciasId($v->getId());
		}


		$this->aProvincia = $v;
	}


	
	public function getProvincia($con = null)
	{
		if ($this->aProvincia === null && ($this->con_provincias_id !== null)) {
						include_once 'lib/model/om/BaseProvinciaPeer.php';

			$this->aProvincia = ProvinciaPeer::retrieveByPK($this->con_provincias_id, $con);

			
		}
		return $this->aProvincia;
	}

	
	public function initSedes()
	{
		if ($this->collSedes === null) {
			$this->collSedes = array();
		}
	}

	
	public function getSedes($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseSedePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSedes === null) {
			if ($this->isNew()) {
			   $this->collSedes = array();
			} else {

				$criteria->add(SedePeer::CON_LOCALIDADES_ID, $this->getId());

				SedePeer::addSelectColumns($criteria);
				$this->collSedes = SedePeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(SedePeer::CON_LOCALIDADES_ID, $this->getId());

				SedePeer::addSelectColumns($criteria);
				if (!isset($this->lastSedeCriteria) || !$this->lastSedeCriteria->equals($criteria)) {
					$this->collSedes = SedePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastSedeCriteria = $criteria;
		return $this->collSedes;
	}

	
	public function countSedes($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseSedePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(SedePeer::CON_LOCALIDADES_ID, $this->getId());

		return SedePeer::doCount($criteria, $distinct, $con);
	}

	
	public function addSede(Sede $l)
	{
		$this->collSedes[] = $l;
		$l->setLocalidad($this);
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseLocalidad:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseLocalidad::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 