<?php


abstract class BasePlanEstudio extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $con_materias_id;


	
	protected $con_carreras_id;


	
	protected $plan;

	
	protected $aMateria;

	
	protected $aCarrera;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getConMateriasId()
	{

		return $this->con_materias_id;
	}

	
	public function getConCarrerasId()
	{

		return $this->con_carreras_id;
	}

	
	public function getPlan()
	{

		return $this->plan;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = PlanEstudioPeer::ID;
		}

	} 
	
	public function setConMateriasId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_materias_id !== $v) {
			$this->con_materias_id = $v;
			$this->modifiedColumns[] = PlanEstudioPeer::CON_MATERIAS_ID;
		}

		if ($this->aMateria !== null && $this->aMateria->getId() !== $v) {
			$this->aMateria = null;
		}

	} 
	
	public function setConCarrerasId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_carreras_id !== $v) {
			$this->con_carreras_id = $v;
			$this->modifiedColumns[] = PlanEstudioPeer::CON_CARRERAS_ID;
		}

		if ($this->aCarrera !== null && $this->aCarrera->getId() !== $v) {
			$this->aCarrera = null;
		}

	} 
	
	public function setPlan($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->plan !== $v) {
			$this->plan = $v;
			$this->modifiedColumns[] = PlanEstudioPeer::PLAN;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->con_materias_id = $rs->getInt($startcol + 1);

			$this->con_carreras_id = $rs->getInt($startcol + 2);

			$this->plan = $rs->getInt($startcol + 3);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 4; 
		} catch (Exception $e) {
			throw new PropelException("Error populating PlanEstudio object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BasePlanEstudio:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(PlanEstudioPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			PlanEstudioPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BasePlanEstudio:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BasePlanEstudio:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(PlanEstudioPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BasePlanEstudio:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aMateria !== null) {
				if ($this->aMateria->isModified()) {
					$affectedRows += $this->aMateria->save($con);
				}
				$this->setMateria($this->aMateria);
			}

			if ($this->aCarrera !== null) {
				if ($this->aCarrera->isModified()) {
					$affectedRows += $this->aCarrera->save($con);
				}
				$this->setCarrera($this->aCarrera);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = PlanEstudioPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += PlanEstudioPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aMateria !== null) {
				if (!$this->aMateria->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aMateria->getValidationFailures());
				}
			}

			if ($this->aCarrera !== null) {
				if (!$this->aCarrera->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aCarrera->getValidationFailures());
				}
			}


			if (($retval = PlanEstudioPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = PlanEstudioPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getConMateriasId();
				break;
			case 2:
				return $this->getConCarrerasId();
				break;
			case 3:
				return $this->getPlan();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = PlanEstudioPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getConMateriasId(),
			$keys[2] => $this->getConCarrerasId(),
			$keys[3] => $this->getPlan(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = PlanEstudioPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setConMateriasId($value);
				break;
			case 2:
				$this->setConCarrerasId($value);
				break;
			case 3:
				$this->setPlan($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = PlanEstudioPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setConMateriasId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setConCarrerasId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setPlan($arr[$keys[3]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(PlanEstudioPeer::DATABASE_NAME);

		if ($this->isColumnModified(PlanEstudioPeer::ID)) $criteria->add(PlanEstudioPeer::ID, $this->id);
		if ($this->isColumnModified(PlanEstudioPeer::CON_MATERIAS_ID)) $criteria->add(PlanEstudioPeer::CON_MATERIAS_ID, $this->con_materias_id);
		if ($this->isColumnModified(PlanEstudioPeer::CON_CARRERAS_ID)) $criteria->add(PlanEstudioPeer::CON_CARRERAS_ID, $this->con_carreras_id);
		if ($this->isColumnModified(PlanEstudioPeer::PLAN)) $criteria->add(PlanEstudioPeer::PLAN, $this->plan);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(PlanEstudioPeer::DATABASE_NAME);

		$criteria->add(PlanEstudioPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setConMateriasId($this->con_materias_id);

		$copyObj->setConCarrerasId($this->con_carreras_id);

		$copyObj->setPlan($this->plan);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new PlanEstudioPeer();
		}
		return self::$peer;
	}

	
	public function setMateria($v)
	{


		if ($v === null) {
			$this->setConMateriasId(NULL);
		} else {
			$this->setConMateriasId($v->getId());
		}


		$this->aMateria = $v;
	}


	
	public function getMateria($con = null)
	{
		if ($this->aMateria === null && ($this->con_materias_id !== null)) {
						include_once 'lib/model/om/BaseMateriaPeer.php';

			$this->aMateria = MateriaPeer::retrieveByPK($this->con_materias_id, $con);

			
		}
		return $this->aMateria;
	}

	
	public function setCarrera($v)
	{


		if ($v === null) {
			$this->setConCarrerasId(NULL);
		} else {
			$this->setConCarrerasId($v->getId());
		}


		$this->aCarrera = $v;
	}


	
	public function getCarrera($con = null)
	{
		if ($this->aCarrera === null && ($this->con_carreras_id !== null)) {
						include_once 'lib/model/om/BaseCarreraPeer.php';

			$this->aCarrera = CarreraPeer::retrieveByPK($this->con_carreras_id, $con);

			
		}
		return $this->aCarrera;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BasePlanEstudio:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BasePlanEstudio::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 