<?php


abstract class BaseResolucion extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $year;


	
	protected $numero;


	
	protected $fecha;


	
	protected $descripcion;


	
	protected $created_at;


	
	protected $path;

	
	protected $collConcursos;

	
	protected $lastConcursoCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getYear()
	{

		return $this->year;
	}

	
	public function getNumero()
	{

		return $this->numero;
	}

	
	public function getFecha($format = '%d/%m/%Y')
	{

		if ($this->fecha === null || $this->fecha === '') {
			return null;
		} elseif (!is_int($this->fecha)) {
						$ts = strtotime($this->fecha);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha] as date/time value: " . var_export($this->fecha, true));
			}
		} else {
			$ts = $this->fecha;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getDescripcion()
	{

		return $this->descripcion;
	}

	
	public function getCreatedAt($format = 'd/m/Y H:i:s')
	{

		if ($this->created_at === null || $this->created_at === '') {
			return null;
		} elseif (!is_int($this->created_at)) {
						$ts = strtotime($this->created_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [created_at] as date/time value: " . var_export($this->created_at, true));
			}
		} else {
			$ts = $this->created_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getPath()
	{

		return $this->path;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ResolucionPeer::ID;
		}

	} 
	
	public function setYear($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->year !== $v) {
			$this->year = $v;
			$this->modifiedColumns[] = ResolucionPeer::YEAR;
		}

	} 
	
	public function setNumero($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->numero !== $v) {
			$this->numero = $v;
			$this->modifiedColumns[] = ResolucionPeer::NUMERO;
		}

	} 
	
	public function setFecha($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha !== $ts) {
			$this->fecha = $ts;
			$this->modifiedColumns[] = ResolucionPeer::FECHA;
		}

	} 
	
	public function setDescripcion($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->descripcion !== $v) {
			$this->descripcion = $v;
			$this->modifiedColumns[] = ResolucionPeer::DESCRIPCION;
		}

	} 
	
	public function setCreatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [created_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->created_at !== $ts) {
			$this->created_at = $ts;
			$this->modifiedColumns[] = ResolucionPeer::CREATED_AT;
		}

	} 
	
	public function setPath($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->path !== $v) {
			$this->path = $v;
			$this->modifiedColumns[] = ResolucionPeer::PATH;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->year = $rs->getInt($startcol + 1);

			$this->numero = $rs->getInt($startcol + 2);

			$this->fecha = $rs->getDate($startcol + 3, null);

			$this->descripcion = $rs->getString($startcol + 4);

			$this->created_at = $rs->getTimestamp($startcol + 5, null);

			$this->path = $rs->getString($startcol + 6);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 7; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Resolucion object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseResolucion:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ResolucionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			ResolucionPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseResolucion:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseResolucion:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


    if ($this->isNew() && !$this->isColumnModified(ResolucionPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ResolucionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseResolucion:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ResolucionPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ResolucionPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collConcursos !== null) {
				foreach($this->collConcursos as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = ResolucionPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collConcursos !== null) {
					foreach($this->collConcursos as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ResolucionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getYear();
				break;
			case 2:
				return $this->getNumero();
				break;
			case 3:
				return $this->getFecha();
				break;
			case 4:
				return $this->getDescripcion();
				break;
			case 5:
				return $this->getCreatedAt();
				break;
			case 6:
				return $this->getPath();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ResolucionPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getYear(),
			$keys[2] => $this->getNumero(),
			$keys[3] => $this->getFecha(),
			$keys[4] => $this->getDescripcion(),
			$keys[5] => $this->getCreatedAt(),
			$keys[6] => $this->getPath(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ResolucionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setYear($value);
				break;
			case 2:
				$this->setNumero($value);
				break;
			case 3:
				$this->setFecha($value);
				break;
			case 4:
				$this->setDescripcion($value);
				break;
			case 5:
				$this->setCreatedAt($value);
				break;
			case 6:
				$this->setPath($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ResolucionPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setYear($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setNumero($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setFecha($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setDescripcion($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setCreatedAt($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setPath($arr[$keys[6]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ResolucionPeer::DATABASE_NAME);

		if ($this->isColumnModified(ResolucionPeer::ID)) $criteria->add(ResolucionPeer::ID, $this->id);
		if ($this->isColumnModified(ResolucionPeer::YEAR)) $criteria->add(ResolucionPeer::YEAR, $this->year);
		if ($this->isColumnModified(ResolucionPeer::NUMERO)) $criteria->add(ResolucionPeer::NUMERO, $this->numero);
		if ($this->isColumnModified(ResolucionPeer::FECHA)) $criteria->add(ResolucionPeer::FECHA, $this->fecha);
		if ($this->isColumnModified(ResolucionPeer::DESCRIPCION)) $criteria->add(ResolucionPeer::DESCRIPCION, $this->descripcion);
		if ($this->isColumnModified(ResolucionPeer::CREATED_AT)) $criteria->add(ResolucionPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(ResolucionPeer::PATH)) $criteria->add(ResolucionPeer::PATH, $this->path);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ResolucionPeer::DATABASE_NAME);

		$criteria->add(ResolucionPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setYear($this->year);

		$copyObj->setNumero($this->numero);

		$copyObj->setFecha($this->fecha);

		$copyObj->setDescripcion($this->descripcion);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setPath($this->path);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getConcursos() as $relObj) {
				$copyObj->addConcurso($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ResolucionPeer();
		}
		return self::$peer;
	}

	
	public function initConcursos()
	{
		if ($this->collConcursos === null) {
			$this->collConcursos = array();
		}
	}

	
	public function getConcursos($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
			   $this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

				ConcursoPeer::addSelectColumns($criteria);
				$this->collConcursos = ConcursoPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

				ConcursoPeer::addSelectColumns($criteria);
				if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
					$this->collConcursos = ConcursoPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConcursoCriteria = $criteria;
		return $this->collConcursos;
	}

	
	public function countConcursos($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

		return ConcursoPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConcurso(Concurso $l)
	{
		$this->collConcursos[] = $l;
		$l->setResolucion($this);
	}


	
	public function getConcursosJoinCarrera($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinCarrera($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinCarrera($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinSede($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinSede($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinSede($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinFacultad($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinFacultad($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinFacultad($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinMateria($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinMateria($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinMateria($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinDedicacion($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinDedicacion($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinDedicacion($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinCargo($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinCargo($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinCargo($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinCarreraMateria($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinCarreraMateria($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinCarreraMateria($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinEstado($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinEstado($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinEstado($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinResultado($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinResultado($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_RESOLUCION_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinResultado($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseResolucion:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseResolucion::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 