<?php


abstract class BaseSede extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $nombre;


	
	protected $con_localidades_id;

	
	protected $aLocalidad;

	
	protected $collConcursos;

	
	protected $lastConcursoCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getNombre()
	{

		return $this->nombre;
	}

	
	public function getConLocalidadesId()
	{

		return $this->con_localidades_id;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = SedePeer::ID;
		}

	} 
	
	public function setNombre($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nombre !== $v) {
			$this->nombre = $v;
			$this->modifiedColumns[] = SedePeer::NOMBRE;
		}

	} 
	
	public function setConLocalidadesId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_localidades_id !== $v) {
			$this->con_localidades_id = $v;
			$this->modifiedColumns[] = SedePeer::CON_LOCALIDADES_ID;
		}

		if ($this->aLocalidad !== null && $this->aLocalidad->getId() !== $v) {
			$this->aLocalidad = null;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->nombre = $rs->getString($startcol + 1);

			$this->con_localidades_id = $rs->getInt($startcol + 2);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 3; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Sede object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseSede:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SedePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			SedePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseSede:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseSede:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SedePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseSede:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aLocalidad !== null) {
				if ($this->aLocalidad->isModified()) {
					$affectedRows += $this->aLocalidad->save($con);
				}
				$this->setLocalidad($this->aLocalidad);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = SedePeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += SedePeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collConcursos !== null) {
				foreach($this->collConcursos as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aLocalidad !== null) {
				if (!$this->aLocalidad->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aLocalidad->getValidationFailures());
				}
			}


			if (($retval = SedePeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collConcursos !== null) {
					foreach($this->collConcursos as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = SedePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getNombre();
				break;
			case 2:
				return $this->getConLocalidadesId();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = SedePeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getNombre(),
			$keys[2] => $this->getConLocalidadesId(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = SedePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setNombre($value);
				break;
			case 2:
				$this->setConLocalidadesId($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = SedePeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setNombre($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setConLocalidadesId($arr[$keys[2]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(SedePeer::DATABASE_NAME);

		if ($this->isColumnModified(SedePeer::ID)) $criteria->add(SedePeer::ID, $this->id);
		if ($this->isColumnModified(SedePeer::NOMBRE)) $criteria->add(SedePeer::NOMBRE, $this->nombre);
		if ($this->isColumnModified(SedePeer::CON_LOCALIDADES_ID)) $criteria->add(SedePeer::CON_LOCALIDADES_ID, $this->con_localidades_id);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(SedePeer::DATABASE_NAME);

		$criteria->add(SedePeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setNombre($this->nombre);

		$copyObj->setConLocalidadesId($this->con_localidades_id);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getConcursos() as $relObj) {
				$copyObj->addConcurso($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new SedePeer();
		}
		return self::$peer;
	}

	
	public function setLocalidad($v)
	{


		if ($v === null) {
			$this->setConLocalidadesId(NULL);
		} else {
			$this->setConLocalidadesId($v->getId());
		}


		$this->aLocalidad = $v;
	}


	
	public function getLocalidad($con = null)
	{
		if ($this->aLocalidad === null && ($this->con_localidades_id !== null)) {
						include_once 'lib/model/om/BaseLocalidadPeer.php';

			$this->aLocalidad = LocalidadPeer::retrieveByPK($this->con_localidades_id, $con);

			
		}
		return $this->aLocalidad;
	}

	
	public function initConcursos()
	{
		if ($this->collConcursos === null) {
			$this->collConcursos = array();
		}
	}

	
	public function getConcursos($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
			   $this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

				ConcursoPeer::addSelectColumns($criteria);
				$this->collConcursos = ConcursoPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

				ConcursoPeer::addSelectColumns($criteria);
				if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
					$this->collConcursos = ConcursoPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConcursoCriteria = $criteria;
		return $this->collConcursos;
	}

	
	public function countConcursos($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

		return ConcursoPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConcurso(Concurso $l)
	{
		$this->collConcursos[] = $l;
		$l->setSede($this);
	}


	
	public function getConcursosJoinCarrera($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinCarrera($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinCarrera($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinFacultad($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinFacultad($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinFacultad($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinMateria($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinMateria($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinMateria($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinDedicacion($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinDedicacion($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinDedicacion($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinCargo($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinCargo($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinCargo($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinCarreraMateria($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinCarreraMateria($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinCarreraMateria($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinResolucion($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinResolucion($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinResolucion($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinEstado($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinEstado($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinEstado($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


	
	public function getConcursosJoinResultado($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConcursoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConcursos === null) {
			if ($this->isNew()) {
				$this->collConcursos = array();
			} else {

				$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

				$this->collConcursos = ConcursoPeer::doSelectJoinResultado($criteria, $con);
			}
		} else {
									
			$criteria->add(ConcursoPeer::CON_SEDES_ID, $this->getId());

			if (!isset($this->lastConcursoCriteria) || !$this->lastConcursoCriteria->equals($criteria)) {
				$this->collConcursos = ConcursoPeer::doSelectJoinResultado($criteria, $con);
			}
		}
		$this->lastConcursoCriteria = $criteria;

		return $this->collConcursos;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseSede:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseSede::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 