<?php

/*
 * This file is part of the symfony package.
 * (c) 2004-2006 Dustin Whittle <dustin.whittle@symfony-project.com>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

/**
 *
 * sfSwfChart class.
 *
 * This class provides an abstraction layer to the PHP SWF Charts library which provides interactive flash graphs.
 *
 * @package    symfony
 * @subpackage dwSwfChartPlugin
 * @author     Dustin Whittle <dustin.whittle@symfony-project.com>
 * @version    SVN: $Id$
 * @link       http://www.maani.us/charts/
 */

class sfSwfChart
{

  public function convertArray($chart=array())
  {
  	$xml="<chart>\r\n";
  	$keys1= array_keys((array) $chart);
  	for ($i1=0;$i1<count($keys1);$i1++){
  		if(is_array($chart[$keys1[$i1]])){
  			$keys2=array_keys($chart[$keys1[$i1]]);
  			if(is_array($chart[$keys1[$i1]][$keys2[0]])){
  				$xml.="\t<".$keys1[$i1].">\r\n";
  				for($i2=0;$i2<count($keys2);$i2++){
  					$keys3=array_keys((array) $chart[$keys1[$i1]][$keys2[$i2]]);
  					switch($keys1[$i1]){
  						case "chart_data":
  						$xml.="\t\t<row>\r\n";
  						for($i3=0;$i3<count($keys3);$i3++){
  							switch(true){
  								case ($chart[$keys1[$i1]][$keys2[$i2]][$keys3[$i3]]===null):
  								$xml.="\t\t\t<null/>\r\n";
  								break;

  								case ($keys2[$i2]>0 and $keys3[$i3]>0):
  								$xml.="\t\t\t<number>".$chart[$keys1[$i1]][$keys2[$i2]][$keys3[$i3]]."</number>\r\n";
  								break;

  								default:
  								$xml.="\t\t\t<string>".$chart[$keys1[$i1]][$keys2[$i2]][$keys3[$i3]]."</string>\r\n";
  								break;
  							}
  						}
  						$xml.="\t\t</row>\r\n";
  						break;

  						case "chart_value_text":
  						$xml.="\t\t<row>\r\n";
  						$count=0;
  						for($i3=0;$i3<count($keys3);$i3++){
  							if($chart[$keys1[$i1]][$keys2[$i2]][$keys3[$i3]]===null){$xml.="\t\t\t<null/>\r\n";}
  							else{$xml.="\t\t\t<string>".$chart[$keys1[$i1]][$keys2[$i2]][$keys3[$i3]]."</string>\r\n";}
  						}
  						$xml.="\t\t</row>\r\n";
  						break;

  						/*case "link_data_text":
  						$xml.="\t\t<row>\r\n";
  						$count=0;
  						for($i3=0;$i3<count($keys3);$i3++){
  							if($chart[$keys1[$i1]][$keys2[$i2]][$keys3[$i3]]===null){$xml.="\t\t\t<null/>\r\n";}
  							else{$xml.="\t\t\t<string>".$chart[$keys1[$i1]][$keys2[$i2]][$keys3[$i3]]."</string>\r\n";}
  						}
  						$xml.="\t\t</row>\r\n";
  						break;*/

  						case "draw":
  						$text="";
  						$xml.="\t\t<".$chart[$keys1[$i1]][$keys2[$i2]]['type'];
  						for($i3=0;$i3<count($keys3);$i3++){
  							if($keys3[$i3]!="type"){
  								if($keys3[$i3]=="text"){$text=$chart[$keys1[$i1]][$keys2[$i2]][$keys3[$i3]];}
  								else{$xml.=" ".$keys3[$i3]."=\"".$chart[$keys1[$i1]][$keys2[$i2]][$keys3[$i3]]."\"";}
  							}
  						}
  						if($text!=""){$xml.=">".$text."</text>\r\n";}
  						else{$xml.=" />\r\n";}
  						break;


  						default://link, etc.
  						$xml.="\t\t<value";
  						for($i3=0;$i3<count($keys3);$i3++){
  							$xml.=" ".$keys3[$i3]."=\"".$chart[$keys1[$i1]][$keys2[$i2]][$keys3[$i3]]."\"";
  						}
  						$xml.=" />\r\n";
  						break;
  					}
  				}
  				$xml.="\t</".$keys1[$i1].">\r\n";
  			}else{
  				if($keys1[$i1]=="chart_type" or $keys1[$i1]=="series_color" or $keys1[$i1]=="series_image" or $keys1[$i1]=="series_explode" or $keys1[$i1]=="axis_value_text"){
  					$xml.="\t<".$keys1[$i1].">\r\n";
  					for($i2=0;$i2<count($keys2);$i2++){
  						if($chart[$keys1[$i1]][$keys2[$i2]]===null){$xml.="\t\t<null/>\r\n";}
  						else{$xml.="\t\t<value>".$chart[$keys1[$i1]][$keys2[$i2]]."</value>\r\n";}
  					}
  					$xml.="\t</".$keys1[$i1].">\r\n";
  				}else{//axis_category, etc.
  					$xml.="\t<".$keys1[$i1];
  					for($i2=0;$i2<count($keys2);$i2++){
  						$xml.=" ".$keys2[$i2]."=\"".$chart[$keys1[$i1]][$keys2[$i2]]."\"";
  					}
  					$xml.=" />\r\n";
  				}
  			}
  		}else{//chart type, etc.
  			$xml.="\t<".$keys1[$i1].">".$chart[$keys1[$i1]]."</".$keys1[$i1].">\r\n";
  		}
  	}
  	$xml.="</chart>\r\n";
  	return $xml;
  }
}

?>