<?php
class sfPrinterFriendlyFilter extends sfFilter
{
  public function execute($filterChain)
  {
    $request = $this->getContext()->getRequest();

    if( $request->hasParameter('printer_friendly') )
    {
      $response = $this->getContext()->getResponse();
      
      $params = $response->getParameterHolder();
      
      // Remove all existing stylesheets
      $stylesheets = $response->getStylesheets();
      foreach($stylesheets AS $stylesheet => $options)
      {
        $params->remove($stylesheet, 'helper/asset/auto/stylesheet');
      }

      // Add printer friendly stylesheets and javascript

      $response->addStylesheet('/sfPrinterFriendlyPlugin/css/printer_friendly', 'last', array('media' => 'print'));
      $response->addStylesheet('/sfPrinterFriendlyPlugin/css/printer_friendly', 'last');
      $response->addStylesheet('printer_friendly', 'last', array('media' => 'print'));
      $response->addStylesheet('printer_friendly', 'last');
    }

    $filterChain->execute();
  }
}
